/* 
======================================================================
 
Now for the boxer demo...
 
boxer.c
 
======================================================================
*/
  
/*
 * Program to randomly place boxes on the screen.
 */
 
int minx;
int maxx;
int miny;
int maxy;

#define MAXWIDTH   100          /* Maximum box width */
#define MAXHEIGHT  100          /* Maximum box height */
#define NOBOXES  50000          /* Number of boxs to draw */
 
#define cardBase        (int *)0xf5000000
#define screenstart     (int *)0xf5000100
#define screenend       (int *)0xf5032900
#define videoOn         (int *)0xf5040004
#define Page_0_Reg      (int *)0xf5040008
#define SCREENWIDTHWORDS 64
 
static int screenmasks[32] = {0x80, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc, 0xfe, 0xff,
0x80ff, 0xc0ff, 0xe0ff, 0xf0ff, 0xf8ff, 0xfcff, 0xfeff, 0xffff,
0x80ffff, 0xc0ffff, 0xe0ffff, 0xf0ffff, 0xf8ffff, 0xfcffff, 0xfeffff, 0xffffff,
0x80ffffff, 0xc0ffffff, 0xe0ffffff, 0xf0ffffff, 0xf8ffffff, 0xfcffffff,
0xfeffffff, 0xffffffff};

#define NMASKS 8

int masks[NMASKS][32];

void initmasks()
{
	int i;
	for (i=0; i<32; i++) masks[0][i] = -1;
	
	for (i=0; i<32; i++) masks[0][i] = -1;
	
	for (i=0; i<32; i += 2) masks[1][i] = 0xaaaaaaaa;
	for (i=1; i<32; i += 2) masks[1][i] = 0x55555555;
	
	for (i=0; i<32; i += 4) masks[2][i] = 0x88888888;
	for (i=1; i<32; i += 4) masks[2][i] = 0x22222222;
	for (i=2; i<32; i += 4) masks[2][i] = 0x44444444;
	for (i=3; i<32; i += 4) masks[2][i] = 0x11111111;

	for (i=0; i<32; i += 8) masks[3][i] = 0x99999999;
	for (i=1; i<32; i += 8) masks[3][i] = 0x22222222;
	for (i=2; i<32; i += 8) masks[3][i] = 0x55555555;
	for (i=3; i<32; i += 8) masks[3][i] = 0x88888888;
	for (i=4; i<32; i += 8) masks[3][i] = 0xaaaaaaaa;
	for (i=5; i<32; i += 8) masks[3][i] = 0x44444444;
	for (i=6; i<32; i += 8) masks[3][i] = 0x99999999;
	for (i=7; i<32; i += 8) masks[3][i] = 0x11111111;

	for (i=0; i<32; i += 8) masks[4][i] = 0x40404040;
	for (i=1; i<32; i += 8) masks[4][i] = 0x02020202;
	for (i=2; i<32; i += 8) masks[4][i] = 0x80808080;
	for (i=3; i<32; i += 8) masks[4][i] = 0x04040404;
	for (i=4; i<32; i += 8) masks[4][i] = 0x10101010;
	for (i=5; i<32; i += 8) masks[4][i] = 0x01010101;
	for (i=6; i<32; i += 8) masks[4][i] = 0x08080808;
	for (i=7; i<32; i += 8) masks[4][i] = 0x20202020;
	
	for (i=0; i<32; i += 8) masks[5][i] = 0x10001000;
	for (i=1; i<32; i += 8) masks[5][i] = 0x00800080;
	for (i=2; i<32; i += 8) masks[5][i] = 0x04000400;
	for (i=3; i<32; i += 8) masks[5][i] = 0x00020002;
	for (i=4; i<32; i += 8) masks[5][i] = 0x80008000;
	for (i=5; i<32; i += 8) masks[5][i] = 0x00400040;
	for (i=6; i<32; i += 8) masks[5][i] = 0x02000200;
	for (i=7; i<32; i += 8) masks[5][i] = 0x00010001;
	
	for (i=0; i<32; i++) masks[6][i] = -1;
	
	for (i=0; i<32; i += 2) masks[7][i] = 0x55555555;
	for (i=1; i<32; i += 2) masks[7][i] = 0xaaaaaaaa;
}
 
maskbox(x, y, width, height, mask)
int x, y, width, height, mask;
{
        register int i, j;
        register int leftbit, mbits;
        register int *adr, *oldadr;
        register int xb = x & 31;
        register int w, yc, mc;
 
        adr = screenstart + (y << 6) + (x >> 5);
		yc = y;
        leftbit = (xb == 0) ? -1 : ~screenmasks[xb - 1];
        if (xb + width < 32) leftbit &= screenmasks[xb + width];
		for (j = height; j; --j) {
                oldadr = adr;
				mc = masks[mask][yc % 32];
                *adr = (*adr & ~leftbit) | (leftbit & mc);
				adr++;
                w = width - (32 - xb);
                for(;w >= 32; w -= 32)  *adr++ = mc;
                if (w > 0) *adr = (*adr & ~screenmasks[w]) | (screenmasks[w] & mc);
                adr = oldadr + SCREENWIDTHWORDS;
				yc++;
        }
}
 
initgraphics()
/* initialise the video card */
{
  int *adr;
  clearscreen();
  adr = videoOn;
  *adr = 0;
  adr = Page_0_Reg;
  *adr = 0;
}

clearscreen()
/* erase the screen */
{
  int *adr;
  for(adr = screenstart; adr < screenend; *adr++ = -1);
}
  
clearbox(x, y, width, height)
int x, y, width, height;
{
        register int i;
        register int leftbit;
        register int *adr, *oldadr;
        register int xb = x & 31;
        register int w;
 
        adr = screenstart + (y << 6) + (x >> 5);
        leftbit = (xb == 0) ? -1 : ~screenmasks[xb - 1];
        if (xb + width < 32) leftbit &= screenmasks[xb + width];
        for(y = height; y; --y) {
                oldadr = adr;
                *adr++ &= ~leftbit;
                w = width - (32 - xb);
                for(;w >= 32; w -= 32)  *adr++ = 0;
                if (w > 0) *adr &= ~screenmasks[w];
                adr = oldadr + SCREENWIDTHWORDS;
        }
}

void clearwindow()
{
  clearbox(minx, miny, maxx-minx, maxy-miny);
}

boxer()
{
	int i, x, y, w, h, mw, mh, mask;
	mw = maxx - minx;
	mh = maxy - miny;
 
    for (i=1; i<NOBOXES; i++)
    {
        x = minx + (rand() % mw);
        y = miny + (rand() % mh);
        w = rand() % MAXWIDTH;
		h = rand() % MAXHEIGHT;
		mask = rand() % NMASKS;
		if (((x + w) < (minx + mw)) && ((y + h) < (miny + mh))) maskbox(x, y, w, h, mask);
     }
}

struct window {
	int wTop;			/* top of window */
	int wLeft;			/* left of window */
	int wBottom;		/* bottom of window */
	int wRight;			/* right of window */
	int wcCursx;		/* top of cursor */
	int wcCursy;		/* left of cursor */
	int wcMode;			/* char draw mode */
	int wcColorF;		/* char foreground color */
	int wcColorB;		/* char background color */
	int wFont;			/* character font pointer */
						/* other fields follow, but are not used yet */
};

void _main ()
{
struct window  winp;

winp.wTop = 40;
winp.wLeft = 80;
winp.wBottom = 720;
winp.wRight = 880;

initgraphics ( ) ;

main(&winp);
}
	
void main (w)
struct	window	*w;
{
	int i;
	minx = w->wLeft;
	maxx = w->wRight;
	miny = w->wTop;
	maxy = w->wBottom;
	initmasks();
	while (1) {
		clearwindow();
		boxer();
		for (i = 0; i < 1000000; i++);
	}
}
