/*	Rom down-loader 9/22/87  */
/*	modified: Hermi Singh - 2/26/88	*/
/*	modified to serve as loader from TForth - 4/9/88 */
/************************************************************************/
/*									*/
/*	Changes made by Hermi Singh					*/
/*									*/
/*	For testing purposes, this code was downloaded by orignal ld-mac*/
/*	to the phoenix and acted as the bootstrap to the test pgm to	*/
/*	be loaded from the Mac. 					*/
/*									*/
/*	Note : all the stuff regarding initialization of transputer	*/
/*	queues on startup was commented out for testing but need to be	*/
/*	put back on ROMing.						*/
/*									*/
/*	Actual modification to code is that we acknowledge every	*/
/*	D_ type record sent to us by the Macintosh end of serial driver	*/
/*	by sending back a "#" character i.e 0x23.  This ack takes place	*/
/*	for all but the D_DONE record.					*/
/*									*/
/*	This change was made to prevent the Mac end from out running	*/
/*	the phoenix end when it was initializing memory to all 0's	*/
/*	for static integer arrays.					*/
/*									*/
/************************************************************************/

#include "newMessage.h"
#include "tload.h"

loader()
{
register int size;
register char *address;

int *stack;
int startflag = 0;		/*	flag to set as 1 on receiving	*/
				/*	a start addr			*/
int siochannel;
char *enda, *start;
char *enter;


/* Figure out which port to use */

	siochannel = 1;
	while (siochannel == 1) {
		if ((getstatus(CHA) & 0x01) == 0x01)
			siochannel = CHA;
		if ((getstatus(CHB) & 0x01) == 0x01)
			siochannel = CHB;
	};
	

/* Download the fucker! */
	while (inbyte(siochannel) != '?')
		;

	outbyte(1,siochannel);	/* Handshake */	
	for(;;)  {
		switch (inbyte(siochannel)) {
		case D_DONE:
			stack = (int *)getword(siochannel);
			enter = (char *)getword(siochannel);
			enda = address;
		#pragma	asm
			ldl	?ws-1		;	entry point - enter
			ldl	?ws-3		;	end addr - enda
			ldl	?ws-2		;	start addr - start
			.RETF	?ws
		#pragma	endasm
		case D_DATA:
			size = (int)inbyte(siochannel);
			while (size--)
				*address++ = inbyte(siochannel);
			break;
		case D_LOAD:
			address = (char *)getword(siochannel);
			if (startflag == 0) {
				start = address;
				startflag = 1;
			}
			break;
		case D_STORAGE:
			size = getword(siochannel);
			while (size--)
				*address++ = 0;
			break;
		default:
			break;
		}
		
		/*	ack back a # symbol to the Mac - to get it	*/
		/*	send us more records.  Handshake.		*/
		
		outbyte(0x23,siochannel);
	}
	
}

int getword(siochannel)
int	siochannel;
{
union {
	char b[4];
	int x;
} word;

	word.b[0] = inbyte(siochannel);
	word.b[1] = inbyte(siochannel);
	word.b[2] = inbyte(siochannel);
	word.b[3] = inbyte(siochannel);
	return(word.x);
}	

