#line 1 "T4th6.tal"
; .TITLE TFORTH 79FORTH FOR THE 414 TRANSPUTER
;
; COPYRIGHT (C) 1987 BY:
; DAVID SKINNER
; THE FORTH HOUSE
; 10756 MATTHIEU LANE
; AURORA, OREGON 97002
; 503-678-5220
;
; Modified by Noel W Henson 2-15-88 for the SWWS
;
#line 29
 .val ???1 , 0

; EQUATES

 .set ABL , 040  
 .set ACR , 015
 .set AMINUS , 055  
 .set ADOT , 056  
 .set BELL , 007
 .set ALF , 012
 .set FFEED , 014
 .set ADEL , 0177
 .set ADLE , 0177
 .set BSOUT , 010
 .set BSIN , 010

 .T800

 .set BPW , (4)  
 .set MAXINT , 0X7FFFFFFF  
 .set VLINK , 0XA081  


 .set EM , 0x003f0000  
; FREMEM+128K  
 .set HDBT , (1024+BPW+BPW)  
 .set NBUF , 2  
 .set BUF1 , EM-(HDBT*NBUF)  
 .set US , (60*BPW)  
 .set INITR0 , BUF1-US  
 .set RTS , (100*BPW)  
 .set INITSP , INITR0-RTS  

 .set DEBUG , 0
; PSA BLOCK DEFINATIONS

;  
 .set T3 , (0)  
 .set T2 , (T3+1)
 .set T1 , (T2+1)
 .set T0 , (T1+1)
 .set PARSTK , (4)  
 .set RETSTK , (PARSTK+1)  
 .set IP , (RETSTK+1)  
 .set W , (IP+1)  
 .set UP , (W+1)  
 .set NEXT , (UP+1)  
 .set FAKSUB , (NEXT+1)  
 .set TTYIN , (FAKSUB+1)  
 .set TTYOUT , (TTYIN+1)  
 .set HALTN , (13)  


; PARAMETER STACK DEFINITIONS

;  
 .set PT4 , (0)  
 .set PT3 , (PT4+1)
 .set PT2 , (PT3+1)
 .set PT1 , (PT2+1)
 .set PT0 , (PT1+1)
 .set P0 , (PT0+1)  
 .set P1 , (P0+1)  
 .set P2 , (P1+1)  
 .set P3 , (P2+1)  
 .set P4 , (P3+1)
 .set P5 , (P4+1)


; RETURN STACK DEFINITIONS

;  
 .set RT4 , (0)  
 .set RT3 , (RT4+1)
 .set RT2 , (RT3+1)
 .set RT1 , (RT2+1)
 .set RT0 , (RT1+1)
 .set R0 , (RT0+1)  
 .set R1 , (R0+1)  
 .set R2 , (R1+1)  
 .set R3 , (R2+1)  
 .set R4 , (R3+1)

; IT ALL STARTS HERE

; ENTER AT _forth for initial start
; _forth+4 for cold start if CREG does not have boot channel
; _forth+8 for warm start (ie keep dictionary)

; If entry is at main+4 or main+8 WPTR must be the same as the initial
; entry through main

 .pub _forth

_forth: J @COLDS ;COLD START ENTRY
 .ALIGN
 AJW -20
 J @CHILL ;COLD START WITHOUT BOOT CHANNEL
 .ALIGN
 LDC TWARM ;POINT TO WARM START ADDRESS
 AJW -20
 J @WARM

COLDS: AJW -20 ;PUT PSA HERE
 STL TTYIN
 STL TTYIN
 STL TTYIN ;SAVE BOOT INPUT LINK ADDRESS
 LDC 0X10
 XOR
 STL TTYOUT

CHILL: LDC TCOLD
WARM: LDNL 0 ;INITIAL FORTH PC
 STL IP

 LDC INTUSR
 STL T0
 LDL T0
 LDNL 0 ;INTUSR
 ADC -BPW*P0 ;LEAVE ROOM FOR THE TEMPS
 STL PARSTK ;SET INITIAL PARAMETER STACK

 LDL T0
 LDNL 1
 STL UP ;SET USER POINTER

 LDL UP
 ADC -BPW*R0 ;LEAVE ROOM FOR THE TEMPS
 STL RETSTK ;SET INITIAL RETURN STACK

 LDC FAKSBR
 STL FAKSUB
 LDC NEXTR
 STL NEXT
 LDL NEXT
 GCALL

; THE FOLLOWING ARE WHAT NEXT LOOKS LIKE ON A MORE CONVENTIONAL MACHINE

; PDP/11 68000 (16 BIT)

; .MACRO NEXT MOVE.W (A5)+,D7
; MOV (IP)+,W MOVE.W 0(A3,D7.L),D6
; JMP @(W)+ JMP 0(A3,D6.L)
; .ENDM

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


; Colon has been moved to here to provide a way to deschedule the process

; When the compilier was finished I noticed that except for a few
; jump instructions in some of the words used in compiling, the only
; jump was in </loop>. If colon was left where it was it was going
; to compile a 3 byte jump so it was moved here so it could be done
; with one byte.

; If NEXT is moved to chip ram DOCOL should be moved with it to take
; full advantage of the move. In that case patch another jump to the
; chip ram location at DOCOL.

; For max speed remove the j @nextr and the align when moving to chip
; ram. But remember to leave nextr word aligned after the move.


 
#line 194
 .align
#line 194
???2
#line 194
 .dbnz 0X81,':'+0X80,0
#line 194
 .align
#line 194
 .dw ???1
#line 194
; 2
#line 194
 ; :
COLON: .DW DOCOL,SPAT,CSP,STORE,CURR,AT
 .DW CONT,STORE,CREATE,SMUDG,RBRAC,ASCODE
DOCOL: LDL IP
 LDL RETSTK
 ADC -BPW ;ALLOCATE RETURN STACK ENTRY
 STL RETSTK
 LDL RETSTK
 STNL R0 ;SAVE IP ON RETURN STACK
 LDL W
 ADC BPW
 STL IP
 ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 J @NEXTR ;! THIS IS THE ONLY DESCHEDULING !!
 ;! THAT WILL NORMALLY BE EXECUTED !!
 ;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


 .ALIGN

NEXTR: LDL IP ;GET FORTH PC
 LDNL 0 ;NEXT POINTER
 STL W ;SAVE FOR ;CODE WORDS
 LDL IP ;POINT TO NEXT INSTRUCTION
 ADC BPW
 STL IP
 LDL W ;GET CODE FIELD POINTER FOR NEXT WORD
 LDNL 0
 GCALL

; THE FOLLOWING PIECE OF CODE WILL SIMULATE A CONVENTIONAL
; SUBROUTINE CALL SUCH AS A PDP/11 JSR

; THE CONSTANT SUBCAL IS NORMALLY A JSR INSTRUCTION

; HERE IT IS A LDL FAKSUB POINTER TO FAKSBR
; GCALL



FAKSBR: ADC BPW-1 ;ROUND UP TO NEXT WORD
 WCNT ;REMEMBER WHERE WE WERE CALLED FROM
 BCNT
 STL T0 ;NOW POINT TO JSR TARGET ADDRESS

 LDL RETSTK
 ADC -BPW ;ALLOCATE ENTRY
 STL RETSTK
 LDL IP
 LDL RETSTK
 STNL R0 ;PUSH CURRENT IP

 LDL T0 ;SET NEW IP
 ADC BPW ;POINT AFTER JSR TARGET
 STL IP ;RETURN TO WORD WITH 0X0F67A IN IT

 LDL T0
 LDNL 0 ;GET THE CALLED ADDRESS
 GCALL

 .DW 0X0F67A ;MAKE SURE 0X0F67A IS THE CORRECT VALUE

 LDL FAKSUB
 GCALL

; INITIAL USER AREA

 .align
TCOLD: .DW COLD+BPW
TWARM: .DW COLDX+BPW

INT4TH: .DW LSTSYM
INTUSR: .DW INITSP ; 3 SP0 TOP OF PARAMETER STACK

 .DW INITR0 ; 4 R0 TOP OF RETURN STACK
 .DW INITSP ; 5 TIB TERMINAL INPUT BUFFER
 .DW 15 ; 6 WIDTH
 .DW 1 ; 7 WARNING
 .DW LSTSYM ; 8 FENCE
 .DW FREMEM ; 9 DP
 .DW FORTH+(3*BPW) ;10 VOCABULARY LINK

 .DW ADFIND ;11 VECTOR TO FIND
 .DW AQTERM ;12 VECTOR TO ?TERMINAL
 .DW AABORT ;13 VECTOR TO ABORT
 .DW ABLOCK ;14 VECTOR TO BLOCK
 .DW ACRA ;15 VECTOR TO CR
 .DW AEMIT ;16 VECTOR TO EMIT
 .DW AEXPCT ;17 VECTOR TO EXPECT
 .DW AINTER ;18 VECTOR TO INTERPRET
 .DW AKEY ;19 VECTOR TO KEY
 .DW ALOAD ;20 VECTOR TO LOAD
 .DW ANUM ;21 VECTOR TO NUMBER
 .DW APAGE ;22 VECTOR TO PAGE
 .DW ARSLW ;23 VECTOR TO R/W
 .DW AABORT ;24 VECTOR TO ATSCLC NOT USED
 .DW AV79 ;25 VECTOR TO VOCABULARY TYPE
 .DW AWORD ;26 VECTOR TO WORD

 .DW 0 ;27 >IN POSITION IN INPUT LINE
 .DW 10 ;28 BASE RADIX
 .DW 0 ;29 BLK DISK BLOCK BEING COMPILED
 .DW 0 ;30 CONTEXT
 .DW 0 ;31 CSP COMPILING STACK CHECK VARIABLE
 .DW 0 ;32 CURRENT
 .DW 0 ;33 DPL DIGITS TO RIGHT OF POINT
 .DW 0 ;34 FLD
 .DW 0 ;35 HLD
 .DW 0 ;36 OFFSET BASE BLOCK OF CURRENT DISK
 .DW 0 ;37 OUT POSITION IN OUTPUT LINE
 .DW 0 ;38 R# EDITOR CURSOR
 .DW 0 ;39 SCR SCREEN BEING EDITED
 .DW 0 ;40 STATE
 .DW 0 ;safety
front_window
 .dw default_window ;42
pltchrvec
 .dw plot_char ;43

 
#line 313
 .align
#line 313
???3
#line 313
 .dbnz 0X81,'!'+0X80,0
#line 313
 .align
#line 313
 .dw ???2
#line 313
; 3
#line 313
 ; STORE
STORE: .DW STORE+BPW
 LDL PARSTK
 GAJW
 LDL P1 ;VALUE TO STORE
 LDL P0 ;ADDRESS
 STNL 0
 AJW 2
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 328
 .align
#line 328
???4
#line 328
 .dbnz 0X81,'#'+0X80,0
#line 328
 .align
#line 328
 .dw ???3
#line 328
; 4
#line 328
 ; #
DIG: .DW DOCOL
 .DW BASE,AT,MSMOD,ROT,LIT,9.
 .DW OVER,LESS,ZBRAN
DIGX: .DW DIG1-DIGX,LIT,7
 .DW PLUS
DIG1: .DW LIT,060,PLUS,HOLD,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 338
 .align
#line 338
???5
#line 338
 .dbnz 0X82,"#",'>'+0X80
#line 338
 .align
#line 338
 .dw ???4
#line 338
; 5
#line 338
 ; #>
EDIGS: .DW DOCOL,DDROP,HLD,AT,PAD,OVER
 .DW SUBB,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 344
 .align
#line 344
???6
#line 344
 .dbnz 0X85,"#BUF",'F'+0X80
#line 344
 .align
#line 344
 .dw ???5
#line 344
; 6
#line 344
 ; #BUFF
NOBUF: .DW DOCON,NBUF

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 349
 .align
#line 349
???7
#line 349
 .dbnz 0X82,"#",'S'+0X80
#line 349
 .align
#line 349
 .dw ???6
#line 349
; 7
#line 349
 ; #S
DIGS: .DW DOCOL
DIGS1: .DW DIG,DDUP,ORR,NOTT,ZBRAN
DIGSX: .DW DIGS1-DIGSX
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 357
 .align
#line 357
???8
#line 357
 .dbnz 0XC1,0X27+0X80,0
#line 357
 .align
#line 357
 .dw ???7
#line 357
; 8
#line 357
 ; '
TICK: .DW DOCOL,DFIND
 .DW NOTT,AABRTQ
 .DBNZ 9,"NOT FOUND"
 .ALIGN
 .DW DROP,LITER,EXIT

 
#line 364
 .align
#line 364
???9
#line 364
 .dbnz 0X86,"'-FIN",'D'+0X80
#line 364
 .align
#line 364
 .dw ???8
#line 364
; 9
#line 364
 ; '-FIND
TDFIND: .DW DOUSE,11

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 369
 .align
#line 369
???10
#line 369
 .dbnz 0X8A,"'?TERMINA",'L'+0X80
#line 369
 .align
#line 369
 .dw ???9
#line 369
; 10
#line 369
 ; '?TERMINAL
TQTERM: .DW DOUSE,12

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 374
 .align
#line 374
???11
#line 374
 .dbnz 0X86,"'ABOR",'T'+0X80
#line 374
 .align
#line 374
 .dw ???10
#line 374
; 11
#line 374
 ; 'ABORT
TABORT: .DW DOUSE,13

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 379
 .align
#line 379
???12
#line 379
 .dbnz 0X86,"'BLOC",'K'+0X80
#line 379
 .align
#line 379
 .dw ???11
#line 379
; 12
#line 379
 ; 'BLOCK
TBLOCK: .DW DOUSE,14

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 384
 .align
#line 384
???13
#line 384
 .dbnz 0X83,"'C",'R'+0X80
#line 384
 .align
#line 384
 .dw ???12
#line 384
; 13
#line 384
 ; 'CR
TCR: .DW DOUSE,15

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 389
 .align
#line 389
???14
#line 389
 .dbnz 0X85,"'EMI",'T'+0X80
#line 389
 .align
#line 389
 .dw ???13
#line 389
; 14
#line 389
 ; 'EMIT
TEMIT: .DW DOUSE,16

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 394
 .align
#line 394
???15
#line 394
 .dbnz 0X87,"'EXPEC",'T'+0X80
#line 394
 .align
#line 394
 .dw ???14
#line 394
; 15
#line 394
 ; 'EXPECT
TEXPCT: .DW DOUSE,17

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 399
 .align
#line 399
???16
#line 399
 .dbnz 0X8A,"'INTERPRE",'T'+0X80
#line 399
 .align
#line 399
 .dw ???15
#line 399
; 16
#line 399
 ; 'INTERPRET
TINTER: .DW DOUSE,18

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 404
 .align
#line 404
???17
#line 404
 .dbnz 0X84,"'KE",'Y'+0X80
#line 404
 .align
#line 404
 .dw ???16
#line 404
; 17
#line 404
 ; 'KEY
TKEY: .DW DOUSE,19

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 409
 .align
#line 409
???18
#line 409
 .dbnz 0X85,"'LOA",'D'+0X80
#line 409
 .align
#line 409
 .dw ???17
#line 409
; 18
#line 409
 ; 'LOAD
TLOAD: .DW DOUSE,20

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 414
 .align
#line 414
???19
#line 414
 .dbnz 0X87,"'NUMBE",'R'+0X80
#line 414
 .align
#line 414
 .dw ???18
#line 414
; 19
#line 414
 ; 'NUMBER
TNUM: .DW DOUSE,21


 
#line 418
 .align
#line 418
???20
#line 418
 .dbnz 0X85,"'PAG",'E'+0X80
#line 418
 .align
#line 418
 .dw ???19
#line 418
; 20
#line 418
 ; 'PAGE
TPAGE: .DW DOUSE,22

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 423
 .align
#line 423
???21
#line 423
 .dbnz 0X84,"'R/",'W'+0X80
#line 423
 .align
#line 423
 .dw ???20
#line 423
; 21
#line 423
 ; 'R/W
TRSLW: .DW DOUSE,23

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 428
 .align
#line 428
???22
#line 428
 .dbnz 0X87,"'STREA",'M'+0X80
#line 428
 .align
#line 428
 .dw ???21
#line 428
; 22
#line 428
 ; 'STREAM
TSTREM: .DW DOCOL,BLK,AT,QDUP,ZBRAN
TSTRX: .DW TSTRM1-TSTRX
 .DW BLOCK,BRAN
TSTRZ: .DW TSTRM2-TSTRZ
TSTRM1: .DW TIB,AT
TSTRM2: .DW TOIN,AT,PLUS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

; 
#line 438
 .align
#line 438
???23
#line 438
 .dbnz 0X88,"'T&SCAL",'C'+0X80
#line 438
 .align
#line 438
 .dw ???22
#line 438
; 23
#line 438
 ; 'T&SCALC
;TTSCALC:.DW DOUSE,24

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 443
 .align
#line 443
???24
#line 443
 .dbnz 0X80+11,"'VOCABULAR",'Y'+0X80
#line 443
 .align
#line 443
 .dw ???23
#line 443
; 24
#line 443
 ; 'VOCABULARY
TVOCAB: .DW DOUSE,25

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 448
 .align
#line 448
???25
#line 448
 .dbnz 0X85,"'WOR",'D'+0X80
#line 448
 .align
#line 448
 .dw ???24
#line 448
; 25
#line 448
 ; 'WORD
TWORD: .DW DOUSE,26

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 453
 .align
#line 453
???26
#line 453
 .dbnz 0XC1,'('+0X80,0
#line 453
 .align
#line 453
 .dw ???25
#line 453
; 26
#line 453
 ; (
PAREN: .DW DOCOL,LIT,-1,TOIN,PSTOR,LIT
 .DW 051,WORD,CAT,ONEP,HERE,PLUS
 .DW CAT,LIT,051,EQUAL,NOTT,QSTREA
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 461
 .align
#line 461
???27
#line 461
 .dbnz 0X81,'*'+0X80,0
#line 461
 .align
#line 461
 .dw ???26
#line 461
; 27
#line 461
 ; *
STAR: .DW DOCOL,USTAR,DROP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 466
 .align
#line 466
???28
#line 466
 .dbnz 0X82,"*",'/'+0X80
#line 466
 .align
#line 466
 .dw ???27
#line 466
; 28
#line 466
 ; */
SSLA: .DW DOCOL,SSMOD,SWAP,DROP,EXIT

 
#line 469
 .align
#line 469
???29
#line 469
 .dbnz 0X85,"*/MO",'D'+0X80
#line 469
 .align
#line 469
 .dw ???28
#line 469
; 29
#line 469
 ; */MOD
SSMOD: .DW DOCOL,TOR,MSTAR,FROMR,MSLAS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 474
 .align
#line 474
???30
#line 474
 .dbnz 0X81,'+'+0X80,0
#line 474
 .align
#line 474
 .dw ???29
#line 474
; 30
#line 474
 ; +
PLUS: .DW PLUS+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 BSUB ;"ADD"
 STL P1
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 490
 .align
#line 490
???31
#line 490
 .dbnz 0X82,"+",'!'+0X80
#line 490
 .align
#line 490
 .dw ???30
#line 490
; 31
#line 490
 ; +STORE
PSTOR: .DW PSTOR+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDNL 0
 LDL P1
 BSUB ;"ADD"
 LDL P0
 STNL 0
 AJW 2
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 508
 .align
#line 508
???32
#line 508
 .dbnz 0X82,"+",'-'+0X80
#line 508
 .align
#line 508
 .dw ???31
#line 508
; 32
#line 508
 ; +-
PM: .DW DOCOL,ZLESS,ZBRAN
PMX: .DW PM1-PMX,NEG
PM1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 515
 .align
#line 515
???33
#line 515
 .dbnz 0X84,"+BU",'F'+0X80
#line 515
 .align
#line 515
 .dw ???32
#line 515
; 33
#line 515
 ; +BUF
PBUF: .DW DOCOL,LIT,HDBT,PLUS,DUP,LIMIT,EQUAL
 .DW ZBRAN
PBUFX: .DW PBUF1-PBUFX,DROP,FIRST
PBUF1: .DW DUP,PREV,AT,SUBB,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 523
 .align
#line 523
???34
#line 523
 .dbnz 0XC5,"+LOO",'P'+0X80
#line 523
 .align
#line 523
 .dw ???33
#line 523
; 34
#line 523
 ; +LOOP
PLOOP: .DW DOCOL,LIT,3,QPAIR,COMP,APLOOP
 .DW HERE,SUBB,COMMA,EXIT

 
#line 527
 .align
#line 527
???35
#line 527
 .dbnz 0X81,','+0X80,0
#line 527
 .align
#line 527
 .dw ???34
#line 527
; 35
#line 527
 ; ,
COMMA: .DW DOCOL,HERE,STORE,CELL,ALLOT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 532
 .align
#line 532
???36
#line 532
 .dbnz 0X81,'-'+0X80,0
#line 532
 .align
#line 532
 .dw ???35
#line 532
; 36
#line 532
 ; -
SUBB: .DW SUBB+BPW
 LDL PARSTK
 GAJW
 LDL P1
 LDL P0
 DIFF
 STL P1
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 548
 .align
#line 548
???37
#line 548
 .dbnz 0X85,"-FIN",'D'+0X80
#line 548
 .align
#line 548
 .dw ???36
#line 548
; 37
#line 548
 ; -FIND
DFIND: .DW DOCOL,TDFIND,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 553
 .align
#line 553
???38
#line 553
 .dbnz 0X89,"-TRAILIN",'G'+0X80
#line 553
 .align
#line 553
 .dw ???37
#line 553
; 38
#line 553
 ; -TRAILING
DTRAI: .DW DOCOL,DUP,ZERO,ADO
DTRAI1: .DW DDUP,PLUS,ONEM,CAT,BL,SUBB,ZBRAN
DTRAIX: .DW DTRAI2-DTRAIX,LEAVE,BRAN
DTRAIZ: .DW DTRAI3-DTRAIZ
DTRAI2: .DW ONEM
DTRAI3: .DW ALOOP
DTRAIW: .DW DTRAI1-DTRAIW,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 564
 .align
#line 564
???39
#line 564
 .dbnz 0X81,'.'+0X80,0
#line 564
 .align
#line 564
 .dw ???38
#line 564
; 39
#line 564
 ; .
DOT: .DW DOCOL,STOD,DDOT,EXIT

 
#line 567
 .align
#line 567
???40
#line 567
 .dbnz 0XC2,".",'"'+0X80
#line 567
 .align
#line 567
 .dw ???39
#line 567
; 40
#line 567
 ; ."
DOTQ: .DW DOCOL,TSTREM,CAT,LIT,042,EQUAL
 .DW ZBRAN
DOTQP .DW DOTQ1-DOTQP,ONE,TOIN,PSTOR,BRAN
DOTQQ .DW DOTQ2-DOTQQ
DOTQ1: .DW LIT,042,STATE,AT,ZBRAN
DOTQR .DW DOTQ3-DOTQR
 .DW COMP,ADOTQ
DOTQ3: .DW WORD,DUP,CAT,ONEP,OVER,PLUS
 .DW CAT,LIT,042,EQUAL,NOTT,QSTREA,STATE
 .DW AT,ZBRAN
DOTQS .DW DOTQ4-DOTQS,CAT,ONEP,ALLOT,BRAN
DOTQT .DW DOTQ2-DOTQT
DOTQ4: .DW COUNT,TYPE
DOTQ2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 585
 .align
#line 585
???41
#line 585
 .dbnz 0X85,".LIN",'E'+0X80
#line 585
 .align
#line 585
 .dw ???40
#line 585
; 41
#line 585
 ; .LINE
DLINE: .DW DOCOL,ALINE,DTRAI,TYPE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 590
 .align
#line 590
???42
#line 590
 .dbnz 0X82,".",'R'+0X80
#line 590
 .align
#line 590
 .dw ???41
#line 590
; 42
#line 590
 ; .R
DOTR: .DW DOCOL,TOR,STOD,FROMR,DDOTR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 595
 .align
#line 595
???43
#line 595
 .dbnz 0X81,'/'+0X80,0
#line 595
 .align
#line 595
 .dw ???42
#line 595
; 43
#line 595
 ; /
SLASH: .DW DOCOL,SLMOD,SWAP,DROP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 600
 .align
#line 600
???44
#line 600
 .dbnz 0XC5,"/LOO",'P'+0X80
#line 600
 .align
#line 600
 .dw ???43
#line 600
; 44
#line 600
 ; /LOOP
UPLOOP: .DW DOCOL,LIT,3,QPAIR,COMP,AUPLOP
 .DW HERE,SUBB,COMMA,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 606
 .align
#line 606
???45
#line 606
 .dbnz 0X84,"/MO",'D'+0X80
#line 606
 .align
#line 606
 .dw ???44
#line 606
; 45
#line 606
 ; /MOD
SLMOD: .DW DOCOL,TOR,STOD,FROMR,MSLAS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 611
 .align
#line 611
???46
#line 611
 .dbnz 0X81,'0'+0X80,0
#line 611
 .align
#line 611
 .dw ???45
#line 611
; 46
#line 611
 ; 0
ZERO: .DW DOCON,0

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 616
 .align
#line 616
???47
#line 616
 .dbnz 0X82,"0",'<'+0X80
#line 616
 .align
#line 616
 .dw ???46
#line 616
; 47
#line 616
 ; 0<
ZLESS: .DW ZLESS+BPW
 LDC 0
 LDL PARSTK
 LDNL P0
 GT
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 627
 .align
#line 627
???48
#line 627
 .dbnz 0X82,"0",'='+0X80
#line 627
 .align
#line 627
 .dw ???47
#line 627
; 48
#line 627
 ; 0=
ZEQU: .DW DOCOL,NOTT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 632
 .align
#line 632
???49
#line 632
 .dbnz 0X82,"0",'>'+0X80
#line 632
 .align
#line 632
 .dw ???48
#line 632
; 49
#line 632
 ; 0>
ZGREAT: .DW DOCOL,ZERO,GREAT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 637
 .align
#line 637
???50
#line 637
 .dbnz 0X87,"0BRANC",'H'+0X80
#line 637
 .align
#line 637
 .dw ???49
#line 637
; 50
#line 637
 ; 0BRANCH
ZBRAN: .DW ZBRAN+BPW
 LDL PARSTK
 LDNL P0
 LDL PARSTK
 ADC BPW ;POP THE FLAG
 STL PARSTK
 CJ @ZBRAN4

 LDL IP ;CURRENT FORTH IP
 ADC BPW ;SKIP BRANCH OFFSET
 STL IP
 LDL NEXT
 GCALL

 .ALIGN
ZBRAN4: LDL IP
 LDL IP
 LDNL 0 ;GET BRANCH OFFSET
 BSUB ;"ADD"
 STL IP
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 663
 .align
#line 663
???51
#line 663
 .dbnz 0X81,'1'+0X80,0
#line 663
 .align
#line 663
 .dw ???50
#line 663
; 51
#line 663
 ; 1
ONE: .DW DOCON,01

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 668
 .align
#line 668
???52
#line 668
 .dbnz 0X82,"1",'+'+0X80
#line 668
 .align
#line 668
 .dw ???51
#line 668
; 52
#line 668
 ; 1+
ONEP: .DW ONEP+BPW
 LDL PARSTK
 LDNL P0
 ADC 1
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 678
 .align
#line 678
???53
#line 678
 .dbnz 0X82,"1",'-'+0X80
#line 678
 .align
#line 678
 .dw ???52
#line 678
; 53
#line 678
 ; 1-
ONEM: .DW ONEM+BPW
 LDL PARSTK
 LDNL P0
 ADC -1
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 690
 .align
#line 690
???54
#line 690
 .dbnz 0X81,'2'+0X80,0
#line 690
 .align
#line 690
 .dw ???53
#line 690
; 54
#line 690
 ; 2
TWO: .DW DOCON,02

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 695
 .align
#line 695
???55
#line 695
 .dbnz 0X82,"2",'*'+0X80
#line 695
 .align
#line 695
 .dw ???54
#line 695
; 55
#line 695
 ; 2*
TWOST: .DW TWOST+BPW
 LDL PARSTK
 LDNL P0
 LDC 1
 SHL
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 708
 .align
#line 708
???56
#line 708
 .dbnz 0X82,"2",'+'+0X80
#line 708
 .align
#line 708
 .dw ???55
#line 708
; 56
#line 708
 ; 2+
TWOP: .DW TWOP+BPW
 LDL PARSTK
 LDNL P0
 ADC 2
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 720
 .align
#line 720
???57
#line 720
 .dbnz 0X82,"2",'-'+0X80
#line 720
 .align
#line 720
 .dw ???56
#line 720
; 57
#line 720
 ; 2-
TWOM: .DW TWOM+BPW
 LDL PARSTK
 LDNL P0
 ADC -2
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 730
 .align
#line 730
???58
#line 730
 .dbnz 0X82,"2",'/'+0X80
#line 730
 .align
#line 730
 .dw ???57
#line 730
; 58
#line 730
 ; 2/
TWOSL: .DW DOCOL,TWO,SLASH,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 735
 .align
#line 735
???59
#line 735
 .dbnz 0X8+11,"79-STANDAR",'D'+0X80
#line 735
 .align
#line 735
 .dw ???58
#line 735
; 59
#line 735
 ; 79-STANDARD
STAND: .DW DOCOL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 740
 .align
#line 740
???60
#line 740
 .dbnz 0XC1,';'+0X80,0
#line 740
 .align
#line 740
 .dw ???59
#line 740
; 60
#line 740
 ; ;
SEMI: .DW DOCOL,QCSP,COMP,EXIT,SMUDG,LBRAC
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 746
 .align
#line 746
???61
#line 746
 .dbnz 0X81,'<'+0X80,0
#line 746
 .align
#line 746
 .dw ???60
#line 746
; 61
#line 746
 ; <
LESS: .DW LESS+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 GT
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 762
 .align
#line 762
???62
#line 762
 .dbnz 0X82,"<",'#'+0X80
#line 762
 .align
#line 762
 .dw ???61
#line 762
; 62
#line 762
 ; <#
BDIGS: .DW DOCOL,PAD,HLD,STORE,EXIT

 
#line 765
 .align
#line 765
???63
#line 765
 .dbnz 0X87,"<+LOOP",'P'+0X80
#line 765
 .align
#line 765
 .dw ???62
#line 765
; 63
#line 765
 ; <+LOOP>
APLOOP: .DW APLOOP+4
 LDL PARSTK
 LDNL P0 ;GET INCREMENT

 LDL PARSTK
 ADC BPW
 STL PARSTK ;REMOVE INCREMENT FROM PARAMETER STACK

 LDL RETSTK
 GAJW
 STL RT0 ;SAVE PSA POINTER
 STL RT1 ;SAVE INCREMENT

 LDL RT1
 LDL R0 ;CURRENT INDEX
 BSUB ;THIS IS REALLY AN ADD
 STL R0 ;UPDATE INDEX

 LDL RT1 ;GET INCREMENT AGAIN
 LDC 0 ;CHECK SIGN OF INCREMENT
 GT ;1 IFF ADJUSTMENT >0
 CJ @APLUP6 ;BRANCH IF ADJUSTMENT <= 0

 LDL R1 ;FINAL INDEX
 LDL R0 ;UPDATED INDEX
 GT ;1 IFF FINAL > CURRENT
 CJ @APLUP8 ;BRANCH IF CURRENT >= FINAL

APLUP4: LDL RT0 ;RESTORE PSA POINTER
 GAJW ;POINT BACK TO PSA
 LDL IP
 LDL IP
 LDNL 0 ;GET BRANCH OFFSET
 BSUB ;"ADD"
 STL IP
 LDL NEXT
 GCALL

 .ALIGN
APLUP6: LDL R1 ;FINAL INDEX
 LDL R0 ;UPDATED INDEX
 GT ;1 IFF FINAL > CURRENT
 CJ @APLUP4 ;BRANCH IF CURRENT >= FINAL

APLUP8: LDL RT0 ;GET PSA POINTER
 AJW 2 ;REMOVE LOOP PARAMETERS
 GAJW
 STL RETSTK
 LDL IP ;GET FORTH PC
 ADC BPW ;SKIP BRANCH VALUE
 STL IP
 LDL NEXT
 GCALL

 
#line 820
 .align
#line 820
???64
#line 820
 .dbnz 0X87,"<-FIND",'>'+0X80
#line 820
 .align
#line 820
 .dw ???63
#line 820
; 64
#line 820
 ; <-FIND>
ADFIND: .DW DOCOL,BL,WORD,CONT,AT,AT
 .DW AFIND,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 826
 .align
#line 826
???65
#line 826
 .dbnz 0X84,"<.\"",'>'+0X80
#line 826
 .align
#line 826
 .dw ???64
#line 826
; 65
#line 826
 ; <.">
ADOTQ: .DW DOCOL,RAT,COUNT,DUP,ONEP,FROMR
 .DW PLUS,ALIGN,TOR,TYPE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 832
 .align
#line 832
???66
#line 832
 .dbnz 0X87,"</LOOP",'>'+0X80
#line 832
 .align
#line 832
 .dw ???65
#line 832
; 66
#line 832
 ; </LOOP>
AUPLOP: .DW AUPLOP+BPW
 LDL PARSTK
 LDNL P0 ;GET INCREMENT

 LDL PARSTK
 ADC BPW
 STL PARSTK ;REMOVE INCREMENT FROM PARAMETER STACK

 LDL RETSTK
 GAJW
 STL RT0 ;SAVE PSA POINTER

 LDL R0 ;CURRENT INDEX
 BSUB ;THIS IS REALLY AN ADD
 STL R0 ;UPDATE INDEX

 LDC 0 ;FAKE BORROW
 LDL R1 ;FINAL INDEX
 LDL R0 ;UPDATED INDEX
 LDIFF ;A' = FINAL - CURRENT
 CJ @APLUP8 ;BRANCH IF CURRENT = FINAL
 CJ @APLUP4 ;NO BORROW SEZ CURRENT < FINAL
 J @APLUP8

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 859
 .align
#line 859
???67
#line 859
 .dbnz 0X87,"<;CODE",'>'+0X80
#line 859
 .align
#line 859
 .dw ???66
#line 859
; 67
#line 859
 ; <;CODE>
ASCODE: .DW DOCOL,FROMR,LATES,PFA,CFA,STORE
 .DW EXIT

 
#line 863
 .align
#line 863
???68
#line 863
 .dbnz 0X88,"<<CMOVE",'>'+0X80
#line 863
 .align
#line 863
 .dw ???67
#line 863
; 68
#line 863
 ; <<CMOVE>
ADCMVE: .DW ADCMVE+BPW ;MOVE FROM BACK TO FRONT
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDL P0 ;LENGTH OF MOVE
 LDC 0
 GT ;1 IF LENGTH >0
 CJ @ADCM08

 LDL P0 ;ADJUST STARING ADDRESSES TO BACK END
 LDL P1
 BSUB ;"ADD"
 STL P1 ;DESTINATION POINTER

 LDL P0
 LDL P2
 BSUB ;"ADD"
 STL P2 ;SOURCE POINTER

ADCM04: LDL P2
 ADC -1
 STL P2
 LDL P2
 LB ;GET SOURCE BYTE

 LDL P1
 ADC -1
 STL P1
 LDL P1
 SB ;SAVE AT DESTINATION

 LDL P0 ;GET COUNT LEFT
 ADC -1
 STL P0
 LDL P0 ;CHECK FOR DONE
 EQC 0
 CJ @ADCM04

ADCM08: LDL PT0 ;RESTORE PSA POINTER
 AJW 3
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 910
 .align
#line 910
???69
#line 910
 .dbnz 0X88,"<ABORT\"",'>'+0X80
#line 910
 .align
#line 910
 .dw ???68
#line 910
; 69
#line 910
 ; <ABORT">
AABRTQ: .DW DOCOL,ZBRAN
AABRT3 .DW AABTQ1-AABRT3,WHERE,CR,RAT
 .DW COUNT,TYPE,SPSTO,QUIT,BRAN
AABRT4 .DW AABTQ2-AABRT4
AABTQ1: .DW FROMR,DUP,CAT,PLUS,ONEP,ALIGN,TOR
AABTQ2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 920
 .align
#line 920
???70
#line 920
 .dbnz 0X87,"<ABORT",'>'+0X80
#line 920
 .align
#line 920
 .dw ???69
#line 920
; 70
#line 920
 ; <ABORT>
AABORT: .DW DOCOL,SPSTO,QSTAC,FORTH,DEFIN,QUIT
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 926
 .align
#line 926
???71
#line 926
 .dbnz 0X87,"<BLOCK",'>'+0X80
#line 926
 .align
#line 926
 .dw ???70
#line 926
; 71
#line 926
 ; <BLOCK>
ABLOCK: .DW DOCOL,OFSET,AT,PLUS,TOR,PREV
 .DW AT,DUP,AT,RAT,SUBB,TWOST
 .DW ZBRAN
ABLCK4 .DW ABLCK3-ABLCK4
ABLCK1: .DW PBUF,NOTT,ZBRAN
ABLCK5 .DW ABLCK2-ABLCK5,DROP,RAT
 .DW BUFFE,DUP,RAT,ONE,RSLW,CELLM
ABLCK2: .DW DUP,AT,RAT,SUBB,TWOST,NOTT
 .DW ZBRAN
ABLCK6 .DW ABLCK1-ABLCK6,DUP,PREV,STORE
ABLCK3: .DW FROMR,DROP,CELLP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 941
 .align
#line 941
???72
#line 941
 .dbnz 0X86,"<CMOV",'E'+0X80
#line 941
 .align
#line 941
 .dw ???71
#line 941
; 72
#line 941
 ; <CMOVE
DCMOVE: .DW DOCOL,DUP,ONE,LESS,ZBRAN
DCMVE3 .DW DCMVE1-DCMVE3
 .DW DDROP,DROP,BRAN
DCMVE4 .DW DCMVE2-DCMVE4
DCMVE1: .DW ADCMVE
DCMVE2: .DW EXIT

 
#line 949
 .align
#line 949
???73
#line 949
 .dbnz 0X87,"<CMOVE",'>'+0X80
#line 949
 .align
#line 949
 .dw ???72
#line 949
; 73
#line 949
 ; <CMOVE>
ACMOVE: .DW ACMOVE+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDL P0 ;LENGTH OF MOVE
 LDC 0
 GT ;1 IF LENGTH >0
 CJ @ACM08

ACM04: LDL P2
 LB ;GET SOURCE BYTE
 LDL P2
 ADC 1
 STL P2

 LDL P1
 SB ;SAVE AT DESTINATION
 LDL P1
 ADC 1
 STL P1

 LDL P0 ;GET COUNT LEFT
 ADC -1
 STL P0
 LDL P0 ;CHECK FOR DONE
 EQC 0
 CJ @ACM04

ACM08: LDL PT0 ;RESTORE PSA POINTER
 AJW 3
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 986
 .align
#line 986
???74
#line 986
 .dbnz 0X84,"<CR",'>'+0X80
#line 986
 .align
#line 986
 .dw ???73
#line 986
; 74
#line 986
 ; <CR>
ACRA: .DW DOCOL,ZERO,OUTT,STORE
 .DW LIT,ACR,EMIT,LIT,ALF,EMIT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 992
 .align
#line 992
???75
#line 992
 .dbnz 0X84,"<DO",'>'+0X80
#line 992
 .align
#line 992
 .dw ???74
#line 992
; 75
#line 992
 ; <DO>
ADO: .DW ADO+BPW
 LDL RETSTK
 ADC -BPW-BPW ;ALLOCATE LOOP PARAMETERS
 STL RETSTK

 LDL PARSTK
 LDNL P0 ;GET STARTING VALUE
 LDL RETSTK
 STNL R0 ;SAVE AS CURRENT INDEX
 LDL PARSTK
 LDNL P1 ;GET ENDING VALUE
 LDL RETSTK
 STNL R1
 LDL PARSTK ;REMOVE LOOP PARAMETERS
 ADC BPW+BPW
 STL PARSTK
 LDL NEXT
 GCALL


 
#line 1013
 .align
#line 1013
???76
#line 1013
 .dbnz 0X88,"<EXPECT",'>'+0X80
#line 1013
 .align
#line 1013
 .dw ???75
#line 1013
; 76
#line 1013
 ; <EXPECT>
AEXPCT: .DW DOCOL,OVER,PLUS,OVER,ADO
AEXPC1: .DW KEY,DUP,LIT,8,EQUAL,OVER
 .DW LIT,0177,EQUAL,ORR,ZBRAN
AEXPCZ .DW AEXPC4-AEXPCZ
 .DW DROP,DUP,IDO,EQUAL,DUP,FROMR
 .DW TWOM,PLUS,TOR,ZBRAN
AEXPCY .DW AEXPC2-AEXPCY,LIT
 .DW 7,BRAN
AEXPCX .DW AEXPC3-AEXPCX
AEXPC2: .DW LIT,8,DUP,EMIT,LIT,ABL
 .DW EMIT
AEXPC3: .DW BRAN
AEXPCW .DW AEXPC7-AEXPCW
AEXPC4: .DW DUP,LIT,015,EQUAL,ZBRAN
AEXPCV .DW AEXPC5-AEXPCV
 .DW LEAVE,DROP,BL,ZERO,BRAN
AEXPCU .DW AEXPC6-AEXPCU
AEXPC5: .DW DUP
AEXPC6: .DW IDO,CSTOR,ZERO,IDO,ONEP,CSTOR
AEXPC7: .DW EMIT,ONE,AUPLOP
AEXPCS .DW AEXPC1-AEXPCS,DROP,EXIT

 
#line 1036
 .align
#line 1036
???77
#line 1036
 .dbnz 0X86,"<FILL",'>'+0X80
#line 1036
 .align
#line 1036
 .dw ???76
#line 1036
; 77
#line 1036
 ; <FILL>
AFILL: .DW AFILL+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDL P1 ;GET COUNT
 LDC 0
 GT ;1 IF COUNT > 0
 CJ @AFIL08 ;BRANCH IF COUNT <= 0

AFIL04: LDL P0 ;FILL VALUE
 LDL P2 ;ADDRESS
 SB
 LDL P2
 ADC 1
 STL P2 ;INCREMENT ADDRESS

 LDL P1 ;CHECK IF DONE
 ADC -1
 STL P1
 LDL P1
 EQC 0
 CJ @AFIL04

AFIL08: LDL PT0 ;RESTORE PSA POINTER
 AJW 3 ;REMOVE PARAMETERS
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

; ENTRY TOS DICTIONARY POINTER
; UNDER STRING POINTER

; EXIT TOS 0 NOT FOUND
; 1 MATCH
; UNDER COUNT & TYPE IFF MATCH
; THIRD PFA POINTER IFF MATCH

 
#line 1075
 .align
#line 1075
???78
#line 1075
 .dbnz 0X86,"<FIND",'>'+0X80
#line 1075
 .align
#line 1075
 .dw ???77
#line 1075
; 78
#line 1075
 ; <FIND>
AFIND: .DW AFIND+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDL P1 ;STRING ADDRESS
 STL PT1
 LDL P0 ;DICTIONARY ADDRESS
 STL P1

AFIN02: LDL P1
 LB ;GET LENGTH BYTE FROM DICTIONARY
 STL P0 ;SAVE LENGTH & TYPE BITS
 LDL P0
 LDC 0X3F ;MASK FOR JUST LENGTH
 AND
 STL PT2 ;SAVE LENGTH

 LDL PT2 ;GET LENGTH FROM DICTIONARY
 LDL PT1
 LB ;LENGTH FROM STRING
 DIFF
 EQC 0
 CJ @AFIN05 ;BRANCH IF WRONG LENGTH

 LDL PT1 ;START OF STRING
 STL PT3 ;SAVE HERE FOR ADDRESS INCREMENTS

AFIN04: LDL PT2 ;CHECK COUNT
 CJ @AFIN07

 LDL PT2
 ADC -1
 STL PT2

 LDL PT3
 ADC 1 ;INCREMENT STRING POINTER
 STL PT3
 LDL PT3
 LB ;GET BYTE FROM STRING

 LDL P1
 ADC 1 ;INCREMENT DICTIONARY POINTER
 STL P1
 LDL P1
 LB ;GET BYTE FROM DICTIONARY
 DIFF
 CJ @AFIN04 ;BRANCH IF MATCH

 LDL P1
 LB ;GET BYTE FROM DICTIONARY AGAIN
 LDC 0X7F
 AND ;CHECK FOR LAST BYTE
 LDL PT3 ;BYTE FROM STRING AGAIN
 LB
 DIFF
 CJ @AFIN07 ;JUMP IF LAST BYTE
 J @AFIN06

AFIN05: LDL P1
 ADC 1 ;INCREMENT DICTIONARY POINTER
 STL P1
AFIN06: LDL P1
 LB ;GET BYTE FROM DICTIONARY
 LDC 0X80 ;CHECK FOR LAST BYTE IN ENTRY
 AND
 CJ @AFIN05

 LDL P1 ;CURRENT DICTIONARY POINTER
 WCNT ;POINT TO START OF CURRENT WORD
 BCNT
 ADC BPW ;POINT TO DICTIONARY LINK
 LDNL 0
 STL P1
 LDL P1 ;NEW DICTIONARY POINTER = NULL
 EQC 0
 CJ @AFIN02 ;BRANCH IF ANOTHER SYMBOL
 LDL PT0 ;GET PSA POINTER
 AJW 1
 LDC 0
 STL P0 ;INDICATE NO MATCH
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

AFIN07: LDL P1 ;DICTIONARY ADDRESS
 WCNT ;ROUND TO WORD BOUNDRY
 BCNT
 ADC BPW+BPW+BPW ;SKIP POINTERS
 STL P1 ;SAVE PFA OF ENTRY
 LDL PT0 ;GET PSA POINTER
 AJW -1
 LDC 1
 STL P0 ;INDICATE MATCH
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 1175
 .align
#line 1175
???79
#line 1175
 .dbnz 0X80+11,"<INTERPRET",'>'+0X80
#line 1175
 .align
#line 1175
 .dw ???78
#line 1175
; 79
#line 1175
 ; <INTERPRET>
AINTER: .DW DOCOL
AINTR1: .DW DFIND,ZBRAN
AINTRZ .DW AINTR4-AINTRZ,STATE,AT,LESS
 .DW ZBRAN
AINTRY .DW AINTR2-AINTRY,CFA,COMMA,BRAN
AINTRX .DW AINTR3-AINTRX
AINTR2: .DW CFA,EXEC
AINTR3: .DW BRAN
AINTRW .DW AINTR6-AINTRW
AINTR4: .DW HERE,NUM,DPL,AT,ONEP,ZBRAN
AINTRV .DW AINTR5-AINTRV,DLITE,BRAN
AINTRU .DW AINTR6-AINTRU
AINTR5: .DW DROP,LITER
AINTR6: .DW QSTAC,BRAN
AINTRT .DW AINTR1-AINTRT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1194
 .align
#line 1194
???80
#line 1194
 .dbnz 0X86,"<LINE",'>'+0X80
#line 1194
 .align
#line 1194
 .dw ???79
#line 1194
; 80
#line 1194
 ; <LINE>
ALINE: .DW DOCOL,BLOCK,SWAP,CSLL,STAR,PLUS
 .DW CSLL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1200
 .align
#line 1200
???81
#line 1200
 .dbnz 0X86,"<LOAD",'>'+0X80
#line 1200
 .align
#line 1200
 .dw ???80
#line 1200
; 81
#line 1200
 ; <LOAD>
ALOAD: .DW DOCOL,QDUP,NOTT,AABRTQ
 .DBNZ 10,"UNLOADABLE"
 .ALIGN
 .DW BLK,AT,TOR,TOIN,AT,TOR
 .DW ZERO,TOIN,STORE,BLK,STORE,INTER
 .DW FROMR,TOIN,STORE,FROMR,BLK,STORE
 .DW EXIT

 
#line 1209
 .align
#line 1209
???82
#line 1209
 .dbnz 0X86,"<LOOP",'>'+0X80
#line 1209
 .align
#line 1209
 .dw ???81
#line 1209
; 82
#line 1209
 ; <LOOP>
ALOOP: .DW ALOOP+BPW
 LDL PARSTK
 LDNL P0 ;GET INCREMENT

 LDL RETSTK
 GAJW
 STL RT0 ;SAVE PSA POINTER

 LDL R0 ;CURRENT INDEX
 ADC 1
 STL R0 ;UPDATE INDEX

 LDL R1 ;FINAL INDEX
 LDL R0 ;UPDATED INDEX
 GT ;1 IFF FINAL > CURRENT
 CJ @ALOOP8 ;BRANCH IF CURRENT >= FINAL

 LDL RT0 ;RESTORE PSA POINTER
 GAJW ;POINT BACK TO PSA
 LDL IP
 LDL IP
 LDNL 0 ;GET BRANCH OFFSET
 BSUB ;"ADD"
 STL IP
 LDL NEXT
 GCALL
 LDC 0 ;!!!!!FILLER!!!!!!

ALOOP8: LDL RT0 ;GET PSA POINTER
 AJW 2 ;REMOVE LOOP PARAMETERS
 GAJW
 STL RETSTK
 LDL IP ;GET FORTH PC
 ADC BPW ;SKIP BRANCH VALUE
 STL IP
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1250
 .align
#line 1250
???83
#line 1250
 .dbnz 0X88,"<NUMBER",'>'+0X80
#line 1250
 .align
#line 1250
 .dw ???82
#line 1250
; 83
#line 1250
 ; <NUMBER>
ANUM: .DW DOCOL,ZERO,ZERO,ROT,DUP,ONEP
 .DW CAT,LIT,AMINUS,EQUAL,DUP,TOR
 .DW PLUS,LIT,-1,DPL,STORE,CONV
 .DW DUP,CAT,BL,GREAT,ZBRAN
ANUMZ .DW ANUM1-ANUMZ
 .DW DUP,CAT,LIT,ADOT,EQUAL,NOTT
 .DW AABRTQ
 .DBNZ 14,"NOT RECOGNIZED"
 .ALIGN
 .DW ZERO,DPL,STORE,CONV,DUP,CAT
 .DW BL,GREAT,AABRTQ
 .DBNZ 14,"NOT RECOGNIZED"
 .ALIGN
ANUM1: .DW DROP,FROMR,ZBRAN
ANUMY .DW ANUM2-ANUMY,DNEG
ANUM2: .DW EXIT

 
#line 1268
 .align
#line 1268
???84
#line 1268
 .dbnz 0X86,"<PAGE",'>'+0X80
#line 1268
 .align
#line 1268
 .dw ???83
#line 1268
; 84
#line 1268
 ; <PAGE>
APAGE: .DW DOCOL,CR,EXIT

 
#line 1303
;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1305
 .align
#line 1305
???85
#line 1305
 .dbnz 0X80+14,"<VOCABULARY79",'>'+0X80
#line 1305
 .align
#line 1305
 .dw ???84
#line 1305
; 85
#line 1305
 ; <VOCABULARY79>
AV79: .DW DOCOL,CREATE,LIT,VLINK,COMMA,LIT
 .DW FORTH+BPW,COMMA,HERE,VOCL,AT,COMMA
 .DW VOCL,STORE,ASCODE
DOVOC: .DW 0X0F67A,DODOES,CELLP,CONT,STORE,EXIT

 
#line 1311
 .align
#line 1311
???86
#line 1311
 .dbnz 0X80+15,"<VOCABULARYFIG",'>'+0X80
#line 1311
 .align
#line 1311
 .dw ???85
#line 1311
; 86
#line 1311
 ; <VOCABULARYFIG>
AVFIG: .DW DOCOL,CREATE,LIT,VLINK,COMMA,CURR
 .DW AT,CFA,COMMA,HERE,VOCL,AT
 .DW COMMA,VOCL,STORE,ASCODE
 .DW 0X0F67A,DODOES,CELLP
 .DW CONT,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1320
 .align
#line 1320
???87
#line 1320
 .dbnz 0X86,"<WORD",'>'+0X80
#line 1320
 .align
#line 1320
 .dw ???86
#line 1320
; 87
#line 1320
 ; <WORD>
AWORD: .DW DOCOL,TSTREM,SWAP,ENCL,DDUP,GREAT
 .DW ZBRAN
AWORDZ .DW AWORD1-AWORDZ,DDROP,DDROP,ZERO,HERE
 .DW STORE,BRAN
AWORDY .DW AWORD2-AWORDY
AWORD1: .DW TOIN,PSTOR,OVER,SUBB,DUP,TOR
 .DW HERE,CSTOR,PLUS,HERE,ONEP,FROMR
 .DW DUP,LIT,0377,GREAT,AABRTQ
 .DBNZ 11,"INPUT > 255"
 .ALIGN
 .DW ONEP,CMOVE
AWORD2: .DW HERE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1336
 .align
#line 1336
???88
#line 1336
 .dbnz 0X81,'='+0X80,0
#line 1336
 .align
#line 1336
 .dw ???87
#line 1336
; 88
#line 1336
 ; =
EQUAL: .DW DOCOL,SUBB,NOTT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1341
 .align
#line 1341
???89
#line 1341
 .dbnz 0X81,'>'+0X80,0
#line 1341
 .align
#line 1341
 .dw ???88
#line 1341
; 89
#line 1341
 ; >
GREAT: .DW DOCOL,SWAP,LESS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1346
 .align
#line 1346
???90
#line 1346
 .dbnz 0X83,">I",'N'+0X80
#line 1346
 .align
#line 1346
 .dw ???89
#line 1346
; 90
#line 1346
 ; >IN
TOIN: .DW DOUSE,27

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1351
 .align
#line 1351
???91
#line 1351
 .dbnz 0X82,">",'R'+0X80
#line 1351
 .align
#line 1351
 .dw ???90
#line 1351
; 91
#line 1351
 ; >R
TOR: .DW TOR+BPW
 LDL PARSTK
 LDNL P0 ;GET TOP OF PARAMETER STACK
 LDL RETSTK
 ADC -BPW ;ALLOCATE ITEM
 STL RETSTK
 LDL RETSTK
 STNL R0
 LDL PARSTK
 ADC BPW ;REMOVE FROM PARAMETER STACK
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 1366
 .align
#line 1366
???92
#line 1366
 .dbnz 0X81,'?'+0X80,0
#line 1366
 .align
#line 1366
 .dw ???91
#line 1366
; 92
#line 1366
 ; ?
QUES: .DW DOCOL,AT,DOT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1371
 .align
#line 1371
???93
#line 1371
 .dbnz 0X85,"?COM",'P'+0X80
#line 1371
 .align
#line 1371
 .dw ???92
#line 1371
; 93
#line 1371
 ; ?COMP
QCOMP: .DW DOCOL,STATE,AT,NOTT,AABRTQ
 .DBNZ 12,"COMPILE ONLY"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 



;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1384
 .align
#line 1384
???94
#line 1384
 .dbnz 0X84,"?CS",'P'+0X80
#line 1384
 .align
#line 1384
 .dw ???93
#line 1384
; 94
#line 1384
 ; ?CSP
QCSP: .DW DOCOL,SPAT,CSP,AT,SUBB,AABRTQ
 .DBNZ 23,"DEFINITION NOT FINISHED"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1392
 .align
#line 1392
???95
#line 1392
 .dbnz 0X84,"?DU",'P'+0X80
#line 1392
 .align
#line 1392
 .dw ???94
#line 1392
; 95
#line 1392
 ; ?DUP
QDUP: .DW DOCOL,DUP,ZBRAN
QDUPZ .DW QDUP1-QDUPZ,DUP
QDUP1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1399
 .align
#line 1399
???96
#line 1399
 .dbnz 0X88,"?LOADIN",'G'+0X80
#line 1399
 .align
#line 1399
 .dw ???95
#line 1399
; 96
#line 1399
 ; ?LOADING
QLOAD: .DW DOCOL,BLK,AT,NOTT,AABRTQ
 .DBNZ 12,"LOADING ONLY"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1407
 .align
#line 1407
???97
#line 1407
 .dbnz 0X86,"?PAIR",'S'+0X80
#line 1407
 .align
#line 1407
 .dw ???96
#line 1407
; 97
#line 1407
 ; ?PAIRS
QPAIR: .DW DOCOL,SUBB,AABRTQ
 .DBNZ 23,"CONDITIONALS NOT PAIRED"
 .ALIGN
 .DW EXIT

 
#line 1413
 .align
#line 1413
???98
#line 1413
 .dbnz 0X86,"?STAC",'K'+0X80
#line 1413
 .align
#line 1413
 .dw ???97
#line 1413
; 98
#line 1413
 ; ?STACK
QSTAC: .DW DOCOL,SPAT,SZERO,SWAP,ULESS,AABRTQ
 .DBNZ 19,"STACK OUT OF BOUNDS"
 .ALIGN
 .DW SPAT,HERE,LIT,100*BPW,PLUS,ULESS
 .DW AABRTQ
 .DBNZ 10,"FULL STACK"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1425
 .align
#line 1425
???99
#line 1425
 .dbnz 0X87,"?STREA",'M'+0X80
#line 1425
 .align
#line 1425
 .dw ???98
#line 1425
; 99
#line 1425
 ; ?STREAM
QSTREA: .DW DOCOL,AABRTQ
 .DBNZ 22,"INPUT STREAM EXHAUSTED"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1433
 .align
#line 1433
???100
#line 1433
 .dbnz 0X89,"?TERMINA",'L'+0X80
#line 1433
 .align
#line 1433
 .dw ???99
#line 1433
; 100
#line 1433
 ; ?TERMINAL
QTERM: .DW DOCOL,TQTERM,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1438
 .align
#line 1438
???101
#line 1438
 .dbnz 0X81,'@'+0X80,0
#line 1438
 .align
#line 1438
 .dw ???100
#line 1438
; 101
#line 1438
 ; @
AT: .DW AT+BPW
 LDL PARSTK
 LDNL P0
 LDNL 0
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1450
 .align
#line 1450
???102
#line 1450
 .dbnz 0X85,"ABOR",'T'+0X80
#line 1450
 .align
#line 1450
 .dw ???101
#line 1450
; 102
#line 1450
 ; ABORT
ABORT: .DW DOCOL,TABORT,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1455
 .align
#line 1455
???103
#line 1455
 .dbnz 0XC6,"ABORT",'"'+0X80
#line 1455
 .align
#line 1455
 .dw ???102
#line 1455
; 103
#line 1455
 ; ABORT"
ABORTQ: .DW DOCOL,QCOMP,COMP,AABRTQ,TSTREM,CAT
 .DW LIT,042,EQUAL,ZBRAN
ABORTZ .DW ABORQ1-ABORTZ,ONE
 .DW TOIN,PSTOR,ZERO,COMMA,BRAN
ABORTY .DW ABORQ2-ABORTY
ABORQ1: .DW LIT,042,WORD,DUP,CAT,ONEP
 .DW SWAP,OVER,PLUS,CAT,LIT,042
 .DW EQUAL,NOTT,QSTREA,ALLOT
ABORQ2: .DW EXIT

 
#line 1466
 .align
#line 1466
???104
#line 1466
 .dbnz 0X83,"AB",'S'+0X80
#line 1466
 .align
#line 1466
 .dw ???103
#line 1466
; 104
#line 1466
 ; ABS
ABS: .DW DOCOL,DUP,PM,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1471
 .align
#line 1471
???105
#line 1471
 .dbnz 0XC5,"AGAI",'N'+0X80
#line 1471
 .align
#line 1471
 .dw ???104
#line 1471
; 105
#line 1471
 ; AGAIN
AGAIN: .DW DOCOL,ONE,QPAIR,COMP,BRAN,HERE
 .DW SUBB,COMMA,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1477
 .align
#line 1477
???106
#line 1477
 .dbnz 0X85,"ALIG",'N'+0X80
#line 1477
 .align
#line 1477
 .dw ???105
#line 1477
; 106
#line 1477
 ; ALIGN
ALIGN: .DW ALIGN+BPW
 LDL PARSTK
 LDNL P0 ;TOP OF PARAMETER STACK
 ADC BPW-1
 WCNT
 BCNT
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1491
 .align
#line 1491
???107
#line 1491
 .dbnz 0X85,"ALLO",'T'+0X80
#line 1491
 .align
#line 1491
 .dw ???106
#line 1491
; 107
#line 1491
 ; ALLOT
ALLOT: .DW DOCOL,ALIGN,DP,PSTOR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1496
 .align
#line 1496
???108
#line 1496
 .dbnz 0X83,"AN",'D'+0X80
#line 1496
 .align
#line 1496
 .dw ???107
#line 1496
; 108
#line 1496
 ; AND
ANDD: .DW ANDD+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 AND
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 1510
 .align
#line 1510
???109
#line 1510
 .dbnz 0X84,"BAS",'E'+0X80
#line 1510
 .align
#line 1510
 .dw ???108
#line 1510
; 109
#line 1510
 ; BASE
BASE: .DW DOUSE,28

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1515
 .align
#line 1515
???110
#line 1515
 .dbnz 0XC5,"BEGI",'N'+0X80
#line 1515
 .align
#line 1515
 .dw ???109
#line 1515
; 110
#line 1515
 ; BEGIN
BEGIN: .DW DOCOL,QCOMP,HERE,ONE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1520
 .align
#line 1520
???111
#line 1520
 .dbnz 0X82,"B",'L'+0X80
#line 1520
 .align
#line 1520
 .dw ???110
#line 1520
; 111
#line 1520
 ; BL
BL: .DW DOCON,ABL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1525
 .align
#line 1525
???112
#line 1525
 .dbnz 0X85,"BLAN",'K'+0X80
#line 1525
 .align
#line 1525
 .dw ???111
#line 1525
; 112
#line 1525
 ; BLANK
BLANK: .DW DOCOL,BL,FILL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1530
 .align
#line 1530
???113
#line 1530
 .dbnz 0X83,"BL",'K'+0X80
#line 1530
 .align
#line 1530
 .dw ???112
#line 1530
; 113
#line 1530
 ; BLK
BLK: .DW DOUSE,29

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1535
 .align
#line 1535
???114
#line 1535
 .dbnz 0X87,"BLK/DR",'V'+0X80
#line 1535
 .align
#line 1535
 .dw ???113
#line 1535
; 114
#line 1535
 ; BLK/DRV
BPDR: .DW DOVAR,0,0,0,0,0,0,0

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1540
 .align
#line 1540
???115
#line 1540
 .dbnz 0X85,"BLOC",'K'+0X80
#line 1540
 .align
#line 1540
 .dw ???114
#line 1540
; 115
#line 1540
 ; BLOCK
BLOCK: .DW DOCOL,TBLOCK,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1545
 .align
#line 1545
???116
#line 1545
 .dbnz 0X86,"BRANC",'H'+0X80
#line 1545
 .align
#line 1545
 .dw ???115
#line 1545
; 116
#line 1545
 ; BRANCH
BRAN: .DW BRAN+BPW
 LDL IP ;GET FORTH PC
 LDL IP
 LDNL 0 ;GET BRANCH OFFSET
 BSUB ;"ADD"
 STL IP ;SAVE NEW PC
 LDL NEXT
 GCALL

 
#line 1555
 .align
#line 1555
???117
#line 1555
 .dbnz 0X86,"BUFFE",'R'+0X80
#line 1555
 .align
#line 1555
 .dw ???116
#line 1555
; 117
#line 1555
 ; BUFFER
BUFFE: .DW DOCOL,USEE,AT,PREV,AT,EQUAL
 .DW ZBRAN
BUFFZ .DW BUFF1-BUFFZ,USEE,AT,PBUF,DROP
 .DW USEE,STORE
BUFF1: .DW USEE,AT,DUP,TOR
BUFF2: .DW PBUF,ZBRAN
BUFFY .DW BUFF2-BUFFY,USEE,STORE,RAT
 .DW AT,ZLESS,ZBRAN
BUFFX .DW BUFF3-BUFFX,RAT,CELLP
 .DW RAT,AT,LIT,MAXINT,ANDD,ZERO
 .DW RSLW
BUFF3: .DW RAT,STORE,RAT,PREV,STORE,FROMR
 .DW CELLP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 




;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 



;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1583
 .align
#line 1583
???118
#line 1583
 .dbnz 0X82,"C",'!'+0X80
#line 1583
 .align
#line 1583
 .dw ???117
#line 1583
; 118
#line 1583
 ; CSTORE
CSTOR: .DW CSTOR+BPW
 LDL PARSTK
 GAJW
 LDL P1
 LDL P0
 SB
 AJW 2
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 



;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1603
 .align
#line 1603
???119
#line 1603
 .dbnz 0X83,"C/",'L'+0X80
#line 1603
 .align
#line 1603
 .dw ???118
#line 1603
; 119
#line 1603
 ; C/L
CSLL: .DW DOCON,0100

 
#line 1606
 .align
#line 1606
???120
#line 1606
 .dbnz 0X82,"C",'@'+0X80
#line 1606
 .align
#line 1606
 .dw ???119
#line 1606
; 120
#line 1606
 ; C@
CAT: .DW CAT+BPW
 LDL PARSTK
 LDNL P0
 LB
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1618
 .align
#line 1618
???121
#line 1618
 .dbnz 0X84,"CEL",'L'+0X80
#line 1618
 .align
#line 1618
 .dw ???120
#line 1618
; 121
#line 1618
 ; CELL
CELL: .DW DOCON,BPW

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1623
 .align
#line 1623
???122
#line 1623
 .dbnz 0X85,"CELL",'-'+0X80
#line 1623
 .align
#line 1623
 .dw ???121
#line 1623
; 122
#line 1623
 ; CELLM
CELLM: .DW CELLM+BPW
 LDL PARSTK
 LDNL P0
 ADC -BPW
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1635
 .align
#line 1635
???123
#line 1635
 .dbnz 0X85,"CELL",'+'+0X80
#line 1635
 .align
#line 1635
 .dw ???122
#line 1635
; 123
#line 1635
 ; CELLP
CELLP: .DW CELLP+BPW
 LDL PARSTK
 LDNL P0
 ADC BPW
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1647
 .align
#line 1647
???124
#line 1647
 .dbnz 0X83,"CF",'A'+0X80
#line 1647
 .align
#line 1647
 .dw ???123
#line 1647
; 124
#line 1647
 ; CFA
CFA: .DW DOCOL,CELLM,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1652
 .align
#line 1652
???125
#line 1652
 .dbnz 0X86,"CHANG",'E'+0X80
#line 1652
 .align
#line 1652
 .dw ???124
#line 1652
; 125
#line 1652
 ; CHANGE
CHANGE: .DW DOCOL,FREEZE,LIMIT,LIT,HDBT,NOBUF
 .DW STAR,SUBB,DUP,LIT,FIRST+BPW,STORE
 .DW LIT,US,SUBB,DUP,LIT,INTUSR+BPW,STORE
 .DW LIT,RTS,SUBB,DUP,LIT,INTUSR,STORE
 .DW LIT,INTUSR+BPW+BPW,STORE
 .DW LIT,_forth,DUP,CELLP,GO

 
#line 1660
 .align
#line 1660
???126
#line 1660
 .dbnz 0X85,"CLEA",'R'+0X80
#line 1660
 .align
#line 1660
 .dw ???125
#line 1660
; 126
#line 1660
 ; CLEAR
CLEAR: .DW DOCOL,OFSET,AT,PLUS,BUFFE,LIT
 .DW 02000,BL,FILL,UPDAT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1666
 .align
#line 1666
???127
#line 1666
 .dbnz 0X85,"CMOV",'E'+0X80
#line 1666
 .align
#line 1666
 .dw ???126
#line 1666
; 127
#line 1666
 ; CMOVE
CMOVE: .DW DOCOL,DUP,ONE,LESS,ZBRAN
CMOVEZ .DW CMOVE1-CMOVEZ
 .DW DDROP,DROP,BRAN
CMOVEY .DW CMOVE2-CMOVEY
CMOVE1: .DW ACMOVE
CMOVE2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1676
 .align
#line 1676
???128
#line 1676
 .dbnz 0X84,"COL",'D'+0X80
#line 1676
 .align
#line 1676
 .dw ???127
#line 1676
; 128
#line 1676
 ; COLD
COLD: .DW DOCOL,LIT,INT4TH,AT,LIT
 .DW FORTH+BPW+BPW,STORE,COLDX

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1682
 .align
#line 1682
???129
#line 1682
 .dbnz 0X85,"COLD",'X'+0X80
#line 1682
 .align
#line 1682
 .dw ???128
#line 1682
; 129
#line 1682
 ; COLDX
COLDX: .DW DOCOL,MTBUF,LIT,INTUSR,UPP
 .DW LIT,3*BPW,PLUS,LIT,(39-3)*BPW
 .DW CMOVE

 .DW IOSTRT ;START SPECIAL I/O

; .DW ONE,DENSTY,STORE ****STAND ALONE I/O
 .DW FIRST,USEE
 .DW STORE,FIRST,PREV,STORE,DR0,ZERO
 .DW EPRINT,STORE,CR,ADOTQ
 .DBNZ 59
COLD1: .DBNZ "T-FORTH VERSION 6 - COPYRIGHT 1988 BY COGENT RESEARCH, INC."
COLD2: .ALIGN
 .DW CR,DEC,ABORT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1700
 .align
#line 1700
???130
#line 1700
 .dbnz 0X87,"COMPIL",'E'+0X80
#line 1700
 .align
#line 1700
 .dw ???129
#line 1700
; 130
#line 1700
 ; COMPILE
COMP: .DW DOCOL,QCOMP,FROMR,DUP,CELLP,TOR
 .DW AT,COMMA,EXIT

 
#line 1704
 .align
#line 1704
???131
#line 1704
 .dbnz 0X89,"CONFIGUR",'E'+0X80
#line 1704
 .align
#line 1704
 .dw ???130
#line 1704
; 131
#line 1704
 ; CONFIGURE
CONF: .DW DOCOL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1709
 .align
#line 1709
???132
#line 1709
 .dbnz 0X88,"CONSTAN",'T'+0X80
#line 1709
 .align
#line 1709
 .dw ???131
#line 1709
; 132
#line 1709
 ; CONSTANT
CON: .DW DOCOL,CREATE,COMMA,ASCODE
DOCON: LDL W
 ADC BPW
 LDNL 0
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1724
 .align
#line 1724
???133
#line 1724
 .dbnz 0X87,"CONTEX",'T'+0X80
#line 1724
 .align
#line 1724
 .dw ???132
#line 1724
; 133
#line 1724
 ; CONTEXT
CONT: .DW DOUSE,30

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1729
 .align
#line 1729
???134
#line 1729
 .dbnz 0X87,"CONVER",'T'+0X80
#line 1729
 .align
#line 1729
 .dw ???133
#line 1729
; 134
#line 1729
 ; CONVERT
CONV: .DW DOCOL
CONV1: .DW ONEP,DUP,TOR,CAT,BASE,AT
 .DW DIGIT,ZBRAN
CONVZ .DW CONV3-CONVZ,SWAP,BASE,AT
 .DW USTAR,DROP,ROT,BASE,AT,USTAR
 .DW DPLUS,DPL,AT,ONEP,ZBRAN
CONVY .DW CONV2-CONVY
 .DW ONE,DPL,PSTOR
CONV2: .DW FROMR,BRAN
CONVX .DW CONV1-CONVX
CONV3: .DW FROMR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1744
 .align
#line 1744
???135
#line 1744
 .dbnz 0X85,"COUN",'T'+0X80
#line 1744
 .align
#line 1744
 .dw ???134
#line 1744
; 135
#line 1744
 ; COUNT
COUNT: .DW DOCOL,DUP,ONEP,SWAP,CAT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1749
 .align
#line 1749
???136
#line 1749
 .dbnz 0X82,"C",'R'+0X80
#line 1749
 .align
#line 1749
 .dw ???135
#line 1749
; 136
#line 1749
 ; CR
CR: .DW DOCOL,TCR,AT,EXEC,EXIT

 
#line 1752
 .align
#line 1752
???137
#line 1752
 .dbnz 0X86,"CREAT",'E'+0X80
#line 1752
 .align
#line 1752
 .dw ???136
#line 1752
; 137
#line 1752
 ; CREATE
CREATE: .DW DOCOL,BL,WORD,DUP,DUP,ONEP
 .DW CAT,ZERO,EQUAL,AABRTQ
 .DBNZ 26,"ATTEMPTED TO REDEFINE NULL"
 .ALIGN
 .DW DUP,CONT,AT,AT,AFIND,ZBRAN
CREAZ .DW CREA1-CREAZ,DDROP,WARN,AT,ZBRAN
CREAY .DW CREA1-CREAY
 .DW DUP,COUNT,TYPE,SPACE,ADOTQ
 .DBNZ 13,"ISN'T UNIQUE "
 .ALIGN
CREA1: .DW CAT,WIDTH,AT,MIN,DDUP,PLUS
 .DW ONEP,BL,OVER,CSTOR
 .DW ONEP,BL,OVER,CSTOR
 .DW ONEP,BL,SWAP,CSTOR
 .DW DUP,ONEP,ALLOT,OVER,PLUS,LIT,0200,TOGGL
 .DW DUP,LIT,0200,TOGGL,LATES,COMMA,CELL
 .DW ALLOT,CURR,AT,STORE,ASCODE
DOVAR: LDL W
 ADC BPW
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1782
 .align
#line 1782
???138
#line 1782
 .dbnz 0X83,"CS",'P'+0X80
#line 1782
 .align
#line 1782
 .dw ???137
#line 1782
; 138
#line 1782
 ; CSP
CSP: .DW DOUSE,31

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1787
 .align
#line 1787
???139
#line 1787
 .dbnz 0X87,"CURREN",'T'+0X80
#line 1787
 .align
#line 1787
 .dw ???138
#line 1787
; 139
#line 1787
 ; CURRENT
CURR: .DW DOUSE,32

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1792
 .align
#line 1792
???140
#line 1792
 .dbnz 0X82,"D",'!'+0X80
#line 1792
 .align
#line 1792
 .dw ???139
#line 1792
; 140
#line 1792
 ; DSTORE
DSTOR: .DW DSTOR+BPW
 LDL PARSTK
 GAJW
 LDL P1 ;HIGH WORD
 LDL P0 ;ADDRESS
 STNL 0
 LDL P2 ;LOW WORD
 LDL P0
 STNL 1
 AJW 3
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 1808
 .align
#line 1808
???141
#line 1808
 .dbnz 0X82,"D",'+'+0X80
#line 1808
 .align
#line 1808
 .dw ???140
#line 1808
; 141
#line 1808
 ; D+
DPLUS: .DW DPLUS+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDC 0 ;INITIAL CARRY
 LDL P3 ;LOW BITS
 LDL P1
 LSUM
 STL P3

 LDL P2 ;HIGH BITS
 LDL P0
 LSUM
 STL P2

 LDL PT0 ;RESTORE PSA POINTER
 AJW 2
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1834
 .align
#line 1834
???142
#line 1834
 .dbnz 0X83,"D+",'-'+0X80
#line 1834
 .align
#line 1834
 .dw ???141
#line 1834
; 142
#line 1834
 ; D+-
DPM: .DW DOCOL,ZLESS,ZBRAN
DPMZ .DW DPM1-DPMZ,DNEG
DPM1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1841
 .align
#line 1841
???143
#line 1841
 .dbnz 0X82,"D",'.'+0X80
#line 1841
 .align
#line 1841
 .dw ???142
#line 1841
; 143
#line 1841
 ; D.
DDOT: .DW DOCOL,ZERO,DDOTR,SPACE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1846
 .align
#line 1846
???144
#line 1846
 .dbnz 0X83,"D.",'R'+0X80
#line 1846
 .align
#line 1846
 .dw ???143
#line 1846
; 144
#line 1846
 ; D.R
DDOTR: .DW DOCOL,DEPTH,LIT,3,LESS,AABRTQ
 .DBNZ 11,"EMPTY STACK"
 .ALIGN
 .DW TOR,SWAP,OVER,DUP,DPM,BDIGS
 .DW DIGS,ROT,SIGN,EDIGS,FROMR,OVER
 .DW SUBB,SPACS,TYPE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1856
 .align
#line 1856
???145
#line 1856
 .dbnz 0X82,"D",'<'+0X80
#line 1856
 .align
#line 1856
 .dw ???144
#line 1856
; 145
#line 1856
 ; D<
DLESS: .DW DOCOL,ROT,DDUP,EQUAL,ZBRAN
DLESSZ .DW DLESS1-DLESSZ
 .DW ROT,ROT,DNEG,DPLUS,ZLESS,BRAN
DLESSY .DW DLESS2-DLESSY
DLESS1: .DW SWAP,LESS,SWAP,DROP
DLESS2: .DW SWAP,DROP,EXIT

 
#line 1864
 .align
#line 1864
???146
#line 1864
 .dbnz 0X84,"DAB",'S'+0X80
#line 1864
 .align
#line 1864
 .dw ???145
#line 1864
; 146
#line 1864
 ; DABS
DABS: .DW DOCOL,DUP,DPM,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1869
 .align
#line 1869
???147
#line 1869
 .dbnz 0X85,"DDRO",'P'+0X80
#line 1869
 .align
#line 1869
 .dw ???146
#line 1869
; 147
#line 1869
 ; DDROP
DDROP: .DW DDROP+BPW
 LDL PARSTK
 ADC BPW+BPW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1879
 .align
#line 1879
???148
#line 1879
 .dbnz 0X84,"DDU",'P'+0X80
#line 1879
 .align
#line 1879
 .dw ???147
#line 1879
; 148
#line 1879
 ; DDUP
DDUP: .DW DDUP+BPW
 LDL PARSTK
 GAJW
 AJW -2
 LDL P3 ;LOW BITS
 STL P1
 LDL P2 ;HIGH BITS
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1895
 .align
#line 1895
???149
#line 1895
 .dbnz 0X87,"DECIMA",'L'+0X80
#line 1895
 .align
#line 1895
 .dw ???148
#line 1895
; 149
#line 1895
 ; DECIMAL
DEC: .DW DOCOL,LIT,10,BASE,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1900
 .align
#line 1900
???150
#line 1900
 .dbnz 0X80+11,"DEFINITION",'S'+0X80
#line 1900
 .align
#line 1900
 .dw ???149
#line 1900
; 150
#line 1900
 ; DEFINITIONS
DEFIN: .DW DOCOL,CONT,AT,CURR,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 







;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1915
 .align
#line 1915
???151
#line 1915
 .dbnz 0X85,"DEPT",'H'+0X80
#line 1915
 .align
#line 1915
 .dw ???150
#line 1915
; 151
#line 1915
 ; DEPTH
DEPTH: .DW DOCOL,SPAT,SZERO,SWAP,SUBB,CELL,SLASH,EXIT

 
#line 1918
 .align
#line 1918
???152
#line 1918
 .dbnz 0X85,"DIGI",'T'+0X80
#line 1918
 .align
#line 1918
 .dw ???151
#line 1918
; 152
#line 1918
 ; DIGIT
DIGIT: .DW DIGIT+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDL P1 ;GET CURRENT CHARACTER
 ADC -'0' ;REMOVE ASCII 0
 STL P1
 LDL P1
 LDC -1
 GT ;1 IF DIGIT > -1
 CJ @DIGIT8 ;BRANCH IF < 0

 LDL P1
 LDC 9
 GT ;1 IF DIGIT > 9
 CJ @DIGIT4 ;BRANCH IF NUMBER

 LDL P1
 ADC -'A'+'9'+1 ;MAKE 0-9:A-F CONTIGIOUS
 STL P1
 LDL P1
 LDC 9
 GT ;1 IF VALUE > 9
 CJ @DIGIT8 ;BRANCH IF '9' < DIGIT < 'A'

DIGIT4: LDL P0 ;CURRENT BASE
 LDL P1 ;BINARY VALUE OF DIGIT
 GT ;1 IF BASE > DIGIT
 CJ @DIGIT8 ;BRANCH IF BASE <= CURRENT DIGIT

DIGIT6: LDC 1
 STL P0 ;RETURN TRUE
 LDL PT0 ;PSA POINTER
 GAJW
 LDL NEXT
 GCALL

DIGIT8: LDL PT0 ;PSA POINTER
 AJW 1
 LDC 0
 STL P0 ;RETURN FALSE
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 1965
 .align
#line 1965
???153
#line 1965
 .dbnz 0X8A,"DISK-ERRO",'R'+0X80
#line 1965
 .align
#line 1965
 .dw ???152
#line 1965
; 153
#line 1965
 ; DISK-ERROR
DSKERR: .DW DOVAR
DKERR: .DW 0

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1971
 .align
#line 1971
???154
#line 1971
 .dbnz 0XC8,"DLITERA",'L'+0X80
#line 1971
 .align
#line 1971
 .dw ???153
#line 1971
; 154
#line 1971
 ; DLITERAL
DLITE: .DW DOCOL,STATE,AT,ZBRAN
DLITEZ .DW DLITE1-DLITEZ,SWAP
 .DW LITER,LITER
DLITE1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 1979
 .align
#line 1979
???155
#line 1979
 .dbnz 0X87,"DNEGAT",'E'+0X80
#line 1979
 .align
#line 1979
 .dw ???154
#line 1979
; 155
#line 1979
 ; DNEGATE
DNEG: .DW DNEG+BPW
 LDL PARSTK
 GAJW
 STL PT0

 LDC 1 ;INITIAL CARRY FOR INCREMENT
 LDL P1 ;LOW BITS
 NOT
 LDC 0
 LSUM
 STL P1

 LDL P0
 NOT
 BSUB ;'ADD' CARRY FROM LOW BITS
 STL P0
 LDL PT0
 GAJW
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2003
 .align
#line 2003
???156
#line 2003
 .dbnz 0XC2,"D",'O'+0X80
#line 2003
 .align
#line 2003
 .dw ???155
#line 2003
; 156
#line 2003
 ; DO
DO: .DW DOCOL,COMP,ADO,HERE,LIT,3
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2009
 .align
#line 2009
???157
#line 2009
 .dbnz 0XC5,"DOES",'>'+0X80
#line 2009
 .align
#line 2009
 .dw ???156
#line 2009
; 157
#line 2009
 ; DOES>
DOES: .DW DOCOL,QCSP,COMP,ASCODE,LIT,0X0F67A
 .DW COMMA,COMP,DODOES,EXIT
DODOES: LDL W ;MOV W,-(PS)
 ADC BPW
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 2022
 .align
#line 2022
???158
#line 2022
 .dbnz 0X82,"D",'P'+0X80
#line 2022
 .align
#line 2022
 .dw ???157
#line 2022
; 158
#line 2022
 ; DP
DP: .DW DOUSE,9

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2027
 .align
#line 2027
???159
#line 2027
 .dbnz 0X83,"DP",'L'+0X80
#line 2027
 .align
#line 2027
 .dw ???158
#line 2027
; 159
#line 2027
 ; DPL
DPL: .DW DOUSE,33

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 



;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2037
 .align
#line 2037
???160
#line 2037
 .dbnz 0X83,"DR",'0'+0X80
#line 2037
 .align
#line 2037
 .dw ???159
#line 2037
; 160
#line 2037
 ; DR0
DR0: .DW DOCOL,ZERO,OFSET,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2042
 .align
#line 2042
???161
#line 2042
 .dbnz 0X83,"DR",'1'+0X80
#line 2042
 .align
#line 2042
 .dw ???160
#line 2042
; 161
#line 2042
 ; DR1
DR1: .DW DOCOL,LIT,5000,OFSET,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

; 
#line 2047
 .align
#line 2047
???162
#line 2047
 .dbnz 0X85,"DRIV",'E'+0X80
#line 2047
 .align
#line 2047
 .dw ???161
#line 2047
; 162
#line 2047
 ; DRIVE
;DRIVE: .DW DOVAR,00

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2052
 .align
#line 2052
???163
#line 2052
 .dbnz 0X84,"DRO",'P'+0X80
#line 2052
 .align
#line 2052
 .dw ???162
#line 2052
; 163
#line 2052
 ; DROP
DROP: .DW DROP+BPW
 LDL PARSTK
 ADC BPW
 STL PARSTK
 LDL NEXT
 GCALL

 .align
#line 2060
???164
#line 2060
 .dbnz 0X83,"DU",'P'+0X80
#line 2060
 .align
#line 2060
 .dw ???163
#line 2060
; 164
#line 2060
 ; DUP
DUP: .DW DUP+BPW
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 LDNL P1
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2074
 .align
#line 2074
???165
#line 2074
 .dbnz 0XC4,"ELS",'E'+0X80
#line 2074
 .align
#line 2074
 .dw ???164
#line 2074
; 165
#line 2074
 ; ELSE
ELSEE: .DW DOCOL,TWO,QPAIR,COMP,BRAN,HERE
 .DW ZERO,COMMA,SWAP,TWO,THENN,TWO
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2081
 .align
#line 2081
???166
#line 2081
 .dbnz 0X84,"EMI",'T'+0X80
#line 2081
 .align
#line 2081
 .dw ???165
#line 2081
; 166
#line 2081
 ; EMIT
EMIT: .DW DOCOL,TEMIT,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2086
 .align
#line 2086
???167
#line 2086
 .dbnz 0X80+13,"EMPTY-BUFFER",'S'+0X80
#line 2086
 .align
#line 2086
 .dw ???166
#line 2086
; 167
#line 2086
 ; EMPTY-BUFFERS
MTBUF: .DW DOCOL,FIRST,LIMIT,OVER,SUBB,ZERO
 .DW AFILL,NOBUF,ZERO,ADO
MTBUF1: .DW LIT,MAXINT,LIT,HDBT,IDO,STAR
 .DW FIRST,PLUS,STORE,ALOOP
MTBUFZ .DW MTBUF1-MTBUFZ,EXIT

; ENCLOSE
; ENTRY TOP DELIMITER
; TEXT ADDRESS

; EXIT TOP OFFSET TO NEXT CHARACTER TO PROCESS
; OFFSET TO END OF TOKEN
; OFFSET TO FIRST CHARACTER OF TOKEN
; TEXT ADDRESS

 
#line 2102
 .align
#line 2102
???168
#line 2102
 .dbnz 0X87,"ENCLOS",'E'+0X80
#line 2102
 .align
#line 2102
 .dw ???167
#line 2102
; 168
#line 2102
 ; ENCLOSE
ENCL: .DW ENCL+BPW
 LDL PARSTK
 GAJW
 AJW -2
 STL PT0

 LDL P3 ;TEXT ADDRESS
 ADC -1
 STL PT1 ;SAVE FOR REFERENCE HERE

 LDL P2 ;DELIMITER
 STL PT2

 LDC -1
 STL P2 ;OFFSET TO START OF TOKEN

ENCL04: LDL P2
 ADC 1 ;COUNT OFFSET TO START OF TOKEN
 STL P2

 LDL PT1
 ADC 1 ;INCREMENT TEXT STRING POINTER
 STL PT1
 LDL PT1
 LB ;GET CHARACTER FROM TEXT STRING
 LDL PT2 ;DELIMITER
 DIFF
 CJ @ENCL04 ;BRANCH IF LEADING DELIMITER

 LDL PT1 ;CHECK FOR EMPTY STRING
 LB
 CJ @ENCL16 ;BRANCH IF EMPTY STRING

 LDL P2
 STL P1 ;INITIAL OFFSET TO END OF TOKEN

ENCL08: LDL PT1
 ADC 1 ;INCREMENT STRING POINTER
 STL PT1

 LDL P1
 ADC 1 ;INCREMENT OFFSET TO END OF TOKEN
 STL P1

 LDL PT1
 LB ;GET BYTE FROM STRING
 STL PT4

 LDL PT4
 CJ @ENCL20 ;BRANCH IF NUL

 LDL PT4 ;BYTE FROM STRING AGAIN
 LDL PT2 ;DELIMITER
 DIFF
 EQC 0
 CJ @ENCL08 ;BRANCH IF NOT DELIMITER

 LDL P1 ;OFFSET TO END OF TOKEN
 ADC 1
 J @ENCL24

ENCL16: LDL P2 ;OFFSET SINCE START
 ADC 1
 STL P1 ;MAKE EMPTY STRING HAVE LENGTH OF 1
 LDL P2 ;PROCESS NULL AGAIN IF BUG
 J @ENCL24

ENCL20: LDL P1 ;END OF STRING IS
ENCL24: STL P0 ;OFFSET TO NEXT CHARACTER TO PROCESS
 LDL PT0 ;GET PSA POINTER
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 2178
 .align
#line 2178
???169
#line 2178
 .dbnz 0X86,"EPRIN",'T'+0X80
#line 2178
 .align
#line 2178
 .dw ???168
#line 2178
; 169
#line 2178
 ; EPRINT
EPRINT: .DW DOVAR
EPRFLG: .DW 0

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2184
 .align
#line 2184
???170
#line 2184
 .dbnz 0X87,"EXECUT",'E'+0X80
#line 2184
 .align
#line 2184
 .dw ???169
#line 2184
; 170
#line 2184
 ; EXECUTE
EXEC: .DW EXEC+BPW
 LDL PARSTK ;MOV (PS)+,W
 LDNL P0 ;INSTRUCTION POINTER
 STL W ;SAVE FOR ;CODE WORDS
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK
 LDL W ;GET CODE FIELD POINTER FOR NEXT WORD
 LDNL 0
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2198
 .align
#line 2198
???171
#line 2198
 .dbnz 0X84,"EXI",'T'+0X80
#line 2198
 .align
#line 2198
 .dw ???170
#line 2198
; 171
#line 2198
 ; EXIT
EXIT: .DW EXIT+BPW
 LDL RETSTK ;MOV (RS)+,IP
 LDNL R0 ;TOP OF RETURN STACK
 STL IP
 LDL RETSTK
 ADC BPW ;POP THE STACK
 STL RETSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2211
 .align
#line 2211
???172
#line 2211
 .dbnz 0X86,"EXPEC",'T'+0X80
#line 2211
 .align
#line 2211
 .dw ???171
#line 2211
; 172
#line 2211
 ; EXPECT
EXPEC: .DW DOCOL,TEXPCT,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2216
 .align
#line 2216
???173
#line 2216
 .dbnz 0X85,"FENC",'E'+0X80
#line 2216
 .align
#line 2216
 .dw ???172
#line 2216
; 173
#line 2216
 ; FENCE
FENCE: .DW DOUSE,8

 
#line 2219
 .align
#line 2219
???174
#line 2219
 .dbnz 0X84,"FIL",'L'+0X80
#line 2219
 .align
#line 2219
 .dw ???173
#line 2219
; 174
#line 2219
 ; FILL
FILL: .DW DOCOL,OVER,ZGREAT,ZBRAN
FILLZ .DW FILL1-FILLZ,AFILL
 .DW BRAN
FILLY .DW FILL2-FILLY
FILL1: .DW DDROP,DROP
FILL2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2229
 .align
#line 2229
???175
#line 2229
 .dbnz 0X84,"FIN",'D'+0X80
#line 2229
 .align
#line 2229
 .dw ???174
#line 2229
; 175
#line 2229
 ; FIND
FIND: .DW DOCOL,DFIND,ZBRAN
FINDZ .DW FIND1-FINDZ,DROP,CFA
 .DW BRAN
FINDY .DW FIND2-FINDY
FIND1: .DW ZERO
FIND2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


 
#line 2240
 .align
#line 2240
???176
#line 2240
 .dbnz 0X85,"FIRS",'T'+0X80
#line 2240
 .align
#line 2240
 .dw ???175
#line 2240
; 176
#line 2240
 ; FIRST
FIRST: .DW DOCON,BUF1

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2245
 .align
#line 2245
???177
#line 2245
 .dbnz 0X83,"FL",'D'+0X80
#line 2245
 .align
#line 2245
 .dw ???176
#line 2245
; 177
#line 2245
 ; FLD
FLD: .DW DOUSE,34

 
#line 2248
 .align
#line 2248
???178
#line 2248
 .dbnz 0X86,"FORGE",'T'+0X80
#line 2248
 .align
#line 2248
 .dw ???177
#line 2248
; 178
#line 2248
 ; FORGET
FORG: .DW DOCOL,BL,WORD,CURR,AT,AT
 .DW AFIND,ZEQU,AABRTQ
 .DBNZ 25,"NOT IN CURRENT VOCABULARY"
 .ALIGN
 .DW DROP,NFA,DUP,FENCE,AT,ULESS
 .DW AABRTQ
 .DBNZ 23,"IN PROTECTED DICTIONARY"
 .ALIGN
 .DW TOR,RAT,CONT,AT,ULESS,ZBRAN
FORGZ .DW FORG1-FORGZ,FORTH
FORG1: .DW RAT,CURR,AT,ULESS,ZBRAN
FORGY .DW FORG2-FORGY
 .DW FORTH,DEFIN
FORG2: .DW VOCL,AT
FORG3: .DW RAT,OVER,ULESS,ZBRAN
FORGW .DW FORG4-FORGW
 .DW AT,BRAN
FORGU .DW FORG3-FORGU
FORG4: .DW DUP,VOCL,STORE
FORG5: .DW DUP,CELLM,CELLM
FORG6: .DW PFA,LFA,AT,DUP,RAT,ULESS
 .DW ZBRAN
FORGV .DW FORG6-FORGV,OVER,CELLM,STORE,AT
 .DW QDUP,ZEQU,ZBRAN
FORGT .DW FORG5-FORGT,FROMR,DP
 .DW STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2278
 .align
#line 2278
???179
#line 2278
 .dbnz 0XC5,"FORT",'H'+0X80
#line 2278
 .align
#line 2278
 .dw ???178
#line 2278
; 179
#line 2278
 ; FORTH
FORTH: .DW DOVOC,VLINK,LSTSYM,0

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2283
 .align
#line 2283
???180
#line 2283
 .dbnz 0X86,"FREEZ",'E'+0X80
#line 2283
 .align
#line 2283
 .dw ???179
#line 2283
; 180
#line 2283
 ; FREEZE
FREEZE: .DW DOCOL,UPP,LIT,3*BPW
 .DW PLUS,LIT,INTUSR,LIT,24*BPW,CMOVE
 .DW LIT,FORTH+BPW+BPW,AT,LIT,INT4TH
 .DW STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2291
 .align
#line 2291
???181
#line 2291
 .dbnz 0X82,"G",'O'+0X80
#line 2291
 .align
#line 2291
 .dw ???180
#line 2291
; 181
#line 2291
 ; GO
GO: .DW GO+BPW
 LDL PARSTK ;MOV (PS)+,PC
 GAJW
 LDL P0 ;INSTRUCTION POINTER
 LDL P1 ;NEW WPTR
 GAJW
 REV ;NEW PC TO TOP
 GCALL

 
#line 2301
 .align
#line 2301
???182
#line 2301
 .dbnz 0X84,"HER",'E'+0X80
#line 2301
 .align
#line 2301
 .dw ???181
#line 2301
; 182
#line 2301
 ; HERE
HERE: .DW DOCOL,DP,AT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2306
 .align
#line 2306
???183
#line 2306
 .dbnz 0X83,"HE",'X'+0X80
#line 2306
 .align
#line 2306
 .dw ???182
#line 2306
; 183
#line 2306
 ; HEX
HEX: .DW DOCOL,LIT,16,BASE,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2311
 .align
#line 2311
???184
#line 2311
 .dbnz 0X83,"HL",'D'+0X80
#line 2311
 .align
#line 2311
 .dw ???183
#line 2311
; 184
#line 2311
 ; HLD
HLD: .DW DOUSE,35

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2316
 .align
#line 2316
???185
#line 2316
 .dbnz 0X84,"HOL",'D'+0X80
#line 2316
 .align
#line 2316
 .dw ???184
#line 2316
; 185
#line 2316
 ; HOLD
HOLD: .DW DOCOL,LIT,-1,HLD,PSTOR,HLD
 .DW AT,CSTOR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2322
 .align
#line 2322
???186
#line 2322
 .dbnz 0X81,'I'+0X80,0
#line 2322
 .align
#line 2322
 .dw ???185
#line 2322
; 186
#line 2322
 ; I
IDO: .DW IDO+BPW
 LDL RETSTK ;MOV (RS),-(PS)
 LDNL R0
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2336
 .align
#line 2336
???187
#line 2336
 .dbnz 0X82,"I",0X27+0X80
#line 2336
 .align
#line 2336
 .dw ???186
#line 2336
; 187
#line 2336
 ; I'
IPDO: .DW IPDO+BPW
 LDL RETSTK ;MOV 2(RS),-(PS)
 LDNL R1
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2350
 .align
#line 2350
???188
#line 2350
 .dbnz 0XC2,"I",'F'+0X80
#line 2350
 .align
#line 2350
 .dw ???187
#line 2350
; 188
#line 2350
 ; IF
IFF: .DW DOCOL,COMP,ZBRAN,HERE,ZERO,COMMA
 .DW TWO,EXIT

 
#line 2354
 .align
#line 2354
???189
#line 2354
 .dbnz 0X89,"IMMEDIAT",'E'+0X80
#line 2354
 .align
#line 2354
 .dw ???188
#line 2354
; 189
#line 2354
 ; IMMEDIATE
IMMED: .DW DOCOL,LATES,LIT,0100,TOGGL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2359
 .align
#line 2359
???190
#line 2359
 .dbnz 0X80+10,"INIT-FORT",'H'+0X80
#line 2359
 .align
#line 2359
 .dw ???189
#line 2359
; 190
#line 2359
 ; INIT-FORTH
IFORTH: .DW DOCON,INT4TH

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2364
 .align
#line 2364
???191
#line 2364
 .dbnz 0X89,"INIT-USE",'R'+0X80
#line 2364
 .align
#line 2364
 .dw ???190
#line 2364
; 191
#line 2364
 ; INIT-USER
IUSER: .DW DOCON,INTUSR

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2369
 .align
#line 2369
???192
#line 2369
 .dbnz 0X89,"INTERPRE",'T'+0X80
#line 2369
 .align
#line 2369
 .dw ???191
#line 2369
; 192
#line 2369
 ; INTERPRET
INTER: .DW DOCOL,TINTER,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2374
 .align
#line 2374
???193
#line 2374
 .dbnz 0X81,'J'+0X80,0
#line 2374
 .align
#line 2374
 .dw ???192
#line 2374
; 193
#line 2374
 ; J
JDO: .DW JDO+BPW
 LDL RETSTK ;MOV 4(RS),-(PS)
 LDNL R2
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2388
 .align
#line 2388
???194
#line 2388
 .dbnz 0X83,"KE",'Y'+0X80
#line 2388
 .align
#line 2388
 .dw ???193
#line 2388
; 194
#line 2388
 ; KEY
KEY: .DW DOCOL,TKEY,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2393
 .align
#line 2393
???195
#line 2393
 .dbnz 0X86,"LATES",'T'+0X80
#line 2393
 .align
#line 2393
 .dw ???194
#line 2393
; 195
#line 2393
 ; LATEST
LATES: .DW DOCOL,CURR,AT,AT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2398
 .align
#line 2398
???196
#line 2398
 .dbnz 0X85,"LEAV",'E'+0X80
#line 2398
 .align
#line 2398
 .dw ???195
#line 2398
; 196
#line 2398
 ; LEAVE
LEAVE: .DW LEAVE+BPW
 LDL RETSTK ;MOV (RS),2(RS)
 LDNL R0
 LDL RETSTK
 STNL R1
 LDL NEXT
 GCALL

 
#line 2407
 .align
#line 2407
???197
#line 2407
 .dbnz 0X83,"LF",'A'+0X80
#line 2407
 .align
#line 2407
 .dw ???196
#line 2407
; 197
#line 2407
 ; LFA
LFA: .DW DOCOL,LIT,2*BPW,SUBB,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2412
 .align
#line 2412
???198
#line 2412
 .dbnz 0X85,"LIMI",'T'+0X80
#line 2412
 .align
#line 2412
 .dw ???197
#line 2412
; 198
#line 2412
 ; LIMIT
LIMIT: .DW DOCON,EM

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2417
 .align
#line 2417
???199
#line 2417
 .dbnz 0X84,"LIS",'T'+0X80
#line 2417
 .align
#line 2417
 .dw ???198
#line 2417
; 199
#line 2417
 ; LIST
LIST: .DW DOCOL,CR,DUP,SCR,STORE,ADOTQ
 .DBNZ 5,"SCR #"
 .ALIGN
 .DW UDOT,LIT,16,ZERO,ADO
LIST1: .DW CR,RAT,LIT,3,DOTR,SPACE
 .DW RAT,SCR,AT,DLINE,QTERM,ZBRAN
LISTZ .DW LIST2-LISTZ,LEAVE
LIST2: .DW ALOOP
LISTY .DW LIST1-LISTY,CR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2430
 .align
#line 2430
???200
#line 2430
 .dbnz 0X83," I",'T'+0X80
#line 2430
 .align
#line 2430
 .dw ???199
#line 2430
; 200
#line 2430
 ; LIT
LIT: .DW LIT+BPW
 LDL IP ;MOV (IP)+,-(PS)
 LDNL 0
 LDL PARSTK
 ADC -BPW ;ALLOCATE ENTRY
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL IP
 ADC BPW ;SKIP CONSTANT
 STL IP
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2447
 .align
#line 2447
???201
#line 2447
 .dbnz 0XC7,"LITERA",'L'+0X80
#line 2447
 .align
#line 2447
 .dw ???200
#line 2447
; 201
#line 2447
 ; LITERAL
LITER: .DW DOCOL,STATE,AT,ZBRAN
LITERZ .DW LITER1-LITERZ,COMP
 .DW LIT,COMMA
LITER1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2455
 .align
#line 2455
???202
#line 2455
 .dbnz 0X84,"LOA",'D'+0X80
#line 2455
 .align
#line 2455
 .dw ???201
#line 2455
; 202
#line 2455
 ; LOAD
LOAD: .DW DOCOL,TLOAD,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2460
 .align
#line 2460
???203
#line 2460
 .dbnz 0XC4,"LOO",'P'+0X80
#line 2460
 .align
#line 2460
 .dw ???202
#line 2460
; 203
#line 2460
 ; LOOP
LOOP: .DW DOCOL,LIT,3,QPAIR,COMP,ALOOP
 .DW HERE,SUBB,COMMA,EXIT

 
#line 2464
 .align
#line 2464
???204
#line 2464
 .dbnz 0X82,"M",'*'+0X80
#line 2464
 .align
#line 2464
 .dw ???203
#line 2464
; 204
#line 2464
 ; M*
MSTAR: .DW DOCOL,DDUP,XORR,TOR,ABS,SWAP
 .DW ABS,USTAR,FROMR,DPM,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2470
 .align
#line 2470
???205
#line 2470
 .dbnz 0X83,"M*",'/'+0X80
#line 2470
 .align
#line 2470
 .dw ???204
#line 2470
; 205
#line 2470
 ; M*/
MSTARS: .DW DOCOL,DDUP,XORR,SWAP,ABS,TOR
 .DW SWAP,ABS,TOR,OVER,XORR,ROT
 .DW ROT,DABS,SWAP,RAT,USTAR,ROT
 .DW FROMR,USTAR,ROT,ZERO,DPLUS,RAT
 .DW USMOD,ROT,ROT,FROMR,USMOD,SWAP
 .DW DROP,SWAP,ROT,DPM,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2480
 .align
#line 2480
???206
#line 2480
 .dbnz 0X82,"M",'+'+0X80
#line 2480
 .align
#line 2480
 .dw ???205
#line 2480
; 206
#line 2480
 ; M+
MPLUS: .DW DOCOL,STOD,DPLUS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2485
 .align
#line 2485
???207
#line 2485
 .dbnz 0X82,"M",'/'+0X80
#line 2485
 .align
#line 2485
 .dw ???206
#line 2485
; 207
#line 2485
 ; M/
MSLAS: .DW DOCOL,OVER,TOR,TOR,DUP,DPM
 .DW RAT,ABS,USMOD,FROMR,RAT,XORR
 .DW PM,SWAP,FROMR,PM,SWAP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2492
 .align
#line 2492
???208
#line 2492
 .dbnz 0X85,"M/MO",'D'+0X80
#line 2492
 .align
#line 2492
 .dw ???207
#line 2492
; 208
#line 2492
 ; M/MOD
MSMOD: .DW DOCOL,TOR,ZERO,RAT,USMOD,FROMR
 .DW SWAP,TOR,USMOD,FROMR,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2498
 .align
#line 2498
???209
#line 2498
 .dbnz 0X83,"MA",'X'+0X80
#line 2498
 .align
#line 2498
 .dw ???208
#line 2498
; 209
#line 2498
 ; MAX
MAX: .DW DOCOL,DDUP,LESS,ZBRAN
MAXZ .DW MAX1-MAXZ,SWAP
MAX1: .DW DROP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 


;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2510
 .align
#line 2510
???210
#line 2510
 .dbnz 0X83,"MI",'N'+0X80
#line 2510
 .align
#line 2510
 .dw ???209
#line 2510
; 210
#line 2510
 ; MIN
MIN: .DW DOCOL,DDUP,GREAT,ZBRAN
MINZ .DW MIN1-MINZ,SWAP
MIN1: .DW DROP,EXIT

 
#line 2515
 .align
#line 2515
???211
#line 2515
 .dbnz 0X83,"MO",'D'+0X80
#line 2515
 .align
#line 2515
 .dw ???210
#line 2515
; 211
#line 2515
 ; MOD
MODD: .DW DOCOL,SLMOD,DROP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2520
 .align
#line 2520
???212
#line 2520
 .dbnz 0X84,"MOV",'E'+0X80
#line 2520
 .align
#line 2520
 .dw ???211
#line 2520
; 212
#line 2520
 ; MOVE
MOVE: .DW DOCOL,ZERO,MAX,CELL,STAR,ACMOVE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2525
 .align
#line 2525
???213
#line 2525
 .dbnz 0X86,"NEGAT",'E'+0X80
#line 2525
 .align
#line 2525
 .dw ???212
#line 2525
; 213
#line 2525
 ; NEGATE
NEG: .DW NEG+BPW
 LDL PARSTK
 LDNL P0
 NOT
 ADC 1
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2538
 .align
#line 2538
???214
#line 2538
 .dbnz 0X83,"NF",'A'+0X80
#line 2538
 .align
#line 2538
 .dw ???213
#line 2538
; 214
#line 2538
 ; NFA
NFA: .DW DOCOL,CELLM,CELLM,LIT,-1,TRAV,LIT,-1,TRAV,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2543
 .align
#line 2543
???215
#line 2543
 .dbnz 0X83,"NO",'T'+0X80
#line 2543
 .align
#line 2543
 .dw ???214
#line 2543
; 215
#line 2543
 ; NOT
NOTT: .DW NOTT+BPW
 LDL PARSTK
 LDNL P0
 EQC 0
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2555
 .align
#line 2555
???216
#line 2555
 .dbnz 0X86,"NUMBE",'R'+0X80
#line 2555
 .align
#line 2555
 .dw ???215
#line 2555
; 216
#line 2555
 ; NUMBER
NUM: .DW DOCOL,TNUM,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2560
 .align
#line 2560
???217
#line 2560
 .dbnz 0X86,"OFFSE",'T'+0X80
#line 2560
 .align
#line 2560
 .dw ???216
#line 2560
; 217
#line 2560
 ; OFFSET
OFSET: .DW DOUSE,36

 
#line 2563
 .align
#line 2563
???218
#line 2563
 .dbnz 0X82,"O",'R'+0X80
#line 2563
 .align
#line 2563
 .dw ???217
#line 2563
; 218
#line 2563
 ; OR
ORR: .DW ORR+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 OR
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2579
 .align
#line 2579
???219
#line 2579
 .dbnz 0X83,"OU",'T'+0X80
#line 2579
 .align
#line 2579
 .dw ???218
#line 2579
; 219
#line 2579
 ; OUT
OUTT: .DW DOUSE,37

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2584
 .align
#line 2584
???220
#line 2584
 .dbnz 0X84,"OVE",'R'+0X80
#line 2584
 .align
#line 2584
 .dw ???219
#line 2584
; 220
#line 2584
 ; OVER
OVER: .DW OVER+BPW
 LDL PARSTK
 GAJW
 LDL P1
 AJW -1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2598
 .align
#line 2598
???221
#line 2598
 .dbnz 0X83,"PA",'D'+0X80
#line 2598
 .align
#line 2598
 .dw ???220
#line 2598
; 221
#line 2598
 ; PAD
PAD: .DW DOCOL,HERE,LIT,0X84,PLUS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2603
 .align
#line 2603
???222
#line 2603
 .dbnz 0X84,"PAG",'E'+0X80
#line 2603
 .align
#line 2603
 .dw ???221
#line 2603
; 222
#line 2603
 ; PAGE
PAGEE: .DW DOCOL,TPAGE,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2608
 .align
#line 2608
???223
#line 2608
 .dbnz 0X83,"PF",'A'+0X80
#line 2608
 .align
#line 2608
 .dw ???222
#line 2608
; 223
#line 2608
 ; PFA
PFA: .DW DOCOL,ONE,TRAV,LIT,BPW+BPW+1,PLUS,ALIGN,EXIT

 
#line 2611
 .align
#line 2611
???224
#line 2611
 .dbnz 0X84,"PIC",'K'+0X80
#line 2611
 .align
#line 2611
 .dw ???223
#line 2611
; 224
#line 2611
 ; PICK
PICK: .DW DOCOL,DUP,ONE,LESS,AABRTQ
 .DBNZ 021,"PICK ARGUMENT < 1"
 .ALIGN
 .DW CELL,STAR,SPAT,PLUS,AT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

;PKEY IS AT THE END WITH SYSTEM DEPENDENT CODE
;POUT IS AT THE END WITH SYSTEM DEPENDENT CODE

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2624
 .align
#line 2624
???225
#line 2624
 .dbnz 0X82,"P",'P'+0X80
#line 2624
 .align
#line 2624
 .dw ???224
#line 2624
; 225
#line 2624
 ; PP
PP: .DW DOCOL,DUP,LIT,-16,ANDD,AABRTQ
 .DBNZ 012,"OFF SCREEN"
 .ALIGN
 .DW ONE,TEXT,PAD,ONEP,SWAP,SCR
 .DW AT,ALINE,CMOVE,UPDAT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2633
 .align
#line 2633
???226
#line 2633
 .dbnz 0X84,"PRE",'V'+0X80
#line 2633
 .align
#line 2633
 .dw ???225
#line 2633
; 226
#line 2633
 ; PREV
PREV: .DW DOVAR,BUF1

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2638
 .align
#line 2638
???227
#line 2638
 .dbnz 0X85,"QUER",'Y'+0X80
#line 2638
 .align
#line 2638
 .dw ???226
#line 2638
; 227
#line 2638
 ; QUERY
QUERY: .DW DOCOL,TIB,AT,LIT,0120,EXPEC
 .DW ZERO,TOIN,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2644
 .align
#line 2644
???228
#line 2644
 .dbnz 0X84,"QUI",'T'+0X80
#line 2644
 .align
#line 2644
 .dw ???227
#line 2644
; 228
#line 2644
 ; QUIT
QUIT: .DW DOCOL,ZERO,BLK,STORE,LBRAC
QUIT1: .DW RPSTO,ADOTQ ;THIS IS DIFFERENT THAN
 .DBNZ 6," <1>OK" ;THE QUIT IN' ALL ABOUT
 ;FORTH' ITS MINOR BUT		
 .ALIGN ;I LIKE THIS ALOT
 .DW CR ;BETTER
QUIT2: .DW QUERY,INTER,STATE,AT
 .DW ZBRAN
QUITZ .DW QUIT1-QUITZ,BRAN
QUITY .DW QUIT2-QUITY

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2658
 .align
#line 2658
???229
#line 2658
 .dbnz 0X82,"R",'#'+0X80
#line 2658
 .align
#line 2658
 .dw ???228
#line 2658
; 229
#line 2658
 ; R#
RSHARP: .DW DOUSE,38

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2663
 .align
#line 2663
???230
#line 2663
 .dbnz 0X83,"R/",'W'+0X80
#line 2663
 .align
#line 2663
 .dw ???229
#line 2663
; 230
#line 2663
 ; R/W
RSLW: .DW DOCOL,TRSLW,AT,EXEC,EXIT

 
#line 2666
 .align
#line 2666
???231
#line 2666
 .dbnz 0X82,"R",'0'+0X80
#line 2666
 .align
#line 2666
 .dw ???230
#line 2666
; 231
#line 2666
 ; R0
RZERO: .DW DOUSE,4

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2671
 .align
#line 2671
???232
#line 2671
 .dbnz 0X82,"R",'>'+0X80
#line 2671
 .align
#line 2671
 .dw ???231
#line 2671
; 232
#line 2671
 ; R>
FROMR: .DW FROMR+BPW
 LDL RETSTK ;MOV (RS)+,-(PS)
 LDNL R0
 LDL RETSTK
 ADC BPW
 STL RETSTK
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2688
 .align
#line 2688
???233
#line 2688
 .dbnz 0X82,"R",'@'+0X80
#line 2688
 .align
#line 2688
 .dw ???232
#line 2688
; 233
#line 2688
 ; R@
RAT: .DW IDO+BPW

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2693
 .align
#line 2693
???234
#line 2693
 .dbnz 0XC6,"REPEA",'T'+0X80
#line 2693
 .align
#line 2693
 .dw ???233
#line 2693
; 234
#line 2693
 ; REPEAT
REPEA: .DW DOCOL,TOR,TOR,AGAIN,FROMR,FROMR
 .DW CELLM,THENN,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2699
 .align
#line 2699
???235
#line 2699
 .dbnz 0X84,"ROL",'L'+0X80
#line 2699
 .align
#line 2699
 .dw ???234
#line 2699
; 235
#line 2699
 ; ROLL
ROLL: .DW DOCOL,DUP,ONE,LESS,AABRTQ
 .DBNZ 021,"ROLL ARGUMENT < 1"
 .ALIGN
 .DW ONEP,DUP,PICK,SWAP,CELL,STAR,SPAT
 .DW PLUS
ROLL1: .DW DUP,CELLM,AT,OVER,STORE,CELLM
 .DW SPAT,OVER,ULESS,NOTT,ZBRAN
ROLLZ .DW ROLL1-ROLLZ
 .DW DDROP,EXIT

 
#line 2710
 .align
#line 2710
???236
#line 2710
 .dbnz 0X83,"RO",'T'+0X80
#line 2710
 .align
#line 2710
 .dw ???235
#line 2710
; 236
#line 2710
 ; ROT
ROT: .DW ROT+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P2
 STL P0
 LDL P1
 STL P2
 STL P1
 GAJW
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2726
 .align
#line 2726
???237
#line 2726
 .dbnz 0X83,"RP",'!'+0X80
#line 2726
 .align
#line 2726
 .dw ???236
#line 2726
; 237
#line 2726
 ; RPSTORE
RPSTO: .DW RPSTO+BPW
 LDL UP ;GET USER POINTER
 LDNL 4 ;MOV 10(R0),RS
 ADC -BPW*R0 ;ALLOCATE TEMPS
 STL RETSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2737
 .align
#line 2737
???238
#line 2737
 .dbnz 0X83,"RP",'@'+0X80
#line 2737
 .align
#line 2737
 .dw ???237
#line 2737
; 238
#line 2737
 ; RP@
RPAT: .DW RPAT+BPW
 LDL RETSTK ;MOV RS,-(PS)
 ADC BPW*R0 ;POINT PAST THE TEMPS
 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 2749
 .align
#line 2749
???239
#line 2749
 .dbnz 0X84,"S->",'D'+0X80
#line 2749
 .align
#line 2749
 .dw ???238
#line 2749
; 239
#line 2749
 ; S->D
STOD: .DW STOD+BPW
 LDL PARSTK
 GAJW
 LDL P0
 XDBLE
 STL P0 ;KILL AREG
 AJW -1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2765
 .align
#line 2765
???240
#line 2765
 .dbnz 0X82,"S",'0'+0X80
#line 2765
 .align
#line 2765
 .dw ???239
#line 2765
; 240
#line 2765
 ; S0
SZERO: .DW DOCOL,SPZERO,AT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2770
 .align
#line 2770
???241
#line 2770
 .dbnz 0X80+12,"SAVE-BUFFER",'S'+0X80
#line 2770
 .align
#line 2770
 .dw ???240
#line 2770
; 241
#line 2770
; SAVE-BUFFERS
SAVBUF: .DW DOCOL,NOBUF,ONEP,ZERO,ADO
SAVBF1: .DW LIT,MAXINT,BUFFE
 .DW DROP,ALOOP
SAVBFZ .DW SAVBF1-SAVBFZ,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2778
 .align
#line 2778
???242
#line 2778
 .dbnz 0X83,"SC",'R'+0X80
#line 2778
 .align
#line 2778
 .dw ???241
#line 2778
; 242
#line 2778
 ; SCR
SCR: .DW DOUSE,39

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2799
 
#line 2824
;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2826
 .align
#line 2826
???243
#line 2826
 .dbnz 0X84,"SIG",'N'+0X80
#line 2826
 .align
#line 2826
 .dw ???242
#line 2826
; 243
#line 2826
 ; SIGN
SIGN: .DW DOCOL,ZLESS,ZBRAN
SIGNZ .DW SIGN1-SIGNZ,LIT,AMINUS
 .DW HOLD
SIGN1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2834
 .align
#line 2834
???244
#line 2834
 .dbnz 0X86,"SMUDG",'E'+0X80
#line 2834
 .align
#line 2834
 .dw ???243
#line 2834
; 244
#line 2834
 ; SMUDGE
SMUDG: .DW DOCOL,LATES,LIT,040,TOGGL,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2839
 .align
#line 2839
???245
#line 2839
 .dbnz 0X83,"SP",'!'+0X80
#line 2839
 .align
#line 2839
 .dw ???244
#line 2839
; 245
#line 2839
 ; SPSTORE
SPSTO: .DW SPSTO+BPW
 LDL UP
 LDNL 3 ;MOV 6(R0),PS
 ADC -BPW*P0 ;ALLOCATE THE TEMPS
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2850
 .align
#line 2850
???246
#line 2850
 .dbnz 0X83,"SP",'0'+0X80
#line 2850
 .align
#line 2850
 .dw ???245
#line 2850
; 246
#line 2850
 ; SP0
SPZERO: .DW DOUSE,3

 
#line 2853
 .align
#line 2853
???247
#line 2853
 .dbnz 0X83,"SP",'@'+0X80
#line 2853
 .align
#line 2853
 .dw ???246
#line 2853
; 247
#line 2853
 ; SP@
SPAT: .DW SPAT+BPW
 LDL PARSTK
 ADC BPW*P0 ;POINT PAST THE TEMPS

 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2868
 .align
#line 2868
???248
#line 2868
 .dbnz 0X85,"SPAC",'E'+0X80
#line 2868
 .align
#line 2868
 .dw ???247
#line 2868
; 248
#line 2868
 ; SPACE
SPACE: .DW DOCOL,BL,EMIT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2873
 .align
#line 2873
???249
#line 2873
 .dbnz 0X86,"SPACE",'S'+0X80
#line 2873
 .align
#line 2873
 .dw ???248
#line 2873
; 249
#line 2873
 ; SPACES
SPACS: .DW DOCOL,ZERO,MAX,QDUP,ZBRAN
SPACSZ .DW SPACS2-SPACSZ
 .DW ZERO,ADO
SPACS1: .DW SPACE,ALOOP
SPACSY .DW SPACS1-SPACSY
SPACS2: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 
#line 2898
;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2900
 .align
#line 2900
???250
#line 2900
 .dbnz 0X85,"STAT",'E'+0X80
#line 2900
 .align
#line 2900
 .dw ???249
#line 2900
; 250
#line 2900
 ; STATE
STATE: .DW DOUSE,40

 
#line 2903
 .align
#line 2903
???251
#line 2903
 .dbnz 0X84,"SWA",'P'+0X80
#line 2903
 .align
#line 2903
 .dw ???250
#line 2903
; 251
#line 2903
 ; SWAP
SWAP: .DW SWAP+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 STL P0
 STL P1
 GAJW
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 









;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2928
 .align
#line 2928
???252
#line 2928
 .dbnz 0X84,"TEX",'T'+0X80
#line 2928
 .align
#line 2928
 .dw ???251
#line 2928
; 252
#line 2928
 ; TEXT
TEXT: .DW DOCOL,HERE,CSLL,ONEP,BLANK,WORD
 .DW BL,OVER,DUP,CAT,PLUS,ONEP
 .DW CSTOR,PAD,CSLL,ONEP,CMOVE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2935
 .align
#line 2935
???253
#line 2935
 .dbnz 0XC4,"THE",'N'+0X80
#line 2935
 .align
#line 2935
 .dw ???252
#line 2935
; 253
#line 2935
 ; THEN
THENN: .DW DOCOL,QCOMP,TWO,QPAIR,HERE,OVER
 .DW SUBB,SWAP,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2941
 .align
#line 2941
???254
#line 2941
 .dbnz 0X83,"TI",'B'+0X80
#line 2941
 .align
#line 2941
 .dw ???253
#line 2941
; 254
#line 2941
 ; TIB
 .DW THENN-8.
TIB: .DW DOUSE,5

 
#line 2945
 .align
#line 2945
???255
#line 2945
 .dbnz 0X86,"TOGGL",'E'+0X80
#line 2945
 .align
#line 2945
 .dw ???254
#line 2945
; 255
#line 2945
 ; TOGGLE
TOGGL: .DW TOGGL+BPW
 LDL PARSTK
 GAJW
 LDL P1 ;MEMORY LOCATION
 LB
 LDL P0 ;XOR MASK
 XOR
 LDL P1
 SB
 AJW 2
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 



;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2968
 .align
#line 2968
???256
#line 2968
 .dbnz 0X88,"TRAVERS",'E'+0X80
#line 2968
 .align
#line 2968
 .dw ???255
#line 2968
; 256
#line 2968
 ; TRAVERSE
TRAV: .DW DOCOL,SWAP
TRAV1: .DW OVER,PLUS,LIT,0177,OVER,CAT
 .DW LESS,ZBRAN
TRAVZ .DW TRAV1-TRAVZ,SWAP,DROP
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 2977
 .align
#line 2977
???257
#line 2977
 .dbnz 0X84,"TYP",'E'+0X80
#line 2977
 .align
#line 2977
 .dw ???256
#line 2977
; 257
#line 2977
 ; TYPE
TYPE: .DW DOCOL,DUP,ZGREAT,ZBRAN
TYPEZ .DW TYPE2-TYPEZ,OVER
 .DW PLUS,SWAP,ADO
TYPE1: .DW IDO,CAT,EMIT,ONE,AUPLOP
TYPEY .DW TYPE1-TYPEY
 .DW BRAN
TYPEX .DW TYPE3-TYPEX
TYPE2: .DW DDROP
TYPE3: .DW EXIT

 
#line 2988
 .align
#line 2988
???258
#line 2988
 .dbnz 0X82,"U",'*'+0X80
#line 2988
 .align
#line 2988
 .dw ???257
#line 2988
; 258
#line 2988
 ; U*
USTAR: .DW USTAR+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDC 0 ;NO CARRY
 LDL P1
 LDL P0
 LMUL
 STL P1 ;SAVE LOWER BITS
 STL P0 ;SAVE UPPER BITS
 LDL PT0
 GAJW
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3006
 .align
#line 3006
???259
#line 3006
 .dbnz 0X82,"U",'.'+0X80
#line 3006
 .align
#line 3006
 .dw ???258
#line 3006
; 259
#line 3006
 ; U.
UDOT: .DW DOCOL,ZERO,DDOT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3011
 .align
#line 3011
???260
#line 3011
 .dbnz 0X85,"U/MO",'D'+0X80
#line 3011
 .align
#line 3011
 .dw ???259
#line 3011
; 260
#line 3011
 ; U/MOD
USMOD: .DW USMOD+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDL P1 ;HIGH BITS
 LDL P2 ;LOW BITS
 LDL P0 ;DIVISIOR
 LDIV
 STL P1 ;RESULT
 STL P2 ;REMAINDER
 LDL PT0
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3031
 .align
#line 3031
???261
#line 3031
 .dbnz 0X82,"U",'<'+0X80
#line 3031
 .align
#line 3031
 .dw ???260
#line 3031
; 261
#line 3031
 ; U<
ULESS: .DW DOCOL,ZERO,SWAP,ZERO,DLESS,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3036
 .align
#line 3036
???262
#line 3036
 .dbnz 0XC5,"UNTI",'L'+0X80
#line 3036
 .align
#line 3036
 .dw ???261
#line 3036
; 262
#line 3036
 ; UNTIL
UNTIL: .DW DOCOL,ONE,QPAIR,COMP,ZBRAN,HERE
 .DW SUBB,COMMA,EXIT

 
#line 3040
 .align
#line 3040
???263
#line 3040
 .dbnz 0X82,"U",'P'+0X80
#line 3040
 .align
#line 3040
 .dw ???262
#line 3040
; 263
#line 3040
 ; UP
UPP: .DW UPP+BPW
 LDL PARSTK
 ADC -BPW ;MAKE ROOM
 STL PARSTK

 LDL UP
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3054
 .align
#line 3054
???264
#line 3054
 .dbnz 0X86,"UPDAT",'E'+0X80
#line 3054
 .align
#line 3054
 .dw ???263
#line 3054
; 264
#line 3054
 ; UPDATE
UPDAT: .DW DOCOL,PREV,AT,AT,LIT,MAXINT+1
 .DW ORR,PREV,AT,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3060
 .align
#line 3060
???265
#line 3060
 .dbnz 0X83,"US",'E'+0X80
#line 3060
 .align
#line 3060
 .dw ???264
#line 3060
; 265
#line 3060
 ; USE
USEE: .DW DOVAR,BUF1

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3065
 .align
#line 3065
???266
#line 3065
 .dbnz 0X84,"USE",'R'+0X80
#line 3065
 .align
#line 3065
 .dw ???265
#line 3065
; 266
#line 3065
 ; USER
USER: .DW DOCOL,CON,ASCODE
DOUSE: LDL W
 LDNL 1 ;MOV (W),-(PS)
 LDL UP
 WSUB ;ADD UP,(PS)

 LDL PARSTK
 ADC -BPW
 STL PARSTK
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3082
 .align
#line 3082
???267
#line 3082
 .dbnz 0X88,"VARIABL",'E'+0X80
#line 3082
 .align
#line 3082
 .dw ???266
#line 3082
; 267
#line 3082
 ; VARIABLE
VAR: .DW DOCOL,CREATE,CELL,ALLOT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3087
 .align
#line 3087
???268
#line 3087
 .dbnz 0X88,"VOC-LIN",'K'+0X80
#line 3087
 .align
#line 3087
 .dw ???267
#line 3087
; 268
#line 3087
 ; VOC-LINK
VOCL: .DW DOUSE,10

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3092
 .align
#line 3092
???269
#line 3092
 .dbnz 0X8A,"VOCABULAR",'Y'+0X80
#line 3092
 .align
#line 3092
 .dw ???268
#line 3092
; 269
#line 3092
 ; VOCABULARY
VOC: .DW DOCOL,TVOCAB,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3097
 .align
#line 3097
???270
#line 3097
 .dbnz 0X87,"WARNIN",'G'+0X80
#line 3097
 .align
#line 3097
 .dw ???269
#line 3097
; 270
#line 3097
 ; WARNING
WARN: .DW DOUSE,7

 
#line 3100
 .align
#line 3100
???271
#line 3100
 .dbnz 0X85,"WHER",'E'+0X80
#line 3100
 .align
#line 3100
 .dw ???270
#line 3100
; 271
#line 3100
 ; WHERE
WHERE: .DW DOCOL,BLK,AT,ZBRAN
WHEREZ .DW WHERE1-WHEREZ,BLK
 .DW AT,DUP,SCR,STORE,CR,CR
 .DW ADOTQ
 .DBNZ 5,"SCR# "
 .ALIGN
 .DW DUP,DOT,TOIN,AT,LIT,01777
 .DW MIN,CSLL,SLMOD,DUP,ADOTQ
 .DBNZ 6,"LINE# "
 .ALIGN
 .DW DOT,CSLL,STAR,ROT,BLOCK,PLUS
 .DW CR,CR,CSLL,DTRAI,TYPE,TOIN
 .DW AT,LIT,01777,GREAT,PLUS,BRAN
WHEREY .DW WHERE2-WHEREY
WHERE1: .DW TOIN,AT
WHERE2: .DW CR,HERE,CAT,DUP,TOR,SUBB
 .DW HERE,RAT,PLUS,ONEP,CAT,LIT
 .DW 040,EQUAL,ZBRAN
WHEREX .DW WHERE3-WHEREX,ONEM
WHERE3: .DW SPACS,FROMR,ZERO,ADO
WHERE4: .DW LIT,0136,EMIT,ALOOP
WHEREW .DW WHERE4-WHEREW,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3126
 .align
#line 3126
???272
#line 3126
 .dbnz 0XC5,"WHIL",'E'+0X80
#line 3126
 .align
#line 3126
 .dw ???271
#line 3126
; 272
#line 3126
 ; WHILE
WHILE: .DW DOCOL,IFF,CELLP,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3131
 .align
#line 3131
???273
#line 3131
 .dbnz 0X85,"WIDT",'H'+0X80
#line 3131
 .align
#line 3131
 .dw ???272
#line 3131
; 273
#line 3131
 ; WIDTH
WIDTH: .DW DOUSE,6

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3136
 .align
#line 3136
???274
#line 3136
 .dbnz 0X84,"WOR",'D'+0X80
#line 3136
 .align
#line 3136
 .dw ???273
#line 3136
; 274
#line 3136
 ; WORD
WORD: .DW DOCOL,TWORD,AT,EXEC,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3141
 .align
#line 3141
???275
#line 3141
 .dbnz 0XC0,0X80,0
#line 3141
 .align
#line 3141
 .dw ???274
#line 3141
; 275
#line 3141
 ; X (NULL)
NULL: .DW DOCOL,BLK,AT,ZBRAN
NULLZ .DW NULL1-NULLZ,STATE
 .DW AT,QSTREA
NULL1: .DW FROMR,DROP,EXIT

 
#line 3147
 .align
#line 3147
???276
#line 3147
 .dbnz 0X83,"XO",'R'+0X80
#line 3147
 .align
#line 3147
 .dw ???275
#line 3147
; 276
#line 3147
 ; XOR
XORR: .DW XORR+BPW
 LDL PARSTK
 GAJW
 LDL P1
 LDL P0
 XOR
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3163
 .align
#line 3163
???277
#line 3163
 .dbnz 0XC1,'['+0X80,0
#line 3163
 .align
#line 3163
 .dw ???276
#line 3163
; 277
#line 3163
 ; [
LBRAC: .DW DOCOL,ZERO,STATE,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3168
 .align
#line 3168
???278
#line 3168
 .dbnz 0XC0+9,"[COMPILE",']'+0X80
#line 3168
 .align
#line 3168
 .dw ???277
#line 3168
; 278
#line 3168
 ; [COMPILE]
BCOMP: .DW DOCOL,QCOMP,DFIND,NOTT,AABRTQ
 .DBNZ 9,"NOT FOUND"
 .ALIGN
 .DW DROP,CFA,COMMA,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3176
 .align
#line 3176
???279
#line 3176
 .dbnz 0X81,']'+0X80,0
#line 3176
 .align
#line 3176
 .dw ???278
#line 3176
; 279
#line 3176
 ; ]
RBRAC: .DW DOCOL,LIT,0300,STATE,STORE,EXIT



 
#line 3181
 .align
#line 3181
???280
#line 3181
 .dbnz 0X84,"-RO",'T'+0X80
#line 3181
 .align
#line 3181
 .dw ???279
#line 3181
; 280
#line 3181
 ; -ROT
MROT: .DW MROT+BPW
 LDL PARSTK
 GAJW
 LDL P2
 LDL P0
 STL P2
 LDL P1
 STL P0
 STL P1
 GAJW
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


 
#line 3198
 .align
#line 3198
???281
#line 3198
 .dbnz 0X84,"LNO",'T'+0X80
#line 3198
 .align
#line 3198
 .dw ???280
#line 3198
; 281
#line 3198
 ; LNOT
LNOT: .DW LNOT+BPW
 LDL PARSTK
 LDNL P0
 NOT ;LOGICAL NOT
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3210
 .align
#line 3210
???282
#line 3210
 .dbnz 0X85,"UNDE",'R'+0X80
#line 3210
 .align
#line 3210
 .dw ???281
#line 3210
; 282
#line 3210
 ; UNDER
UNDER: .DW UNDER+BPW
 LDL PARSTK
 LDNL P0 ;GET TOP OF STACK
 LDL PARSTK
 STNL P1 ;SAVE UNDER TOP
 LDL PARSTK
 ADC BPW ;REMOVE ENTRY
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3224
 .align
#line 3224
???283
#line 3224
 .dbnz 0X86,"ROTAT",'E'+0X80
#line 3224
 .align
#line 3224
 .dw ???282
#line 3224
; 283
#line 3224
 ; ROTATE
ROTATE: .DW ROTATE+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER
 LDC 0
 LDL P0 ;GET COUNT
 GT ;1 IF RIGHT SHIFT
 CJ @ROTAT1
 LDL P1 ;VALUE
 LDC 0
 LDL P0 ;COUNT
 NOT
 ADC 1
 LSHR
 OR
 STL P1 ;NEW TOP OF STACK
 LDL PT0
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

ROTAT1: LDC 0
 LDL P1 ;VALUE
 LDL P0 ;COUNT
 LSHL
 OR
 STL P1
 LDL PT0
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3263
 .align
#line 3263
???284
#line 3263
 .dbnz 0X86,"LSHIF",'T'+0X80
#line 3263
 .align
#line 3263
 .dw ???283
#line 3263
; 284
#line 3263
 ; LSHIFT
LSHIFT: .DW LSHIFT+BPW
 LDL PARSTK
 GAJW
 LDL P1 ;VALUE
 LDL P0 ;COUNT
 SHL
 STL P1
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3279
 .align
#line 3279
???285
#line 3279
 .dbnz 0X86,"RSHIF",'T'+0X80
#line 3279
 .align
#line 3279
 .dw ???284
#line 3279
; 285
#line 3279
 ; RSHIFT
RSHIFT: .DW RSHIFT+BPW
 LDL PARSTK
 GAJW
 LDL P1 ;VALUE
 LDL P0 ;COUNT
 SHR
 STL P1
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 3293
 .align
#line 3293
???286
#line 3293
 .dbnz 0X81,'='+0X80,0
#line 3293
 .align
#line 3293
 .dw ???285
#line 3293
; 286
#line 3293
 ; =
EQ: .DW EQ+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 DIFF
 EQC 0
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL


;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3311
 .align
#line 3311
???287
#line 3311
 .dbnz 0X82,'<','>'+0X80
#line 3311
 .align
#line 3311
 .dw ???286
#line 3311
; 287
#line 3311
 ; <>
NE: .DW NE+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 DIFF
 EQC 0
 EQC 0
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3329
 .align
#line 3329
???288
#line 3329
 .dbnz 0X81,'>'+0X80,0
#line 3329
 .align
#line 3329
 .dw ???287
#line 3329
; 288
#line 3329
 ; >
GTR: .DW GTR+BPW
 LDL PARSTK
 GAJW
 LDL P1
 LDL P0
 GT
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 3343
 .align
#line 3343
???289
#line 3343
 .dbnz 0X82,'>','='+0X80
#line 3343
 .align
#line 3343
 .dw ???288
#line 3343
; 289
#line 3343
 ; >=
GE: .DW GE+BPW
 LDL PARSTK
 GAJW
 LDL P0
 LDL P1
 GT ;1 IF P0 > P1
 EQC 0 ;1 IF P1 >= P0
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3360
 .align
#line 3360
???290
#line 3360
 .dbnz 0X82,'<','='+0X80
#line 3360
 .align
#line 3360
 .dw ???289
#line 3360
; 290
#line 3360
 ; <=
LE: .DW LE+BPW
 LDL PARSTK
 GAJW
 LDL P1
 LDL P0
 GT ;1 IF P1 > P0
 EQC 0 ;1 IF P1 <= P0
 AJW 1
 STL P0
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 3375
 .align
#line 3375
???291
#line 3375
 .dbnz 0X82,"U",'<'+0X80
#line 3375
 .align
#line 3375
 .dw ???290
#line 3375
; 291
#line 3375
 ; U<
UL: .DW UL+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDC 0 ;INITIAL BORROW
 LDL P1
 LDL P0
 LDIFF
 STL P1 ;POP AREG
 STL P1 ;SAVE BORROW AS FLAG
 LDL PT0 ;RESTORE PSA POINTER
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3396
 .align
#line 3396
???292
#line 3396
 .dbnz 0X82,"U",'>'+0X80
#line 3396
 .align
#line 3396
 .dw ???291
#line 3396
; 292
#line 3396
 ; U>
UG: .DW UG+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDC 0 ;INITIAL BORROW
 LDL P0
 LDL P1
 LDIFF
 STL P1 ;POP AREG
 STL P1 ;SAVE BORROW AS FLAG
 LDL PT0 ;RESTORE PSA POINTER
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

 
#line 3415
 .align
#line 3415
???293
#line 3415
 .dbnz 0X83,"U>",'='+0X80
#line 3415
 .align
#line 3415
 .dw ???292
#line 3415
; 293
#line 3415
 ; U>=
UGE: .DW UGE+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDC 0 ;INITIAL BORROW
 LDL P1
 LDL P0
 LDIFF
 STL P1 ;POP AREG
 EQC 0 ;COMPLIMENT BORROW
 STL P1 ;SAVE BORROW AS FLAG
 LDL PT0 ;RESTORE PSA POINTER
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3437
 .align
#line 3437
???294
#line 3437
 .dbnz 0X83,"U<",'='+0X80
#line 3437
 .align
#line 3437
 .dw ???293
#line 3437
; 294
#line 3437
 ; U<=
ULE: .DW ULE+BPW
 LDL PARSTK
 GAJW
 STL PT0 ;SAVE PSA POINTER

 LDC 0 ;INITIAL BORROW
 LDL P0
 LDL P1
 LDIFF
 STL P1 ;POP AREG
 EQC 0 ;COMPLIMENT BORROW
 STL P1 ;SAVE BORROW AS FLAG
 LDL PT0 ;RESTORE PSA POINTER
 AJW 1
 GAJW
 STL PARSTK
 LDL NEXT
 GCALL


 
#line 3458
 .align
#line 3458
???295
#line 3458
 .dbnz 0X80+11,"<?TERMINAL",'>'+0X80
#line 3458
 .align
#line 3458
 .dw ???294
#line 3458
; 295
#line 3458
 ; <?TERMINAL>
AQTERM: .DW DOCOL,ZERO,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3463
 .align
#line 3463
???296
#line 3463
 .dbnz 0X86,"<EMIT",'>'+0X80
#line 3463
 .align
#line 3463
 .dw ???295
#line 3463
; 296
#line 3463
 ; <EMIT>
AEMIT: .DW DOCOL,EMITCK,LNKOUT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3468
 .align
#line 3468
???297
#line 3468
 .dbnz 0X85,"<KEY",'>'+0X80
#line 3468
 .align
#line 3468
 .dw ???296
#line 3468
; 297
#line 3468
 ; <KEY>
AKEY: .DW DOCOL,ZERO
AKEY4: .DW DROP,LNKIN,LIT,0X7F,ANDD,DUP,LIT,ALF,SUBB,ZBRAN
AKEYZ .DW AKEY4-AKEYZ,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3475
 .align
#line 3475
???298
#line 3475
 .dbnz 0X85,"<R/W",'>'+0X80
#line 3475
 .align
#line 3475
 .dw ???297
#line 3475
; 298
#line 3475
 ; <R/W>
ARSLW: .DW DOCOL,DROP,DDROP,EXIT
 .DW DOCOL,ONE,AABRTQ
 .DBNZ 10,"DISK ERROR"
 .ALIGN
 .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3484
 .align
#line 3484
???299
#line 3484
 .dbnz 0X86,"<EMIT",'>'+0X80
#line 3484
 .align
#line 3484
 .dw ???298
#line 3484
; 299
#line 3484
 ; <EMITCK>
EMITCK: .DW DOCOL,DUP,LIT,0X20,LESS,ZBRAN
EMTCKZ .DW EMTCK1-EMTCKZ,ONE,OUTT,PSTOR
EMTCK1: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3491
 .align
#line 3491
???300
#line 3491
 .dbnz 0X83,"1I",'O'+0X80
#line 3491
 .align
#line 3491
 .dw ???299
#line 3491
; 300
#line 3491
 ; <1IO>
 .DW DOCOL
 .DW LIT,AEMIT,TEMIT,STORE
 .DW LIT,AKEY,TKEY,STORE
 .DW LIT,AQTERM,TQTERM,STORE
 .DW LIT,ARSLW,TRSLW,STORE,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3500
 .align
#line 3500
???301
#line 3500
 .dbnz 0X86,"IOSTR",0X80+'T'
#line 3500
 .align
#line 3500
 .dw ???300
#line 3500
; 301
#line 3500
 ; IOSTRT
IOSTRT: .DW DOCOL
 .DW R3IO
IOSTR4: .DW EXIT


 
#line 3506
 .align
#line 3506
???302
#line 3506
 .dbnz 0X80+12,"<2?TERMINAL",'>'+0X80
#line 3506
 .align
#line 3506
 .dw ???301
#line 3506
; 302
#line 3506
; <2?TERMINAL>
SQTERM: .DW DOCOL,TWO,LNKOUT,LNKIN,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3511
 .align
#line 3511
???303
#line 3511
 .dbnz 0X87,"<2EMIT",'>'+0X80
#line 3511
 .align
#line 3511
 .dw ???302
#line 3511
; 303
#line 3511
 ; <2EMIT>
SEMIT: .DW DOCOL,EMITCK,ZERO,LNKOUT,LNKOUT,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3516
 .align
#line 3516
???304
#line 3516
 .dbnz 0X86,"<2KEY",'>'+0X80
#line 3516
 .align
#line 3516
 .dw ???303
#line 3516
; 304
#line 3516
 ; <2KEY>
SKEY: .DW DOCOL,ZERO
SKEY4: .DW DROP,ONE,LNKOUT,LNKIN,LIT,0X7F,ANDD,DUP,LIT,ALF,SUBB,ZBRAN
SKEYZ .DW SKEY4-SKEYZ,EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3523
 .align
#line 3523
???305
#line 3523
 .dbnz 0X86,"<2R/W",'>'+0X80
#line 3523
 .align
#line 3523
 .dw ???304
#line 3523
; 305
#line 3523
 ; <2R/W>
SRSLW: .DW DOCOL,ZBRAN
SRSLWZ .DW SRSLW5-SRSLWZ,LIT,3,LNKOUT
 .DW LIT,256,SLMOD,LNKOUT,LNKOUT,LNKIN,ZEQU,ZBRAN
SRSLWY .DW SRSLW4-SRSLWY,LIT,1024,OVER,PLUS,SWAP,ADO
SRSLW1: .DW LNKIN,IDO,CSTOR,ONE,AUPLOP
SRSLWX .DW SRSLW1-SRSLWX,BRAN
SRSLWQ .DW SRSLW9-SRSLWQ
SRSLW4: .DW ONE,AABRTQ
 .DBNZ 10,"DISK ERROR"
 .ALIGN

SRSLW5: .DW LIT,4,LNKOUT,LIT,256,SLMOD,LNKOUT,LNKOUT
 .DW LIT,1024,OVER,PLUS,SWAP,ADO
SRSLW6: .DW IDO,CAT,LNKOUT,ONE,AUPLOP
SRSLWT .DW SRSLW6-SRSLWT,LNKIN,ZEQU,ZBRAN
SRSLWR .DW SRSLW4-SRSLWR
SRSLW9: .DW EXIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3544
 .align
#line 3544
???306
#line 3544
 .dbnz 0X83,"2I",'O'+0X80
#line 3544
 .align
#line 3544
 .dw ???305
#line 3544
; 306
#line 3544
 ; <2IO>
 .DW DOCOL
 .DW LIT,SEMIT,TEMIT,STORE
 .DW LIT,SKEY,TKEY,STORE
 .DW LIT,SQTERM,TQTERM,STORE
 .DW LIT,SRSLW,TRSLW,STORE,EXIT




 
#line 3554
 .align
#line 3554
???307
#line 3554
 .dbnz 0X86,"<3KEY",'>'+0X80
#line 3554
 .align
#line 3554
 .dw ???306
#line 3554
; 307
RKEY: .DW RKEY+BPW
RKEY4: LDC 50
 SHL ;WAIT 1 US
 LDC 0X42000008 ;COMMAND/STATUS REGISTER FOR CHANNEL A ;COMMAND/STATUS FOR CHANNEL A
 LB
 LDC 0X01 ;Rx CHARACTER AVAILABLE
 AND
 CJ @RKEY4
 LDC 50
 SHL ;WAIT SOME MORE
 LDL PARSTK
 ADC -BPW ;MAKE SOME ROOM ON THE STACK
 STL PARSTK
 LDC 0X4200000C ;DATA REGISTER FOR CHANNEL A
 LB ;READ CHARACTER FROM SCC
 LDL PARSTK
 STNL P0 ;PUT BYTE ON STACK
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3577
 .align
#line 3577
???308
#line 3577
 .dbnz 0X87,"<3TERM",'>'+0X80
#line 3577
 .align
#line 3577
 .dw ???307
#line 3577
; 308
RQTERM: .DW RQTERM+BPW
RQTERM4:
 LDL PARSTK
 ADC -BPW ;MAKE SOME ROOM ON THE STACK
 STL PARSTK
 LDC 0X42000008 ;COMMAND/STATUS REGISTER FOR CHANNEL A
 LB
 LDC 0X01
 AND
 CJ @RQTN

 LDC 1
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

RQTN:
 LDC 0
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3604
 .align
#line 3604
???309
#line 3604
 .dbnz 0X87,"<3EMIT",'>'+0X80
#line 3604
 .align
#line 3604
 .dw ???308
#line 3604
; 309
REMIT: .DW REMIT+BPW
REMIT4: LDC 50
 SHL ;WAIT 1 US
 LDC 0X42000008 ;COMMAND/STATUS REGISTER FOR CHANNEL A ;COMMAND/STATUS FOR CHANNEL A
 LB
 LDC 0X04 ;Tx BUFFER EMPTY
 AND
 CJ @REMIT4
 LDC 50
 SHL ;WAIT SOME MORE
 LDL PARSTK
 LDNL P0 ;GET THE OUTPUT BYTE
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK
 LDC 0X4200000C ;DATA REGISTER FOR CHANNEL A
 SB ;OUTPUT CHARACTER TO SCC
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3627
 .align
#line 3627
???310
#line 3627
 .dbnz 0X83,"3I",'O'+0X80
#line 3627
 .align
#line 3627
 .dw ???309
#line 3627
; 310
#line 3627
 ; <3IO>
R3IO: .DW DOCOL
 .DW LIT,REMIT,TEMIT,STORE
 .DW LIT,RKEY,TKEY,STORE
 .DW LIT,RQTERM,TQTERM,STORE
 .DW LIT,RRSW,TRSLW,STORE
 .DW SCCINI,EXIT

 
#line 3635
 .align
#line 3635
???311
#line 3635
 .dbnz 0X88,"SCC_INI",'T'+0X80H
#line 3635
 .align
#line 3635
 .dw ???310
#line 3635
; 311
SCCINI: .DW SCCINI+BPW
 LDC SCCINT
 STL T1 ;INITIALIZE TABLE POINTER
 LDC 0X42000008 ;COMMAND/STATUS REGISTER FOR CHANNEL A
 STL T2 ;COMMAND REGISTER ADDRESS
SCCLUP: LDC 50
 SHL ;DELAY 1 US
 LDL T1
 LB ;GET REGISTER NUMBER
 LDL T2
 SB ;WRITE REGISTER TO SCC
 LDC 50
 SHL ;DELAY 1 US
 LDL T1
 ADC 1
 LB ;GET DATA BYTE
 LDL T2
 SB ;WRITE BYTE TO SCC
 LDL T1
 ADC 2
 STL T1
 LDL T1
 LB ;CHECK FOR END OF TABLE
 EQC 0XFF
 CJ @SCCLUP
 LDL NEXT
 GCALL


SCCINT: .DBNZ 9,0XC0 ;MASTER INT CONTROL HARDWARE RESET
 .DBNZ 9,0X02 ;MASTER INT CONTROL NO VECTOR
 .DBNZ 00,0X00 ;NULL
 .DBNZ 04,0X44 ;TRANS/REC MIS PARAM x16 CLOCK & 1 STOP BIT
 .DBNZ 01,0X00 ;TRANS/REC INT MODES NO INTERRUPTS
 .DBNZ 02,0X00 ;INTERRUPT VECTOR NO VECTOR
 .DBNZ 03,0XC0 ;REC. PARAMETERS 8 BITS/CHARACTER
 .DBNZ 05,0X64 ;TRANS. PARAMETERS 8 BITS/CHARACTER
 .DBNZ 06,0X00 ;SYNC CHARACTER
 .DBNZ 07,0X00 ;SYNC CHARACTER
 .DBNZ 10,0X00 ;MISC BITS
 .DBNZ 11,0X54 ;CLK MODE CONTROL
 .DBNZ 12,((3686400/2/16)/9600)-2 BAUD RATE LOWER CONSTANT
 .DBNZ 13,0X00 ; BAUD RATE UPPER CONSTANT
 .DBNZ 14,0X03 ;MISC BITS USE INTERNAL BAUD RATE GENERATOR
 .DBNZ 15,0X00 ;INTERRUPT CONTROL
 .DBNZ 03,0XC1 ;RECV CONTROL 8 BITS & Rx ENABLE
 .DBNZ 05,0X6E ;TRAN CONTROL 8 BITS Tx ENABLE & RTS
 .DBNZ 00,0X80 ;COMMAND REG RESET Tx CRC GENERATOR
 .DBNZ -1

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+










 
#line 3697
 .align
#line 3697
???312
#line 3697
 .dbnz 0X84,"OUT",'0'+0X80
#line 3697
 .align
#line 3697
 .dw ???311
#line 3697
; 312
LKOUT0: .DW LKOUT0+BPW
 LDL PARSTK
 LDNLP P0 ;ADDRESS OF CHARACTER
 LDC 0X80000000 ;CHANNEL
 LDC 1 ;LENGTH
 OUT
 LDL PARSTK
 ADC BPW ;POP STACK
 STL PARSTK
 LDL NEXT ;GET RETURN ADDRESS
 GCALL

 
#line 3710
 .align
#line 3710
???313
#line 3710
 .dbnz 0X84,"OUT",'1'+0X80
#line 3710
 .align
#line 3710
 .dw ???312
#line 3710
; 313
LKOUT1: .DW LKOUT1+BPW
 LDL PARSTK
 LDNLP P0 ;ADDRESS OF CHARACTER
 LDC 0X80000004 ;CHANNEL
 LDC 1 ;LENGTH
 OUT
 LDL PARSTK
 ADC BPW ;POP STACK
 STL PARSTK
 LDL NEXT ;GET RETURN ADDRESS
 GCALL

 
#line 3723
 .align
#line 3723
???314
#line 3723
 .dbnz 0X84,"OUT",'2'+0X80
#line 3723
 .align
#line 3723
 .dw ???313
#line 3723
; 314
LKOUT2: .DW LKOUT2+BPW
 LDL PARSTK
 LDNLP P0 ;ADDRESS OF CHARACTER
 LDC 0X80000008 ;CHANNEL
 LDC 1 ;LENGTH
 OUT
 LDL PARSTK
 ADC BPW ;POP STACK
 STL PARSTK
 LDL NEXT ;GET RETURN ADDRESS
 GCALL

 
#line 3736
 .align
#line 3736
???315
#line 3736
 .dbnz 0X84,"OUT",'3'+0X80
#line 3736
 .align
#line 3736
 .dw ???314
#line 3736
; 315
LKOUT3: .DW LKOUT3+BPW
 LDL PARSTK
 LDNLP P0 ;ADDRESS OF CHARACTER
 LDC 0X8000000C ;CHANNEL
 LDC 1 ;LENGTH
 OUT
 LDL PARSTK
 ADC BPW ;POP STACK
 STL PARSTK
 LDL NEXT ;GET RETURN ADDRESS
 GCALL

 
#line 3749
 .align
#line 3749
???316
#line 3749
 .dbnz 0X83,"IN",'0'+0X80
#line 3749
 .align
#line 3749
 .dw ???315
#line 3749
; 316
LKIN0: .DW LKIN0+BPW
 LDL PARSTK
 ADC -BPW ;ROOM FOR CHARACTER
 STL PARSTK
 LDL PARSTK
 LDNLP P0 ;POINTER TO TOP OF PARAMETER STACK
 LDC 0X80000010 ;CHANNEL ADDRESS
 LDC 1 ;READ ONE CHARACTER
 IN
 LDL PARSTK
 LDNL P0
 LDC 0XFF ;SAVE JUST THE CHARACTER
 AND
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 3768
 .align
#line 3768
???317
#line 3768
 .dbnz 0X83,"IN",'1'+0X80
#line 3768
 .align
#line 3768
 .dw ???316
#line 3768
; 317
LKIN1: .DW LKIN1+BPW
 LDL PARSTK
 ADC -BPW ;ROOM FOR CHARACTER
 STL PARSTK
 LDL PARSTK
 LDNLP P0 ;POINTER TO TOP OF PARAMETER STACK
 LDC 0X80000014 ;CHANNEL ADDRESS
 LDC 1 ;READ ONE CHARACTER
 IN
 LDL PARSTK
 LDNL P0
 LDC 0XFF ;SAVE JUST THE CHARACTER
 AND
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 3787
 .align
#line 3787
???318
#line 3787
 .dbnz 0X83,"IN",'2'+0X80
#line 3787
 .align
#line 3787
 .dw ???317
#line 3787
; 318
LKIN2: .DW LKIN2+BPW
 LDL PARSTK
 ADC -BPW ;ROOM FOR CHARACTER
 STL PARSTK
 LDL PARSTK
 LDNLP P0 ;POINTER TO TOP OF PARAMETER STACK
 LDC 0X80000018 ;CHANNEL ADDRESS
 LDC 1 ;READ ONE CHARACTER
 IN
 LDL PARSTK
 LDNL P0
 LDC 0XFF ;SAVE JUST THE CHARACTER
 AND
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

 
#line 3806
 .align
#line 3806
???319
#line 3806
 .dbnz 0X83,"IN",'3'+0X80
#line 3806
 .align
#line 3806
 .dw ???318
#line 3806
; 319
LKIN3: .DW LKIN3+BPW
 LDL PARSTK
 ADC -BPW ;ROOM FOR CHARACTER
 STL PARSTK
 LDL PARSTK
 LDNLP P0 ;POINTER TO TOP OF PARAMETER STACK
 LDC 0X8000001C ;CHANNEL ADDRESS
 LDC 1 ;READ ONE CHARACTER
 IN
 LDL PARSTK
 LDNL P0
 LDC 0XFF ;SAVE JUST THE CHARACTER
 AND
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


 
#line 3828
 .align
#line 3828
???320
#line 3828
 .dbnz 0X87,"BTLKOU",'T'+0X80
#line 3828
 .align
#line 3828
 .dw ???319
#line 3828
; 320
LNKOUT: .DW LNKOUT+BPW
 LDL PARSTK
 LDNLP P0 ;ADDRESS OF CHARACTER
 LDL TTYOUT ;CHANNEL
 LDC 1 ;LENGTH
 OUT
 LDL PARSTK
 ADC BPW ;POP STACK
 STL PARSTK
 LDL NEXT ;GET RETURN ADDRESS
 GCALL

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3843
 .align
#line 3843
???321
#line 3843
 .dbnz 0X86,"BTLKI",'N'+0X80
#line 3843
 .align
#line 3843
 .dw ???320
#line 3843
; 321
LNKIN: .DW LNKIN+BPW
 LDL PARSTK
 ADC -BPW ;ROOM FOR CHARACTER
 STL PARSTK
 LDL PARSTK
 LDNLP P0 ;POINTER TO TOP OF PARAMETER STACK
 LDL TTYIN ;BOOT CHANNEL IN
 LDC 1 ;READ ONE CHARACTER
 IN
 LDL PARSTK
 LDNL P0
 LDC 0XFF ;SAVE JUST THE CHARACTER
 AND
 LDL PARSTK
 STNL P0
 LDL NEXT
 GCALL

#line 1 "term.hdr"
; Structures for terminal emulation
;

;------------------------------------------------------------------
;; Window structure
#line 17
; other fields follow, but are not used yet.


;------------------------------------------------------------------
;; Font structure








;------------------------------------------------------------------
;; Character structure (byte offset to bitmap)




;------------------------------------------------------------------
;; Screen structure
#line 3863 "T4th6.tal"
#line 1 "Screen.tal"
; Big Picture IQ stuff for the Orca.
; 5-2-88
#line 16
init_video
 ldc 0x18
 ldc 0x48000000
 sb

 ldc 1
 ldc 0xF4000000+0xF6000
 sb

 ldc 4
 ldc 0xF4000000+0xF0000
 sb
 ldc 0xff
 ldc 0xF4000000+0xF1000
 sb

 ldc 5
 ldc 0xF4000000+0xF0000
 sb
 ldc 0
 ldc 0xF4000000+0xF1000
 sb

 ldc 6
 ldc 0xF4000000+0xF0000
 sb
 ldc 1
 ldc 0xF4000000+0xF1000
 sb

 ldc 7
 ldc 0xF4000000+0xF0000
 sb
 ldc 0
 ldc 0xF4000000+0xF1000
 sb

 ldc 0
 ldc 0xF4000000+0xF0000
 sb
 ldc 0xff
 ldc 0xF4000000+0xF1800
 sb
 ldc 1
 ldc 0xF4000000+0xF0000
 sb
 ldc 0
 ldc 0xF4000000+0xF1800
 sb

 ldc 128
gray2:
 adc -1
 dup
 ldc 0xF4000000+0xF0000
 sb
 ldc 0xff
 ldc 0xF4000000+0xF0800
 sb
 dup
 cj @gray1
 j @gray2
gray1:
 ldc 128
gray4:
 adc -1
 dup
 adc 128
 ldc 0xF4000000+0xF0000
 sb
 ldc 0
 ldc 0xF4000000+0xF0800
 sb
 dup
 cj @gray3
 j @gray4
gray3:
 ldc 1
 ldc 0xF4000000+0xE0000 ;turn on the video
 sb

 call @gray_screen
 ret

gray_screen
 ldc 0xF4000000+1024
 stl 1 ;save the start address
 ldc 0xAAAAAAAA
 stl 2 ;save the pattern
 ldc 0xF4000000+1024+(808*1024)
 stl 3 ;save the end address

gs1 ldl 2 ;get the data
 ldl 1 ;get the address
 call @fill_line ;fill the line

 ldl 2 ;get the data
 ldc 0xFFFFFFFF
 xor
 stl 2 ;and invert it

 ldl 1 ;get the screen address
 adc 1024 ;and increment it
 stl 1

 ldl 3
 ldl 1
 diff
 eqc 0
 cj @gs1
 ret

fill_line
 ldl 1
 adc 1024 ;make the end address
 stl 3

fl1 ldl 2 ;get the data
 ldl 1 ;get the address
 stnl 0

 ldl 1
 adc 4 ;increment the address by a word
 stl 1

 ldl 1
 ldl 3
 diff
 eqc 0 ;done?
 cj @fl1
 ret

fill_window_bkgnd ;with background
 ldl 1 ;get 0
 ldnl 0
 adc -16
 ldc 1024
 prod ;times in the stride
 adc 0xF4000000+1024 ;get the line address
 stl 2 ;and save

 ldl 1 ;get 2
 ldnl 2
 adc 1
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 3

fwb1 ldl 2 ;get the line address
 ldl 1 ;get the window.struct pointer
 call @fill_line_bkgnd

 ldl 2
 adc 1024 ;increment the line address
 stl 2

 ldl 2
 ldl 3
 diff
 eqc 0
 cj @fwb1
 ret

fill_line_bkgnd
 ldl 1 ;get 1
 ldnl 1
 ldc 3
 shr ;force to byte boundries
 ldl 2
 add ;add in the line address
 stl 3 ;and save

 ldl 1 ;get 3
 ldnl 3
 ldc 3
 shr
 adc 1
 ldl 2
 add
 stl 2 ;ditto

 ldl 1 ;get 8
 ldnl 8
 stl 1

flb1 ldl 1
 ldl 3
 sb
 ldl 3
 adc 1
 stl 3

 ldl 3
 ldl 2
 diff
 eqc 0
 cj @flb1
 ret

draw_lborder
 ldl 1 ;get 1
 ldnl 1
 ldc 3
 shr ;get the needed byte boundry
 adc -1
 stl 2 ;save temporarily

 ldl 1 ;get 0
 ldnl 0
 adc -16
 ldc 1024
 prod
 adc 0xF4000000+1024 ;get the address of the first byte
 ldl 2
 add
 stl 3

 ldl 1 ;get 2
 ldnl 2
 adc 2
 ldc 1024
 prod
 adc 0xF4000000+1024
 ldl 2
 add
 stl 2

dlb1 ldl 3
 lb
 ldc 0xf8
 and
 ldc 4
 or
 ldl 3
 sb

 ldl 3
 adc 1024
 stl 3

 ldl 2
 ldl 3
 diff
 eqc 0
 cj @dlb1
 ret

draw_rborder
 ldl 1 ;get 3
 ldnl 3
 ldc 3
 shr
 adc 1
 stl 2

 ldl 1 ;get 0
 ldnl 0
 adc -13
 ldc 1024
 prod
 adc 0xF4000000+1024 ;get the address of the first byte
 ldl 2
 add
 stl 3

 ldl 1 ;get 2
 ldnl 2
 adc 3
 ldc 1024
 prod
 adc 0xF4000000+1024
 ldl 2
 add
 stl 2

drb1 ldl 3
 lb
 ldc 0x7
 and
 ldc 0x38
 or
 ldl 3
 sb

 ldl 3
 adc 1024
 stl 3

 ldl 2
 ldl 3
 diff
 eqc 0
 cj @drb1
 ret
draw_tborder
 ldl 1 ;get 0
 ldnl 0
 adc -1
 ldc 1024
 prod
 adc 0xF4000000+1024
 ldl 1
 call @draw_hborder
 ret

draw_sborder
 ldl 1 ;get 0
 ldnl 0
 adc -16
 ldc 1024
 prod
 adc 0xF4000000+1024
 ldl 1
 call @draw_hborder
 ret

draw_bborder
 ldl 1 ;get 0
 ldnl 2
 adc 1
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 ldl 1
 call @draw_hborder
 ret

draw_hborder
 ldl 1 ;get 1
 ldnl 1
 ldc 3
 shr ;force to byte boundries
 ldl 2
 add ;add in the line address
 stl 3 ;and save

 ldl 1 ;get 3
 ldnl 3
 ldc 3
 shr
 adc 1
 ldl 2
 add
 stl 2 ;ditto

 ldc 0xff
 stl 1

dhb1 ldl 1
 ldl 3
 sb
 ldl 3
 adc 1
 stl 3

 ldl 3
 ldl 2
 diff
 eqc 0
 cj @dhb1
 ret

draw_brcorner
 ldl 1
 ldnl 2
 adc 1
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 1
 ldnl 3
 ldc 3
 shr
 adc 1
 ldl 2
 add
 stl 2

 ldl 2
 lb
 ldc 0x7
 and
 ldc 0xf8
 or
 ldl 2
 sb

 ldl 2
 adc 1024
 stl 2

 ldl 2
 lb
 ldc 0x7
 and
 ldc 0xf8
 or
 ldl 2
 sb

 ldl 2
 adc 1024
 stl 2

 ldl 2
 lb
 ldc 0x7
 and
 ldc 0xf8
 or
 ldl 2
 sb

 ret

draw_trcorner
 ldl 1
 ldnl 0
 adc -16
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 1
 ldnl 3
 ldc 3
 shr
 adc 1
 ldl 2
 add
 stl 2

 ldl 2
 lb
 ldc 0x1F
 and
 ldc 0xe0
 or
 ldl 2
 sb

 ldl 2
 adc 1024
 stl 2

 ldl 2
 lb
 ldc 0x1F
 and
 ldc 0x20
 or
 ldl 2
 sb

 ldl 2
 adc 1024
 stl 2

 ldl 2
 lb
 ldc 0x1F
 and
 ldc 0x20
 or
 ldl 2
 sb

 ret

draw_tlcorner
 ldl 1
 ldnl 0
 adc -16
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 1
 ldnl 1
 ldc 3
 shr
 adc -1
 ldl 2
 add
 stl 2

 ldl 2
 lb
 ldc 0xf8
 and
 ldc 0x07
 or
 ldl 2
 sb

 ret

draw_blcorner
 ldl 1
 ldnl 2
 adc 1
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 1
 ldnl 1
 ldc 3
 shr
 adc -1
 ldl 2
 add
 stl 2

 ldl 2
 lb
 ldc 0xf8
 and
 ldc 0x07
 or
 ldl 2
 sb

 ret

 
#line 556
 .align
#line 556
???322
#line 556
 .dbnz 0X8B,"DRAW.WINDO",'W'+0X80
#line 556
 .align
#line 556
 .dw ???321
#line 556
; 322
DRAW_WINDOW
 .DW DOCOL,FWIN,AT,DWIND,FWIN,AT,tog_curs,EXIT

 
#line 560
 .align
#line 560
???323
#line 560
 .dbnz 0X8D,"<DRAW.WINDOW",'>'+0X80
#line 560
 .align
#line 560
 .dw ???322
#line 560
; 323
#line 560
 ; draw.window
DWIND: .DW DWIND+BPW


 LDL PARSTK
 LDNL P0 ;GET THE OUTPUT BYTE
 CALL @draw_window
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK

 LDL NEXT
 GCALL

draw_window
 ldl 1
 call @fill_window_bkgnd
 ldl 1
 call @draw_lborder
 ldl 1
 call @draw_rborder
 ldl 1
 call @draw_tborder
 ldl 1
 call @draw_bborder
 ldl 1
 call @draw_sborder
 ldl 1
 call @draw_tlcorner
 ldl 1
 call @draw_blcorner
 ldl 1
 call @draw_trcorner
 ldl 1
 call @draw_brcorner

 ret

 
#line 598
 .align
#line 598
???324
#line 598
 .dbnz 0X8A,"INIT.VIDE",'O'+0X80
#line 598
 .align
#line 598
 .dw ???323
#line 598
; 324
#line 598
 ; INIT.VIDEO
IVID: .DW IVID+BPW

 call @init_video

 LDL NEXT
 GCALL

 
#line 606
 .align
#line 606
???325
#line 606
 .dbnz 0X8B,"GRAY.SCREE",'N'+0X80
#line 606
 .align
#line 606
 .dw ???324
#line 606
; 325
#line 606
 ; INIT.VIDEO
GRYSCR: .DW GRYSCR+BPW

 call @gray_screen

 LDL NEXT
 GCALL
 .pub default_window
 .align
default_window
 .dw 18 ;0
 .dw 32 ;1
 .dw 273 ;2
 .dw 351 ;3
 .dw 0 ;4
 .dw 0 ;5
 .dw 0 ;6
 .dw 255 ;7
 .dw 0 ;8
 .dw FONT ;9
 .dw 0 ;wgCursx
 .dw 0 ;wgCursy
 .dw 0 ;wgMode
 .dw 0 ;wgPen
 .dw 0 ;wgPattern
 .dw 255 ;wgColorF
 .dw 0 ;wgColorB
 .dw 0 ;wNext
 .dw window_activate
 .dw window_deactivate
 .dw 0 ;wNname
 .dw 0 ;wpTerminate 0=run, 1=stop 2=stopped
 .dw screen ;wScreen

 
#line 640
 .align
#line 640
???326
#line 640
 .dbnz 0X8D,"CREATE.WINDO",'W'+0X80
#line 640
 .align
#line 640
 .dw ???325
#line 640
; 326
crwindow
 .DW CREATE,LIT,23,CELL,STAR,ALLOT
 .DW DEFWIN,DP,LIT,23,CELL,STAR,SUBB
 .DW LIT,23,MOVE
 .DW DP,LIT,20,CELL,STAR,SUBB,STORE
 .DW DP,LIT,21,CELL,STAR,SUBB,STORE
 .DW DP,LIT,22,CELL,STAR,SUBB,STORE
 .DW DP,LIT,23,CELL,STAR,SUBB,STORE
 .DW EXIT

 
#line 651
 .align
#line 651
???327
#line 651
 .dbnz 0X8E,"DEFAULT.WINDO",'W'+0X80
#line 651
 .align
#line 651
 .dw ???326
#line 651
; 327
#line 651
 ; DEF.WINDOW
DEFWIN: .DW DOCOL,LIT,default_window,EXIT

 
#line 654
 .align
#line 654
???328
#line 654
 .dbnz 0X87,"?SCREE",'N'+0X80
#line 654
 .align
#line 654
 .dw ???327
#line 654
; 328
#line 654
 ; ?SCREEN
SCRN: .DW DOCOL,LIT,screen,EXIT

 
#line 657
 .align
#line 657
???329
#line 657
 .dbnz 0X89,"'PLOTCHA",'R'+0X80
#line 657
 .align
#line 657
 .dw ???328
#line 657
; 329
#line 657
 ; 'PLOTCHAR
TPC: .DW DOCOL,LIT,pltchrvec,EXIT

 
#line 660
 .align
#line 660
???330
#line 660
 .dbnz 0X88,"PLOTCHA",'R'+0X80
#line 660
 .align
#line 660
 .dw ???329
#line 660
; 330
#line 660
 ;
PLCH .DW DOCOL, TPC, AT, EXEC, EXIT

 
#line 663
 .align
#line 663
???331
#line 663
 .dbnz 0X88,"ACTIVAT",'E'+0X80
#line 663
 .align
#line 663
 .dw ???330
#line 663
; 331
ACTIV .DW DOCOL,FWIN,AT,WACT,EXIT

 
#line 666
 .align
#line 666
???332
#line 666
 .dbnz 0X8A,"DEACTIVAT",'E'+0X80
#line 666
 .align
#line 666
 .dw ???331
#line 666
; 332
DEACT .DW DOCOL,FWIN,AT,WDEACT,EXIT

 
#line 669
 .align
#line 669
???333
#line 669
 .dbnz 0X8C,"FRONT.WINDO",'W'+0X80
#line 669
 .align
#line 669
 .dw ???332
#line 669
; 333
FWIN .DW DOCOL,LIT,front_window,EXIT

 
#line 672
 .align
#line 672
???334
#line 672
 .dbnz 0X8A,"<PLOTCHAR",'>'+0X80
#line 672
 .align
#line 672
 .dw ???333
#line 672
; 334
#line 672
 ;
plot_char .DW plot_char+BPW

 LDL PARSTK
 LDNL P0 ;GET THE OUTPUT window
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK

 LDL PARSTK
 LDNL P0 ;GET THE BYTE
 CALL @plotChar

 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK

 ldl NEXT
 gcall

 
#line 692
 .align
#line 692
???335
#line 692
 .dbnz 0X8A,"TOG.CURSO",'R'+0X80
#line 692
 .align
#line 692
 .dw ???334
#line 692
; 335
#line 692
 ;
tog_curs
 .DW tog_curs+BPW

 LDL PARSTK
 LDNL P0 ;GET THE OUTPUT window
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK

 CALL @cCursTog

 ldl NEXT
 gcall

 
#line 707
 .align
#line 707
???336
#line 707
 .dbnz 0X83,"CL",'W'+0X80
#line 707
 .align
#line 707
 .dw ???335
#line 707
; 336
CLEARW .DW DOCOL,LIT,0,FWIN,AT,LIT,16,PLUS,STORE
 .DW LIT,0,FWIN,AT,LIT,20,PLUS,STORE,DRAW_WINDOW
 .DW EXIT

 
#line 712
 .align
#line 712
???337
#line 712
 .dbnz 0X85,"HOME",'W'+0X80
#line 712
 .align
#line 712
 .dw ???336
#line 712
; 337
HOMEW .DW DOCOL,FWIN,AT,DUP,LIT,16,PLUS,LIT,0,SWAP,STORE
 .DW 20,PLUS,LIT,0,SWAP,STORE,EXIT

 
#line 716
 .align
#line 716
???338
#line 716
 .dbnz 0X8A,"<ACTIVATE",'>'+0X80
#line 716
 .align
#line 716
 .dw ???337
#line 716
; 338
WACT .DW WACT+BPW

 LDL PARSTK
 LDNL P0
 LDL PARSTK
 ADC BPW
 STL PARSTK
 CALL @window_activate

 LDL NEXT
 GCALL

window_activate
 ldl 1 ;get 0
 ldnl 0
 adc -13
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @draw_hborder

 RET

 
#line 783
 .align
#line 783
???339
#line 783
 .dbnz 0X8C,"<DEACTIVATE",'>'+0X80
#line 783
 .align
#line 783
 .dw ???338
#line 783
; 339
WDEACT .DW WDEACT+BPW

 LDL PARSTK
 LDNL P0 ;GET THE OUTPUT BYTE
 CALL @window_deactivate
 LDL PARSTK
 ADC BPW ;POP THE STACK
 STL PARSTK

 LDL NEXT
 GCALL

window_deactivate
 ldl 1 ;get 0
 ldnl 0
 adc -13
 ldc 1024
 prod
 adc 0xF4000000+1024
 stl 2
 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ldl 2
 adc 1024*2
 stl 2

 ldl 2
 ldl 1
 call @fill_line_bkgnd

 ret

;-------------------------------------------------------------
; <CALL1> (APARAM FUNADDR -)
;

 
#line 854
 .align
#line 854
???340
#line 854
 .dbnz 0X87,"<CALL1",'>'+0X80
#line 854
 .align
#line 854
 .dw ???339
#line 854
; 340
callit .DW callit+BPW

 ldl PARSTK
 ldnl P0 ;fetch function addr
 ldl PARSTK
 ldnl P1 ;fetch aparam value
 ajw -4
 stl 1 ;set aparam
 ldc calldone-calldot
 ldpi
calldot
 stl 0 ;set return address
 gcall

calldone
 ldl PARSTK
 adc 2*BPW
 stl PARSTK
 LDL NEXT
 GCALL

;-------------------------------------------------------------
; <DOWNLOAD> ( - start end entry)
; read a binary file from the serial port in download format.
; returns the lowest address loaded, the address following the
; highest address loaded, and the transfer address.

 .ext download

 
#line 884
 .align
#line 884
???341
#line 884
 .dbnz 0X8A,"<DOWNLOAD",'>'+0X80
#line 884
 .align
#line 884
 .dw ???340
#line 884
; 341
loadit .DW loadit+BPW

 call @download
 stl T0 ;start

 ldl PARSTK
 adc -(BPW*3)
 stl PARSTK

 ldl PARSTK
 stnl P1

 ldl PARSTK
 stnl P2

 ldl T0
 ldl PARSTK
 stnl P0

 LDL NEXT
 GCALL

;-------------------------------------------------------------
; <UNDRAW.WIN> ( window - )
; read a binary file from the serial port in download format.
; returns the lowest address loaded, the address following the
; highest address loaded, and the transfer address.

 .ext wUndraw

 
#line 915
 .align
#line 915
???342
#line 915
 .dbnz 0X8C,"<UNDRAW.WIN",'>'+0X80
#line 915
 .align
#line 915
 .dw ???341
#line 915
; 342
udwit .DW udwit+BPW

 ldl PARSTK
 ldnl P0 ;fetch aparam value
 ldl PARSTK
 adc BPW
 stl PARSTK

 call @wUndraw

 LDL NEXT
 GCALL


;-------------------------------------------------------------
;debug stuff

 .pub putchar

putchar
 LDC 50
 SHL ;WAIT 1 US
 LDC 0X42000008 ;COMMAND/STATUS REGISTER FOR CHANNEL A ;COMMAND/STATUS FOR CHANNEL A
 LB
 LDC 0X04 ;Tx BUFFER EMPTY
 AND
 CJ @putchar
 LDC 50
 SHL ;WAIT SOME MORE
 ldl 1
 LDC 0X4200000C ;DATA REGISTER FOR CHANNEL A
 SB ;OUTPUT CHARACTER TO SCC
 ret
#line 3864 "T4th6.tal"
#line 1 "monaco12"
 .ALIGN
FONT:
 .DW 0, 217, 1, 16
 .DW CHCurs-FONT
 .DW CH0-FONT
 .DW CH1-FONT
 .DW CH2-FONT
 .DW CH3-FONT
 .DW CH4-FONT
 .DW CH5-FONT
 .DW CH6-FONT
 .DW CH7-FONT
 .DW CH8-FONT
 .DW CH9-FONT
 .DW CH10-FONT
 .DW CH11-FONT
 .DW CH12-FONT
 .DW CH13-FONT
 .DW CH14-FONT
 .DW CH15-FONT
 .DW CH16-FONT
 .DW CH17-FONT
 .DW CH18-FONT
 .DW CH19-FONT
 .DW CH20-FONT
 .DW CH21-FONT
 .DW CH22-FONT
 .DW CH23-FONT
 .DW CH24-FONT
 .DW CH25-FONT
 .DW CH26-FONT
 .DW CH27-FONT
 .DW CH28-FONT
 .DW CH29-FONT
 .DW CH30-FONT
 .DW CH31-FONT
 .DW CH32-FONT
 .DW CH33-FONT
 .DW CH34-FONT
 .DW CH35-FONT
 .DW CH36-FONT
 .DW CH37-FONT
 .DW CH38-FONT
 .DW CH39-FONT
 .DW CH40-FONT
 .DW CH41-FONT
 .DW CH42-FONT
 .DW CH43-FONT
 .DW CH44-FONT
 .DW CH45-FONT
 .DW CH46-FONT
 .DW CH47-FONT
 .DW CH48-FONT
 .DW CH49-FONT
 .DW CH50-FONT
 .DW CH51-FONT
 .DW CH52-FONT
 .DW CH53-FONT
 .DW CH54-FONT
 .DW CH55-FONT
 .DW CH56-FONT
 .DW CH57-FONT
 .DW CH58-FONT
 .DW CH59-FONT
 .DW CH60-FONT
 .DW CH61-FONT
 .DW CH62-FONT
 .DW CH63-FONT
 .DW CH64-FONT
 .DW CH65-FONT
 .DW CH66-FONT
 .DW CH67-FONT
 .DW CH68-FONT
 .DW CH69-FONT
 .DW CH70-FONT
 .DW CH71-FONT
 .DW CH72-FONT
 .DW CH73-FONT
 .DW CH74-FONT
 .DW CH75-FONT
 .DW CH76-FONT
 .DW CH77-FONT
 .DW CH78-FONT
 .DW CH79-FONT
 .DW CH80-FONT
 .DW CH81-FONT
 .DW CH82-FONT
 .DW CH83-FONT
 .DW CH84-FONT
 .DW CH85-FONT
 .DW CH86-FONT
 .DW CH87-FONT
 .DW CH88-FONT
 .DW CH89-FONT
 .DW CH90-FONT
 .DW CH91-FONT
 .DW CH92-FONT
 .DW CH93-FONT
 .DW CH94-FONT
 .DW CH95-FONT
 .DW CH96-FONT
 .DW CH97-FONT
 .DW CH98-FONT
 .DW CH99-FONT
 .DW CH100-FONT
 .DW CH101-FONT
 .DW CH102-FONT
 .DW CH103-FONT
 .DW CH104-FONT
 .DW CH105-FONT
 .DW CH106-FONT
 .DW CH107-FONT
 .DW CH108-FONT
 .DW CH109-FONT
 .DW CH110-FONT
 .DW CH111-FONT
 .DW CH112-FONT
 .DW CH113-FONT
 .DW CH114-FONT
 .DW CH115-FONT
 .DW CH116-FONT
 .DW CH117-FONT
 .DW CH118-FONT
 .DW CH119-FONT
 .DW CH120-FONT
 .DW CH121-FONT
 .DW CH122-FONT
 .DW CH123-FONT
 .DW CH124-FONT
 .DW CH125-FONT
 .DW CH126-FONT
 .DW CH127-FONT
 .DW CH128-FONT
 .DW CH129-FONT
 .DW CH130-FONT
 .DW CH131-FONT
 .DW CH132-FONT
 .DW CH133-FONT
 .DW CH134-FONT
 .DW CH135-FONT
 .DW CH136-FONT
 .DW CH137-FONT
 .DW CH138-FONT
 .DW CH139-FONT
 .DW CH140-FONT
 .DW CH141-FONT
 .DW CH142-FONT
 .DW CH143-FONT
 .DW CH144-FONT
 .DW CH145-FONT
 .DW CH146-FONT
 .DW CH147-FONT
 .DW CH148-FONT
 .DW CH149-FONT
 .DW CH150-FONT
 .DW CH151-FONT
 .DW CH152-FONT
 .DW CH153-FONT
 .DW CH154-FONT
 .DW CH155-FONT
 .DW CH156-FONT
 .DW CH157-FONT
 .DW CH158-FONT
 .DW CH159-FONT
 .DW CH160-FONT
 .DW CH161-FONT
 .DW CH162-FONT
 .DW CH163-FONT
 .DW CH164-FONT
 .DW CH165-FONT
 .DW CH166-FONT
 .DW CH167-FONT
 .DW CH168-FONT
 .DW CH169-FONT
 .DW CH170-FONT
 .DW CH171-FONT
 .DW CH172-FONT
 .DW CH173-FONT
 .DW CH174-FONT
 .DW CH175-FONT
 .DW CH176-FONT
 .DW CH177-FONT
 .DW CH178-FONT
 .DW CH179-FONT
 .DW CH180-FONT
 .DW CH181-FONT
 .DW CH182-FONT
 .DW CH183-FONT
 .DW CH184-FONT
 .DW CH185-FONT
 .DW CH186-FONT
 .DW CH187-FONT
 .DW CH188-FONT
 .DW CH189-FONT
 .DW CH190-FONT
 .DW CH191-FONT
 .DW CH192-FONT
 .DW CH193-FONT
 .DW CH194-FONT
 .DW CH195-FONT
 .DW CH196-FONT
 .DW CH197-FONT
 .DW CH198-FONT
 .DW CH199-FONT
 .DW CH200-FONT
 .DW CH201-FONT
 .DW CH202-FONT
 .DW CH203-FONT
 .DW CH204-FONT
 .DW CH205-FONT
 .DW CH206-FONT
 .DW CH207-FONT
 .DW CH208-FONT
 .DW CH209-FONT
 .DW CH210-FONT
 .DW CH211-FONT
 .DW CH212-FONT
 .DW CH213-FONT
 .DW CH214-FONT
 .DW CH215-FONT
 .DW CH216-FONT
 .DW CH217-FONT
 .ALIGN
CHCurs .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 129, 255, 0, 0
 .ALIGN
CH0 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH1 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH2 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH3 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH4 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH5 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH6 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH7 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH8 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH9 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH10 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH11 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH12 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH13 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH14 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH15 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH16 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH17 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH18 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH19 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH20 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH21 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH22 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH23 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH24 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH25 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH26 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH27 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH28 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH29 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH30 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH31 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH32 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH33 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH34 .DW 8
 .DB 0, 0, 0, 0x28, 0x28, 0x28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH35 .DW 8
 .DB 0, 0, 0, 0x28, 0x7c, 0x28, 0x28, 0x7c, 0x28, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH36 .DW 8
 .DB 0, 0, 0x10, 0x38, 0x54, 0x50, 0x30, 0x18, 0x14, 0x14, 0x54, 0x38, 0x10, 0, 0, 0
 .ALIGN
CH37 .DW 8
 .DB 0, 0, 0, 0x24, 0x54, 0x58, 0x38, 0x10, 0x28, 0x34, 0x54, 0x48, 0, 0, 0, 0
 .ALIGN
CH38 .DW 8
 .DB 0, 0, 0, 0x60, 0x90, 0x90, 0xa0, 0x40, 0xa0, 0x94, 0x88, 0x74, 0, 0, 0, 0
 .ALIGN
CH39 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0x10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH40 .DW 8
 .DB 0, 0, 0x8, 0x10, 0x10, 0x20, 0x20, 0x20, 0x20, 0x20, 0x10, 0x10, 0x8, 0, 0, 0
 .ALIGN
CH41 .DW 8
 .DB 0, 0, 0x20, 0x10, 0x10, 0x8, 0x8, 0x8, 0x8, 0x8, 0x10, 0x10, 0x20, 0, 0, 0
 .ALIGN
CH42 .DW 8
 .DB 0, 0, 0, 0x10, 0x54, 0x38, 0x38, 0x54, 0x10, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH43 .DW 8
 .DB 0, 0, 0, 0, 0, 0x10, 0x10, 0x7c, 0x10, 0x10, 0, 0, 0, 0, 0, 0
 .ALIGN
CH44 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x10, 0x10, 0x10, 0x20, 0, 0
 .ALIGN
CH45 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0x7c, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH46 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH47 .DW 8
 .DB 0, 0, 0, 0x4, 0x4, 0x8, 0x8, 0x10, 0x10, 0x20, 0x20, 0x40, 0x40, 0, 0, 0
 .ALIGN
CH48 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH49 .DW 8
 .DB 0, 0, 0, 0x10, 0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH50 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x4, 0x4, 0x8, 0x10, 0x20, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH51 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x4, 0x18, 0x4, 0x4, 0x4, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH52 .DW 8
 .DB 0, 0, 0, 0x8, 0x18, 0x28, 0x48, 0x7c, 0x8, 0x8, 0x8, 0x8, 0, 0, 0, 0
 .ALIGN
CH53 .DW 8
 .DB 0, 0, 0, 0x7c, 0x40, 0x40, 0x78, 0x4, 0x4, 0x4, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH54 .DW 8
 .DB 0, 0, 0, 0x18, 0x20, 0x40, 0x78, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH55 .DW 8
 .DB 0, 0, 0, 0x7c, 0x4, 0x4, 0x8, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH56 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH57 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x3c, 0x4, 0x8, 0x30, 0, 0, 0, 0
 .ALIGN
CH58 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x10, 0x10, 0, 0, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH59 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x10, 0x10, 0, 0, 0x10, 0x10, 0x10, 0x20, 0, 0
 .ALIGN
CH60 .DW 8
 .DB 0, 0, 0, 0, 0x8, 0x10, 0x20, 0x40, 0x20, 0x10, 0x8, 0, 0, 0, 0, 0
 .ALIGN
CH61 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x7c, 0, 0x7c, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH62 .DW 8
 .DB 0, 0, 0, 0, 0x20, 0x10, 0x8, 0x4, 0x8, 0x10, 0x20, 0, 0, 0, 0, 0
 .ALIGN
CH63 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x4, 0x8, 0x10, 0x10, 0, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH64 .DW 8
 .DB 0, 0, 0, 0, 0, 0x78, 0x84, 0xb4, 0xb4, 0xbc, 0x80, 0x78, 0, 0, 0, 0
 .ALIGN
CH65 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH66 .DW 8
 .DB 0, 0, 0, 0x78, 0x44, 0x44, 0x78, 0x44, 0x44, 0x44, 0x44, 0x78, 0, 0, 0, 0
 .ALIGN
CH67 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x40, 0x40, 0x40, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH68 .DW 8
 .DB 0, 0, 0, 0x78, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x78, 0, 0, 0, 0
 .ALIGN
CH69 .DW 8
 .DB 0, 0, 0, 0x7c, 0x40, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH70 .DW 8
 .DB 0, 0, 0, 0x7c, 0x40, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x40, 0, 0, 0, 0
 .ALIGN
CH71 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x40, 0x40, 0x4c, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH72 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH73 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH74 .DW 8
 .DB 0, 0, 0, 0x4, 0x4, 0x4, 0x4, 0x4, 0x4, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH75 .DW 8
 .DB 0, 0, 0, 0x44, 0x48, 0x50, 0x60, 0x40, 0x60, 0x50, 0x48, 0x44, 0, 0, 0, 0
 .ALIGN
CH76 .DW 8
 .DB 0, 0, 0, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH77 .DW 8
 .DB 0, 0, 0, 0x44, 0x6c, 0x54, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH78 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x64, 0x54, 0x4c, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH79 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH80 .DW 8
 .DB 0, 0, 0, 0x78, 0x44, 0x44, 0x44, 0x78, 0x40, 0x40, 0x40, 0x40, 0, 0, 0, 0
 .ALIGN
CH81 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0x10, 0x8, 0, 0
 .ALIGN
CH82 .DW 8
 .DB 0, 0, 0, 0x78, 0x44, 0x44, 0x44, 0x78, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH83 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x40, 0x40, 0x38, 0x4, 0x4, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH84 .DW 8
 .DB 0, 0, 0, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH85 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH86 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x28, 0x10, 0, 0, 0, 0
 .ALIGN
CH87 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x54, 0x6c, 0x44, 0, 0, 0, 0
 .ALIGN
CH88 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x28, 0x10, 0x28, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH89 .DW 8
 .DB 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x28, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH90 .DW 8
 .DB 0, 0, 0, 0x7c, 0x4, 0x4, 0x8, 0x10, 0x20, 0x40, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH91 .DW 8
 .DB 0, 0, 0x38, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x38, 0, 0, 0
 .ALIGN
CH92 .DW 8
 .DB 0, 0, 0, 0x40, 0x40, 0x20, 0x20, 0x10, 0x10, 0x8, 0x8, 0x4, 0x4, 0, 0, 0
 .ALIGN
CH93 .DW 8
 .DB 0, 0, 0x38, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x8, 0x38, 0, 0, 0
 .ALIGN
CH94 .DW 8
 .DB 0, 0, 0, 0x10, 0x28, 0x44, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH95 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xfe, 0, 0, 0, 0
 .ALIGN
CH96 .DW 8
 .DB 0, 0, 0, 0x10, 0x8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH97 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH98 .DW 8
 .DB 0, 0, 0, 0x40, 0x40, 0x40, 0x78, 0x44, 0x44, 0x44, 0x44, 0x78, 0, 0, 0, 0
 .ALIGN
CH99 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x44, 0x40, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH100 .DW 8
 .DB 0, 0, 0, 0x4, 0x4, 0x4, 0x3c, 0x44, 0x44, 0x44, 0x44, 0x3c, 0, 0, 0, 0
 .ALIGN
CH101 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x44, 0x7c, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH102 .DW 8
 .DB 0, 0, 0, 0xc, 0x10, 0x10, 0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH103 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x3c, 0x44, 0x44, 0x44, 0x44, 0x3c, 0x4, 0x44, 0x38, 0
 .ALIGN
CH104 .DW 8
 .DB 0, 0, 0, 0x40, 0x40, 0x40, 0x78, 0x44, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH105 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH106 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x60, 0
 .ALIGN
CH107 .DW 8
 .DB 0, 0, 0, 0x40, 0x40, 0x40, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0, 0, 0, 0
 .ALIGN
CH108 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH109 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x78, 0x54, 0x54, 0x54, 0x54, 0x54, 0, 0, 0, 0
 .ALIGN
CH110 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x78, 0x44, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH111 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH112 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x78, 0x44, 0x44, 0x44, 0x44, 0x78, 0x40, 0x40, 0, 0
 .ALIGN
CH113 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x3c, 0x44, 0x44, 0x44, 0x44, 0x3c, 0x4, 0x4, 0, 0
 .ALIGN
CH114 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x58, 0x64, 0x44, 0x40, 0x40, 0x40, 0, 0, 0, 0
 .ALIGN
CH115 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x44, 0x38, 0x4, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH116 .DW 8
 .DB 0, 0, 0, 0, 0x20, 0x20, 0x70, 0x20, 0x20, 0x20, 0x20, 0x18, 0, 0, 0, 0
 .ALIGN
CH117 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH118 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x28, 0x10, 0, 0, 0, 0
 .ALIGN
CH119 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x54, 0x54, 0x54, 0x54, 0x54, 0x28, 0, 0, 0, 0
 .ALIGN
CH120 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x44, 0x28, 0x10, 0x10, 0x28, 0x44, 0, 0, 0, 0
 .ALIGN
CH121 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x3c, 0x4, 0x44, 0x38, 0
 .ALIGN
CH122 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x7c, 0x8, 0x10, 0x20, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH123 .DW 8
 .DB 0, 0, 0x8, 0x10, 0x10, 0x10, 0x10, 0x20, 0x10, 0x10, 0x10, 0x10, 0x8, 0, 0, 0
 .ALIGN
CH124 .DW 8
 .DB 0, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0
 .ALIGN
CH125 .DW 8
 .DB 0, 0, 0x20, 0x10, 0x10, 0x10, 0x10, 0x8, 0x10, 0x10, 0x10, 0x10, 0x20, 0, 0, 0
 .ALIGN
CH126 .DW 8
 .DB 0, 0, 0, 0x34, 0x58, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH127 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH128 .DW 8
 .DB 0, 0x28, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH129 .DW 8
 .DB 0x38, 0x44, 0x44, 0x38, 0x44, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH130 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x40, 0x40, 0x40, 0x40, 0x44, 0x38, 0x10, 0x10, 0x20, 0
 .ALIGN
CH131 .DW 8
 .DB 0, 0x8, 0x10, 0x7c, 0x40, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x7c, 0, 0, 0, 0
 .ALIGN
CH132 .DW 8
 .DB 0x34, 0x58, 0, 0x44, 0x44, 0x64, 0x54, 0x4c, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH133 .DW 8
 .DB 0, 0x28, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH134 .DW 8
 .DB 0, 0x28, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH135 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH136 .DW 8
 .DB 0, 0, 0, 0x10, 0x8, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH137 .DW 8
 .DB 0, 0, 0, 0x10, 0x28, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH138 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH139 .DW 8
 .DB 0, 0, 0, 0x34, 0x58, 0, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH140 .DW 8
 .DB 0, 0, 0x18, 0x24, 0x24, 0x18, 0x3c, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH141 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x44, 0x40, 0x40, 0x44, 0x38, 0x10, 0x10, 0x20, 0
 .ALIGN
CH142 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0x38, 0x44, 0x7c, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH143 .DW 8
 .DB 0, 0, 0, 0x20, 0x10, 0, 0x38, 0x44, 0x7c, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH144 .DW 8
 .DB 0, 0, 0, 0x10, 0x28, 0, 0x38, 0x44, 0x7c, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH145 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x38, 0x44, 0x7c, 0x40, 0x40, 0x3c, 0, 0, 0, 0
 .ALIGN
CH146 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH147 .DW 8
 .DB 0, 0, 0, 0x20, 0x10, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH148 .DW 8
 .DB 0, 0, 0, 0x10, 0x28, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH149 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH150 .DW 8
 .DB 0, 0, 0, 0x34, 0x58, 0, 0x58, 0x64, 0x44, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH151 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH152 .DW 8
 .DB 0, 0, 0, 0x20, 0x10, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH153 .DW 8
 .DB 0, 0, 0, 0x30, 0x48, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH154 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH155 .DW 8
 .DB 0, 0, 0, 0x34, 0x58, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH156 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH157 .DW 8
 .DB 0, 0, 0, 0x20, 0x10, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH158 .DW 8
 .DB 0, 0, 0, 0x10, 0x28, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH159 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x34, 0, 0, 0, 0
 .ALIGN
CH160 .DW 8
 .DB 0, 0, 0, 0x10, 0x38, 0x10, 0x10, 0x10, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH161 .DW 8
 .DB 0, 0, 0, 0x30, 0x48, 0x48, 0x30, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH162 .DW 8
 .DB 0, 0, 0, 0, 0, 0x10, 0x38, 0x54, 0x50, 0x50, 0x54, 0x38, 0x10, 0, 0, 0
 .ALIGN
CH163 .DW 8
 .DB 0, 0, 0, 0x18, 0x20, 0x20, 0x20, 0x70, 0x20, 0x24, 0x24, 0x78, 0, 0, 0, 0
 .ALIGN
CH164 .DW 8
 .DB 0, 0, 0x38, 0x44, 0x20, 0x50, 0x48, 0x24, 0x14, 0x8, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH165 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x7c, 0x7c, 0x7c, 0x38, 0, 0, 0, 0, 0
 .ALIGN
CH166 .DW 8
 .DB 0, 0, 0, 0x3c, 0x54, 0x54, 0x54, 0x54, 0x3c, 0x14, 0x14, 0x14, 0, 0, 0, 0
 .ALIGN
CH167 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x48, 0x48, 0x44, 0x44, 0x44, 0x58, 0x40, 0, 0, 0
 .ALIGN
CH168 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH169 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH170 .DW 8
 .DB 0, 0, 0, 0xf4, 0x5c, 0x5c, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH171 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH172 .DW 8
 .DB 0, 0, 0, 0x28, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH173 .DW 8
 .DB 0, 0, 0, 0, 0, 0x8, 0x7c, 0x10, 0x7c, 0x20, 0, 0, 0, 0, 0, 0
 .ALIGN
CH174 .DW 8
 .DB 0, 0, 0, 0x3c, 0x50, 0x50, 0x50, 0x7c, 0x50, 0x50, 0x50, 0x5c, 0, 0, 0, 0
 .ALIGN
CH175 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x4c, 0x54, 0x64, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH176 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0x6c, 0x54, 0x6c, 0, 0, 0, 0, 0, 0
 .ALIGN
CH177 .DW 8
 .DB 0, 0, 0, 0, 0, 0x10, 0x10, 0x7c, 0x10, 0x10, 0, 0x7c, 0, 0, 0, 0
 .ALIGN
CH178 .DW 8
 .DB 0, 0, 0, 0, 0x8, 0x10, 0x20, 0x40, 0x20, 0x10, 0x8, 0x7c, 0, 0, 0, 0
 .ALIGN
CH179 .DW 8
 .DB 0, 0, 0, 0, 0x20, 0x10, 0x8, 0x4, 0x8, 0x10, 0x20, 0x7c, 0, 0, 0, 0
 .ALIGN
CH180 .DW 8
 .DB 0, 0, 0, 0x44, 0x28, 0x7c, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH181 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x44, 0x44, 0x44, 0x44, 0x4c, 0x74, 0x40, 0x40, 0, 0
 .ALIGN
CH182 .DW 8
 .DB 0, 0, 0, 0, 0x30, 0x8, 0x1c, 0x24, 0x44, 0x44, 0x48, 0x30, 0, 0, 0, 0
 .ALIGN
CH183 .DW 8
 .DB 0, 0, 0, 0x7c, 0x44, 0x20, 0x10, 0x8, 0x10, 0x20, 0x44, 0x7c, 0, 0, 0, 0
 .ALIGN
CH184 .DW 8
 .DB 0, 0, 0, 0x7c, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0, 0, 0, 0
 .ALIGN
CH185 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x7c, 0x28, 0x28, 0x28, 0x28, 0x28, 0, 0, 0, 0
 .ALIGN
CH186 .DW 8
 .DB 0, 0xc, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x60, 0, 0
 .ALIGN
CH187 .DW 8
 .DB 0, 0, 0, 0x3c, 0x44, 0x44, 0x44, 0x3c, 0, 0x7c, 0, 0, 0, 0, 0, 0
 .ALIGN
CH188 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x38, 0, 0x7c, 0, 0, 0, 0, 0, 0
 .ALIGN
CH189 .DW 8
 .DB 0, 0, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x28, 0x28, 0x6c, 0, 0, 0, 0
 .ALIGN
CH190 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x54, 0x5c, 0x50, 0x54, 0x38, 0, 0, 0, 0
 .ALIGN
CH191 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x38, 0x4c, 0x54, 0x64, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH192 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0, 0x10, 0x10, 0x20, 0x40, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH193 .DW 8
 .DB 0, 0, 0, 0x10, 0x10, 0, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, 0, 0, 0
 .ALIGN
CH194 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0x7c, 0x4, 0x4, 0, 0, 0, 0, 0, 0
 .ALIGN
CH195 .DW 8
 .DB 0, 0, 0, 0xc, 0x8, 0x8, 0x8, 0x8, 0x8, 0x68, 0x18, 0x8, 0, 0, 0, 0
 .ALIGN
CH196 .DW 8
 .DB 0, 0xc, 0x10, 0x10, 0x10, 0x10, 0x38, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x60, 0, 0
 .ALIGN
CH197 .DW 8
 .DB 0, 0, 0, 0, 0, 0x4, 0x38, 0x44, 0x38, 0x40, 0, 0, 0, 0, 0, 0
 .ALIGN
CH198 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x10, 0x10, 0x28, 0x28, 0x44, 0x7c, 0, 0, 0, 0
 .ALIGN
CH199 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x14, 0x28, 0x50, 0x50, 0x28, 0x14, 0, 0, 0, 0
 .ALIGN
CH200 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x50, 0x28, 0x14, 0x14, 0x28, 0x50, 0, 0, 0, 0
 .ALIGN
CH201 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x54, 0, 0, 0, 0
 .ALIGN
CH202 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH203 .DW 8
 .DB 0, 0x20, 0x10, 0x38, 0x44, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH204 .DW 8
 .DB 0x34, 0x58, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x7c, 0x44, 0x44, 0x44, 0, 0, 0, 0
 .ALIGN
CH205 .DW 8
 .DB 0x34, 0x58, 0, 0x38, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x38, 0, 0, 0, 0
 .ALIGN
CH206 .DW 8
 .DB 0, 0, 0, 0x3c, 0x50, 0x50, 0x50, 0x5c, 0x50, 0x50, 0x50, 0x3c, 0, 0, 0, 0
 .ALIGN
CH207 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x28, 0x54, 0x5c, 0x50, 0x54, 0x28, 0, 0, 0, 0
 .ALIGN
CH208 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0x38, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH209 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0, 0, 0x7c, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH210 .DW 8
 .DB 0, 0, 0, 0x24, 0x48, 0x6c, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH211 .DW 8
 .DB 0, 0, 0, 0x6c, 0x24, 0x48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH212 .DW 8
 .DB 0, 0, 0, 0x8, 0x10, 0x18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH213 .DW 8
 .DB 0, 0, 0, 0x18, 0x8, 0x10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
 .ALIGN
CH214 .DW 8
 .DB 0, 0, 0, 0, 0, 0x10, 0, 0x7c, 0, 0x10, 0, 0, 0, 0, 0, 0
 .ALIGN
CH215 .DW 8
 .DB 0, 0, 0, 0, 0, 0, 0x10, 0x28, 0x44, 0x28, 0x10, 0, 0, 0, 0, 0
 .ALIGN
CH216 .DW 8
 .DB 0, 0, 0, 0, 0x28, 0, 0x44, 0x44, 0x44, 0x44, 0x44, 0x3c, 0x4, 0x4, 0x38, 0
 .ALIGN
CH217 .DW 8
 .DB 0xc, 0x18, 0x28, 0x28, 0x10, 0x10, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x38, 0
#line 3865 "T4th6.tal"
#line 1 "term.tal"
;------------------------------------------------------------------
; Terminal emulator for NuBus video displays
; created 6 Apr 88
; by Charles Vollum & Wayne Davison
;
; Copyright  1988 Cogent Research, Inc.
;------------------------------------------------------------------


 .pub screen,plotChar,cCursTog

 .align
screen:
 .dw 0xF4000000+1024  
 .dw 1024  
 .dw 1  
 .dw 0  
 .dw 0,0,807,1023  

 .ext drawChr,xorChr
 .ext wScroll
 .ext wFill
;------------------------------------------------------------------
; Output a character to a window, wrapping at end of line.
; handle control characters CR, LF, and BS.

 .val B,6
 .val A,5
 .val locals,4
 .val ulCursor,3
 .val fp,2
 .val cp,1
 .val last,0

plotChar:  
 ajw -locals

 ldl A
 call @cCursTog  

 ldl A
 ldnl 9
 stl fp  

; check for control characters and handle
 ldl B
 eqc 13
 cj @notCR

 ldc 0
 ldl A
 stnl 4  
 j @plotDone

notCR:
 ldl B
 eqc 10
 cj @notLF

 ldl A
 call @wWrap  
 j @plotDone

notLF:
 ldl B
 eqc 8
 cj @notBS

 ldl A
 ldnl 4
 cj @plotDone

 ldl A
 ldnl 4
 ldl fp
 dup
 ldnl 4
 add
 ldnl 0
 sub
 dup
 ldl A
 stnl 4  
 ldc 0
 rev
 gt
 cj @plotDone
 ldc 0
 ldl A
 stnl 4  

notBS:
; it's not a control character.  is it printable?
 ldl fp
 ldnl 0
 ldl B
 gt
 eqc 0
 cj @plotDone
 ldl B
 ldl fp
 ldnl 1
 gt
 eqc 0
 cj @plotDone

; it is a character in our table, so plot it!
; first compute the address of the character.
 ldl B
 ldl fp
 ldnl 0
 sub
 ldl fp
 ldnlp 5
 wsub
 ldnl 0
 ldl fp
 add
 stl cp

; check if this char will overflow the current line.
 ldl cp
 ldnl 0
 ldl A
 ldnl 4
 add
 ldl A
 ldnl 3
 ldl A
 ldnl 1
 sub
 gt
 cj @plotit

 ldl A
 call @wWrap  

plotit:
; compute address of byte that holds the upper left of cursor
 ldl A
 call @cursPtr
 stl ulCursor

; call drawChr(cp, ulCursor, 3, 2)
 ldl fp
 ldnl 2
 stl last

 ldl fp
 ldnl 3

 ldl ulCursor

 ldl cp

 call @drawChr

; increment the cursor to the next char position
 ldl A
 ldnl 4
 ldl cp
 ldnl 0
 add
 dup
 ldl A
 stnl 4

 ldl fp
 ldnl 4
 ldl fp
 add
 ldnl 0
 add  
 ldl A
 ldnl 3
 ldl A
 ldnl 1
 sub
 gt
 cj @plotDone

 ldl A
 call @wWrap  

plotDone:
 ldl A
 call @cCursTog  

 ajw locals
 ret

;------------------------------------------------------------------
; Toggle display of the character cursor at the current cursor
; location

 .val A,4
 .val locals,3
 .val ulCursor,2
 .val cursChar,1
 .val last,0

cCursTog:  
 ajw -locals

; compute address of byte that holds the upper left of cursor
 ldl A
 call @cursPtr
 stl ulCursor

; compute the address of the cursor character
 ldl A
 ldnl 9
 dup
 stl last  
 ldnl 4
 ldl last
 add
 stl cursChar

; call xorChr(cursChar, ulCursor, 3, 2)
 ldl last
 dup
 ldnl 2
 stl last

 ldnl 3

 ldl ulCursor

 ldl cursChar

 call @xorChr

 ajw locals
 ret

;------------------------------------------------------------------
; Hide the character cursor

 .val A,4
 .val locals,3
 .val ulCursor,2
 .val cursChar,1
 .val last,0

cCursOff:  
 ajw -locals

; compute address of byte that holds the upper left of cursor
 ldl A
 call @cursPtr
 stl ulCursor

; compute the address of the cursor character
 ldl A
 ldnl 9
 dup
 stl last  
 ldnl 4
 ldl last
 add
 stl cursChar

; call wFill(ulCursor, cursChar.0, 3, 8)
 ldl last
 ldnl 3

 ldl A
 ldnl 8
 stl last

 ldl cursChar
 ldnl 0
 ldc 3  
 shr  

 ldl ulCursor

 call @wFill

 ajw locals
 ret

;------------------------------------------------------------------
; Adjust 4 to left edge of window, and move 5 down
; one line. If needed, scroll up one line.


 .val A,1

wWrap:  
 ldc 0
 ldl A
 stnl 4  

 ldl A
 ldnl 5
 ldl A
 ldnl 9
 ldnl 3
 ldc 1
 shl
 add
 adc -1
 ldl A
 ldnl 2
 ldl A
 ldnl 0
 sub
 gt  
 cj @noscroll  

 ldl A
 call @scrollLine
 j @wrapup

noscroll:
 ldl A
 ldnl 5
 ldl A
 ldnl 9
 ldnl 3
 add
 ldl A
 stnl 5  

wrapup:
 ret

;------------------------------------------------------------------
; Scroll a window up one line.

 .val A,5
 .val locals,4
 .val widthBytes,3
 .val ulWindow,2
 .val ulCursor,1
 .val last,0

scrollLine:  
 ajw -locals

; compute width of window scan line in bytes (widthBytes)
 ldl A
 ldnl 3
 ldl A
 ldnl 1
 sub
 adc 1
 ldc screen
 ldnl 2
 prod
 ldc 3
 shr  
 stl widthBytes

; compute address of byte that holds the upper left of bottom line
 ldl A
 call @cursPtr
 stl ulCursor

; compute address of byte that holds the upper left of the window
 ldl A
 ldnl 1
 ldc screen
 ldnl 2
 prod
 ldc 3
 shr  

 ldl A
 ldnl 0
 ldc screen
 ldnl 1
 prod  

 add

 ldc screen
 ldnl 0  

 add

 stl ulWindow

; call wScroll(ulWindow, widthBytes, 9.3, 5)
 ldl A
 ldnl 5
 stl last

 ldl A
 ldnl 9
 ldnl 3

 ldl widthBytes

 ldl ulWindow

 call @wScroll

; now call wFill(ulCursor, widthBytes, 9.3, 8)
 ldl A
 ldnl 8
 stl last

 ldl A
 ldnl 9
 ldnl 3

 ldl widthBytes

 ldl ulCursor

 call @wFill

 ajw locals
 ret

;------------------------------------------------------------------
; Compute the address of the byte holding the upper left pixel of
; the current cursor location.

 .val A,1

cursPtr:  
 ldl A
 ldnl 4
 ldl A
 ldnl 1
 add
 ldc screen
 ldnl 2
 prod
 ldc 3
 shr  

 ldl A
 ldnl 5
 ldl A
 ldnl 0
 add
 ldc screen
 ldnl 1
 prod  

 add
 ldc screen
 ldnl 0  

 add

 ret
#line 3866 "T4th6.tal"

#line 1 "DKIO.TAL"
; There are a number of references of the form

; Z1772+CMDREG or Z1772+STAREG

; These references are an incorrect mixture of apples and oranges but
; since CMDREG & STAREG are both zero the arithmetic is correct and allows the
; references to them to be found without pain or making the code longer.

; It would be nice if I could read the dma counters to determine if the correct
; number of bytes were input/output. Sometimes the 1772 in the ST says it
; completed when it has not really done so. I check it there by looking at
; the contents of the DMA address register.

; How about 1.4 meg 3.5 inch

; No attempt has been made to enable or inhibit context switches.

; All routines except those with a "HEAD" macro, use "C" calling sequence

; How about having the fifoclr state indicate fifo or direct i/o?
; If fifoclr =0 then direct i/o if fifoclr=1 then use the fifo


 .set CMRES , 0x00 ;1772 COMMAND TO RESTORE DISK
 .set CMSEEK , 0x10 ;1772 COMMAND TO SEEK NO VERIFY
 .set CMRSEC , 0x80 ;1172 COMMAND TO READ SECTOR
 .set CMRSET , 0xD0 ;1772 COMMAND TO RESET
 .set CMRDTR , 0xE0 ;1772 COMMAND TO READ TRACK
 .set CMSTPN , 0x50 ;1772 COMMAND TO STEP IN ONE TRACK
 .set CMSTPO , 0x70 ;1772 COMMAND TO STEP OUT ONE TRACK
 .set CMWRTR , 0xF0 ;1772 COMMAND TO WRITE TRACK
 .set CMWSEC , 0xA0 ;1172 COMMAND TO WRITE SECTOR

 .set REV3 , 600000/64 ;TIME FOR 3 REVS
 .set REV5 , 1000000/64 ;TIME FOR 5 REVS

 .set RETRY , 4 ;NUMBER OF RETRIES FOR SECTOR I/O

 .set FDCSEL0 , 0X4A000020 ;FLOPPY ZERO SELECT
 .set FDCSIDE , 0X4A00002C ;FLOPPY SIDE SELECT
 .set WD1772 , 0x5A000000 ;1772 BASE ADDRESS

 .set CMDREG , 0 ;1772 COMMAND REGISTER
 .set STAREG , CMDREG ;1772 STATUS REGISTER
 .set TRKREG , CMDREG+4 ;1772 TRACK REGISTER
 .set SECREG , TRKREG+4 ;1772 SECTOR REGISTER
 .set DATREG , SECREG+4 ;1772 DATA REGISTER

; WORK SPACE DEFINATIONS

 .set CDRIVE , 0 ;DRIVE NUMBER
 .set CSIDE , CDRIVE+1 ;SIDE NUMBER 0=BOTTOM 1=TOP
 .set CTRACK , CSIDE+1 ;TRACK NUMBER 0 <= N <= 79
 .set CSECTR , CTRACK+1 ;SECTOR NUMBER 1 <= N <= 10
 .set CCOUNT , CSECTR+1 ;SECTORS TO READ/WRITE
 .set CBUFF , CCOUNT+1 ;CURRENT LOCATION IN BUFFER
 .set CBUFFE , CBUFF+1 ;PAST END OF CURRENT READ/WRITE
 .set XBUFF , CBUFFE+1 ;START OF CURRENT SECTOR
 .set Z1772 , XBUFF+1 ;QUICK ACCESS TO WD1772
 .set RETCNT , Z1772+1 ;RETRY ERROR COUNT
 .set MIDERR , RETCNT+1 ;MID POINT IN ERROR RECOVERY
 .set FDCTIME , MIDERR+1 ;TEMP FOR TIME OUTS
 .set RESRET , FDCTIME+1 ;RETURN ADDRESS FOR RESTORE
 .set FSETRET , RESRET+1 ;ALL ROUTINES CALL FLOPSET AT ENTRY
 ;THIS IS WHERE THE RETURN ADDRESS FOR
 ;THAT CALL WILL BE STORED. THE CALL
 ;INSTRUCTION ALLOCATES THIS LOCATION &
 ;THE NEXT THREE TEMPS.
 .set FDCTMP , FSETRET+1
 .set FDCTMP1 , FDCTMP+1
 .set FDCTMP2 , FDCTMP1+1
 .set FSCRATCH , FDCTMP2+1 ;NUMBER OF ALLOCATED LOCATIONS

; THE FOLLOWING ARE USED BY THE FORMAT GENERATOR

;.set ZSBYTE , RESRET ;QUICK REFERENCE TO SBYTE
;.set ZFILL , FDCTMP ;QUICK REFERENCE TO FILL
 .set FBYTE , FDCTMP1 ;BYTE FOR THE CURRENT PATTERN
 .set FILCNT , FDCTMP2 ;NUMBER OF BYTES IN CURRENT PATTERN
 .set FRET , FSETRET ;RETURN ADDRESS FOR FILL

; THE FOLLOWING ARE ALLOCATED BY THE CALLER

 .set FUSRRET , FSCRATCH ;THE USER RETURN ADDRESS
 .set PDRIVE , FUSRRET+1 ;0 DEVICE
 .set PSIDE , PDRIVE+1 ;1 SIDE
 .set PTRACK , PSIDE+1 ;2 TRACK
 .set PSECTR , PTRACK+1 ;3 STARTING SECTOR
 .set PCOUNT , PSECTR+1 ;4 NUMBER OF SECTORS
 .set PBUFF , PCOUNT+1 ;5 BUFFER ADDRESS
#line 105
 
#line 105
 .align
#line 105
???343
#line 105
 .dbnz 0X84,"3R/",0X80+'W'
#line 105
 .align
#line 105
 .dw ???342
#line 105
; 343
#line 105
 ;3R/W
RRSW: .DW DOCOL,TOR ;R/W FLAG
 .DW TWO,SWAP ;DO 2 SECTORS
 .DW LIT,5000,SLMOD,TOR ;DRIVE #
 .DW LIT,10,SLMOD,TOR ;TRACK #
 .DW LIT,5,SLMOD ;SIDE & SECTOR #
 .DW SWAP,TWOST,ONEP,SWAP ;SECTOR #'s START WITH 1
 .DW FROMR ;TRACK TO PARAMETER STACK
 .DW SWAP ;SIDE TO TOP
 .DW FROMR ;DRIVE TO PARAMETER STACK
 .DW FROMR,ZBRAN ;R/W FLAG TO PARAMETER STACK
RRSWZ .DW RRSW4-RRSWZ,FREAD,BRAN ;FLAG=1>>READ
RRSWY .DW RRSW8-RRSWY
RRSW4: .DW FWRITE ;FLAG=0>>WRITE
RRSW8: .DW DDROP,EXIT ;DROP ERROR INFO

; THIS ASSUMES ALL DRIVES HAVE 5000 BLOCKS ON THEM AND BLOCK ZERO IS THE
; FIRST BLOCK ON EACH DRIVE

; CALLING SEQUENCE BUFFER_ADDRESS BLOCK# R/W_FLAG 3R/W -- NULL

; YOU MIGHT WANT TO DO SOMETHING ABOUT ERRORS....



 
#line 130
 .align
#line 130
???344
#line 130
 .dbnz 0X88,"FLOPREA",0X80+'D'
#line 130
 .align
#line 130
 .dw ???343
#line 130
; 344
FREAD: .DW FREAD+BPW
 AJW -3 ;ALLOCATE EXTRA PARAMETERS
 LDL PARSTK+3
 LDNL P5
 STL 2 ;BUFFER ADDRESS

 LDL PARSTK+3
 LDNL P4
 STL 1 ;COUNT

 LDL PARSTK+3
 LDNL P3
 STL 0 ;STARTING SECTOR

 LDL PARSTK+3
 LDNL P2 ;TRACK NUMBER

 LDL PARSTK+3
 LDNL P1 ;SIDE

 LDL PARSTK+3
 LDNL P0 ;DRIVE

 CALL @FLOPRD
 AJW 3 ;CLEAR STACK

 LDL PARSTK ;NOW FIX USER PARAMETER STACK
 ADC 4*BPW ;WAS 6 PARAMETERS NOW WANT 2
 STL PARSTK

 LDL PARSTK
 STNL P0 ;SAVE ERROR FLAG

 LDL PARSTK
 STNL P1 ;SAVE ERROR STATUS

 LDL NEXT
 GCALL


 
#line 171
 .align
#line 171
???345
#line 171
 .dbnz 0X89,"FLOPWRIT",0X80+'E'
#line 171
 .align
#line 171
 .dw ???344
#line 171
; 345
FWRITE: .DW FWRITE+BPW
 AJW -3 ;ALLOCATE EXTRA PARAMETERS
 LDL PARSTK+3
 LDNL P5
 STL 2 ;BUFFER ADDRESS

 LDL PARSTK+3
 LDNL P4
 STL 1 ;COUNT

 LDL PARSTK+3
 LDNL P3
 STL 0 ;STARTING SECTOR

 LDL PARSTK+3
 LDNL P2 ;TRACK NUMBER

 LDL PARSTK+3
 LDNL P1 ;SIDE

 LDL PARSTK+3
 LDNL P0 ;DRIVE

 CALL @FLOPWR
 AJW 3 ;CLEAR STACK

 LDL PARSTK ;NOW FIX USER PARAMETER STACK
 ADC 4*BPW ;WAS 6 PARAMETERS NOW WANT 2
 STL PARSTK

 LDL PARSTK
 STNL P0 ;SAVE ERROR FLAG

 LDL PARSTK
 STNL P1 ;SAVE ERROR STATUS

 LDL NEXT
 GCALL


 
#line 212
 .align
#line 212
???346
#line 212
 .dbnz 0X88,"FLOPRAT",0X80+'E'
#line 212
 .align
#line 212
 .dw ???345
#line 212
; 346
 .DW DOCON,DRVRATE ;SEEK RATE VECTOR

 
#line 215
 .align
#line 215
???347
#line 215
 .dbnz 0X87,"FLOPFM",0X80+'T'
#line 215
 .align
#line 215
 .dw ???346
#line 215
; 347
FFMT: .DW FFMT+BPW
XFMT: AJW -3 ;ALLOCATE EXTRA PARAMETERS
 LDL PARSTK+3
 LDNL P5
 STL 2 ;BUFFER ADDRESS

 LDL PARSTK+3
 LDNL P4
 STL 1 ;COUNT

 LDL PARSTK+3
 LDNL P3
 STL 0 ;STARTING SECTOR

 LDL PARSTK+3
 LDNL P2 ;TRACK NUMBER

 LDL PARSTK+3
 LDNL P1 ;SIDE

 LDL PARSTK+3
 LDNL P0 ;DRIVE

 CALL @FMTRACK
 AJW 3 ;CLEAR STACK

 LDL PARSTK ;NOW FIX USER PARAMETER STACK
 ADC 4*BPW ;WAS 6 PARAMETERS NOW WANT 2
 STL PARSTK

 LDL PARSTK
 STNL P0 ;SAVE ERROR FLAG

 LDL PARSTK
 STNL P1 ;SAVE ERROR STATUS

 LDL NEXT
 GCALL

; FLOPRD

; 5 buffer address
; 4 number of sectors to read (must all be on current surface)
; 3 starting sector number (sector numbers start with 1)
; 2 track number (track numbers start with 0)
; 1 0=bottom side 1=top side
; 0 device (0 <= N <= 3)

; EXIT AREG<>0 ERROR AREG=0 OK
;
; BREG=08 ID HEADER PRESENT CRC ERROR ON DATA
; BREG=10 ID HEADER PRESENT NO (OR BAD) DATA HEADER
; BREG=18 ID HEADER NOT PRESENT OR CRC ERROR


FLOPRD: CALL @FLOPSET ;SETUP FLOPPIES
FRD0: CALL @SEEKNV ;LOAD TRACK REGISTER
 EQC 0
 CJ @FRDE1 ;BRANCH IF AN ERROR

FRD1: LDL CSECTR ;GET CURRENT SECTOR
 LDL Z1772
 ADC SECREG ;POINT TO 1772 SECTOR REGISTER
 SB ;AND SET IT
 LDL XBUFF ;SET START OF BUFFER
 STL CBUFF
 LDL CBUFF ;GET START OF BUFFER ADDRESS
 ADC 512 ;POINT TO END OF BUFFER
 STL CBUFFE ;AND SAVE FOR CHECK
 LDC CMRSEC ;READ SECTOR COMMAND
 LDL Z1772+CMDREG
 SB ;START 1772

 LDTIMER ;GET CURRENT TIME
 ADC REV3+REV3
 STL FDCTIME ;SAVE AS ENDING TIME
 
#line 292
 LDC 32*20 ;WAIT 32 uSEC
#line 292
 SHL

FRBYTE: LDL Z1772+STAREG
 LB ;GET 1772 STATUS
 LDC 0X02 ;CHECK DRQ
 AND
 CJ @FRD2 ;BRANCH IF NO BYTE
 LDL Z1772
 ADC DATREG
 LB ;GET DATA BYTE FROM 1772
 LDL CBUFF ;BUFFER ADDRESS FOR BYTE
 SB ;SAVE BYTE IN BUFFER
 LDL CBUFF
 ADC 1 ;POINT TO NEXT BUFFER LOCATION
 STL CBUFF
 LDL CBUFFE ;CHECK IF DONE
 LDL CBUFF
 DIFF
 EQC 0
 CJ @FRBYTE

FRDXZ: LDL Z1772+STAREG
 LB ;GET 1772 STATUS
 LDC 0X01 ;CHECK BUSY
 AND
 CJ @FRDZZ ;BRANCH IF NOT BUSY

 LDTIMER ;CURRENT TIME
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT ;1 IF ENOUGH TIME
 CJ @FRDXZ
FRDZZ: LDL Z1772+STAREG
 LB ;CHECK STATUS
 LDC 0x1C ;RNF & CRC & LOST DATA
 AND
 CJ @FRDOK ;BRANCH IF NO ERROR
 J @FRDE ;AND TRY AGAIN

FRD2: LDTIMER ;CURRENT TIME
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT ;1 IF ENOUGH TIME
 CJ @FRBYTE

FRDE: LDC 2 ;CHECK FOR MULTIPLE SECTOR READ
 LDL PCOUNT
 GT ;1 IF COUNT IS < 2
 CJ @FRBAD ;EXIT IF MULTIPLE

 
#line 344
 LDC CMRSET ;RESET COMMAND
#line 344
 LDL Z1772+CMDREG
#line 344
 SB
#line 344
 LDC 32*20 ;WAIT 32 uSEC
#line 344
 SHL
#line 344
 ;RESET THE 1772
 LDL RETCNT ;CHECK FOR MIDDLE ERROR
 LDL MIDERR
 DIFF
 EQC 0
 CJ @FRD5
FRDE1: CALL @RESTOR  
 CALL @SEEKNV
FRD5: LDL RETCNT
 ADC -1 ;COUNT DOWN ERROR COUNTER
 STL RETCNT
 LDC 0
 LDL RETCNT ;CHECK IF TOO MANY ERRORS
 GT
 CJ @FRD0 ;BRANCH BACK IF LIFE LEFT

FRBAD: LDL Z1772+STAREG ;GET THE STATUS AGAIN
 LB
 LDC 1 ;INDICATE ERROR
 AJW FSCRATCH ;CLEAN UP WORK SPACE
 RET

FRDOK: LDL CBUFF
 STL XBUFF ;SET START OF NEXT SECTOR
 LDL CSECTR
 ADC 1 ;TO NEXT SECTOR
 STL CSECTR
 LDL CCOUNT
 ADC -1 ;COUNT DOWN SECTORS TO DO
 STL CCOUNT
 LDC 1
 LDL CCOUNT
 GT ;1 IF COUNT <= 0
 CJ @FRD1 ;TRY AGAIN IF NOT NOT DONE

 LDC 0 ;INDICATE NO ERROR
 AJW FSCRATCH ;CLEAN UP WORK SPACE
 RET

; FLOPWR

; 5 buffer address
; 4 number of sectors to read (must all be on current surface)
; 3 starting sector number (sector numbers start with 1)
; 2 track number (track numbers start with 0)
; 1 0=bottom side 1=top side
; 0 device (0 <= N <= 3)

; EXIT AREG<>0 ERROR AREG=0 OK
;
; BREG=08 ID HEADER PRESENT CRC ERROR ON DATA
; BREG=10 ID HEADER PRESENT NO (OR BAD) DATA HEADER
; BREG=18 ID HEADER NOT PRESENT OR CRC ERROR


FLOPWR: CALL @FLOPSET ;SETUP FLOPPIES
FWR0: CALL @SEEKNV ;LOAD TRACK REGISTER
 EQC 0
 CJ @FWRE1 ;BRANCH IF AN ERROR

FWR1: LDL CSECTR ;GET CURRENT SECTOR
 LDL Z1772
 ADC SECREG ;POINT TO 1772 SECTOR REGISTER
 SB ;AND SET IT
 LDL XBUFF ;SET START OF BUFFER
 STL CBUFF
 LDL CBUFF ;GET START OF BUFFER ADDRESS
 ADC 512 ;POINT TO END OF BUFFER
 STL CBUFFE ;AND SAVE FOR CHECK
 LDC CMWSEC ;WRITE SECTOR COMMAND
 LDL Z1772+CMDREG
 SB ;START 1772

 LDTIMER ;GET CURRENT TIME
 ADC REV3+REV3
 STL FDCTIME ;SAVE AS ENDING TIME
 
#line 420
 LDC 32*20 ;WAIT 32 uSEC
#line 420
 SHL

FWBYTE: LDL Z1772+STAREG
 LB ;GET 1772 STATUS
 LDC 0X02 ;CHECK DRQ
 AND
 CJ @FWR2 ;BRANCH IF NO BYTE
 LDL CBUFF ;BUFFER ADDRESS FOR BYTE
 LB ;GET BYTE
 LDL Z1772
 ADC DATREG
 SB ;SEND DATA BYTE TO 1772
 LDL CBUFF
 ADC 1 ;POINT TO NEXT BUFFER LOCATION
 STL CBUFF
 LDL CBUFFE ;CHECK IF DONE
 LDL CBUFF
 DIFF
 EQC 0
 CJ @FWBYTE

FWRXZ: LDL Z1772+STAREG
 LB ;GET 1772 STATUS
 LDC 0X01 ;CHECK BUSY
 AND
 CJ @FWRZZ ;BRANCH IF NOT BUSY

 LDTIMER ;CURRENT TIME
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT ;1 IF ENOUGH TIME
 CJ @FWRXZ
FWRZZ: LDL Z1772+STAREG
 LB ;CHECK STATUS
 LDC 0x5C ;WRITE PROTECT & RNF & CRC & LOST DATA
 AND
 CJ @FWROK ;BRANCH IF NO ERROR
 J @FWRE ;AND TRY AGAIN

FWR2: LDTIMER ;CURRENT TIME
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT ;1 IF ENOUGH TIME
 CJ @FWBYTE

FWRE: LDC 2 ;CHECK FOR MULTIPLE SECTOR READ
 LDL PCOUNT
 GT ;1 IF COUNT IS < 2
 CJ @FWBAD ;EXIT IF MULTIPLE

 
#line 472
 LDC CMRSET ;RESET COMMAND
#line 472
 LDL Z1772+CMDREG
#line 472
 SB
#line 472
 LDC 32*20 ;WAIT 32 uSEC
#line 472
 SHL
#line 472
 ;RESET THE 1772
 LDL RETCNT ;CHECK FOR MIDDLE ERROR
 LDL MIDERR
 DIFF
 EQC 0
 CJ @FWR5
FWRE1: CALL @RESTOR  
 CALL @SEEKNV
FWR5: LDL RETCNT
 ADC -1 ;COUNT DOWN ERROR COUNTER
 STL RETCNT
 LDC 0
 LDL RETCNT ;CHECK IF TOO MANY ERRORS
 GT
 CJ @FWR0 ;BRANCH BACK IF LIFE LEFT

FWBAD: LDL Z1772+STAREG ;GET THE STATUS AGAIN
 LB
 LDC 1 ;INDICATE ERROR
 AJW FSCRATCH ;CLEAN UP WORK SPACE
 RET

FWROK: LDL CBUFF
 STL XBUFF ;SET START OF NEXT SECTOR
 LDL CSECTR
 ADC 1 ;TO NEXT SECTOR
 STL CSECTR
 LDL CCOUNT
 ADC -1 ;COUNT DOWN SECTORS TO DO
 STL CCOUNT
 LDC 1
 LDL CCOUNT
 GT ;1 IF COUNT <= 0
 CJ @FWR1 ;TRY AGAIN IF NOT NOT DONE

 LDC 0 ;INDICATE NO ERROR
 AJW FSCRATCH ;CLEAN UP WORK SPACE
 RET

; FMTRACK BUILD STANDARD TRACK PROTOTYPE

; 5 buffer to build image in (6500 bytes long)
; 4 number of sectors on surface
; 3 starting sector number
; 2 track number (track numbers start with 0)
; 1 0=bottom side 1=top side
; 0 device (0 <= N <= 3)

; The caller can create a spiral sector pattern by setting the starting
; sector to a different value on each track.

; EXIT AREG=0 ERROR AREG<>0 OK

FMTRACK CALL @FLOPSET ;GET SOME STORAGE & SETUP
; LDC FFILL ;FILL ROUTINE
; STL ZFILL
; LDC SBYTE ;ROUTINE TO SET ONE BYTE
; STL ZSBYTE

 LDC 0
 STL CCOUNT ;COUNT OF BYTES IN FIFO

 LDC 60 ;60 * 4E (INITIAL TRACK GAP)
 LDC 0x4E
 CALL @FFILL

FMTR04: LDC 12 ;12 * 0 SYNC UP AREA
 LDC 0
 CALL @FFILL

 LDC 3 ;3 * A1 SYNC
 LDC 0xF5
 CALL @FFILL

 LDC 0xFE ;ADDRESS HEADER
 CALL @SBYTE

 LDL CTRACK ;TRACK 0/79
 CALL @SBYTE

 LDL CSIDE ;SIDE 0/1
 CALL @SBYTE

 LDL CSECTR ;SECTOR
 CALL @SBYTE

 LDC 0x02 ;SECTOR SIZE 2=512 BYTES
 CALL @SBYTE

 LDC 0xF7 ;WRITE CHECKSUM
 CALL @SBYTE

 LDC 22 ;22 * 4E GAP BETWEEN ADDRESS & DATA
 LDC 0x4E
 CALL @FFILL

 LDC 12 ;12 * 0 SYNC UP AREA
 LDC 0
 CALL @FFILL

 LDC 3 ;3 * A1 SYNC
 LDC 0xF5
 CALL @FFILL

 LDC 0xFB ;DATA HEADER
 CALL @SBYTE

 LDC 512 ;512 BYTES OF DATA
 LDC 0xE5 ;VIRGIN DATA
 CALL @FFILL

 LDC 0xF7 ;WRITE CHECKSUM
 CALL @SBYTE

; LDL CCOUNT ;F7 CODE WRITES TWO BYTES
; ADC 2 ;COMPENSATE FOR CHECKSUM BYTES
; STL CCOUNT ;REMOVE COMMENT IF YOU CARE ABOUT EXACT COUNT

 LDC 40 ;40 * 4E GAP BETWEEN DATA & ADDRESS
 LDC 0x4E
 CALL @FFILL

 LDL CSECTR
 ADC 1 ;INCREMENT SECTOR NUMBER
 STL CSECTR
 LDL CSECTR
 LDL PCOUNT ;PAST LAST SECTOR ON TRACK?
 GT
 CJ @FMT12
 LDC 1 ;START SPIRAL SECTORS OVER
 STL CSECTR

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MINOR CHANGE TO PRECEEDING SECTION TO CREATE INTERLACE PATTERN ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FMT12: LDL CSECTR ;CHECK FOR DONE
 LDL PSECTR
 DIFF
 EQC 0
 CJ @FMTR04 ;DO NEXT SECTOR IF NOT DONE

 LDC 6499 ;PUT THIS MANY BYTES INTO THE FIFO
 LDL CCOUNT ;NUMBER OF BYTES IN FIFO NOW
 DIFF ;HAVE NUMBER OF FILLER BYTES
 LDC 0x4E
 CALL @FFILL ;MAKE TRAILER AFTER LAST SECTOR
 LDC 6499
 STL PCOUNT ;SAVE COUNT
 J @WTR ;WRITE THE TRACK

FFILL: LDL 1 ;GET BYTE
 LDL XBUFF+4 ;ADDRESS
 SB ;SAVE BYTE IN BUFFER
 LDL XBUFF+4
 ADC 1 ;INCREMENT BUFFER ADDRESS
 STL XBUFF+4
 LDL CCOUNT+4 ;COUNT THE BYTE
 ADC 1
 STL CCOUNT+4
 LDL 2 ;CHECK FOR ENOUGH
 ADC -1
 STL 2
 LDL 2
 EQC 0
 CJ @FFILL ;BRANCH IF NOT DONE
 RET

SBYTE: LDL 1 ;GET BYTE AGAIN
 LDL XBUFF+4 ;BUFFER ADDRESS
 SB
 LDL XBUFF+4
 ADC 1 ;INCREMENT BUFFER ADDRESS
 STL XBUFF+4
 LDL CCOUNT+4
 ADC 1 ;COUNT THE BYTE
 STL CCOUNT+4
 RET

; WRITE TRACK ROUTINE

; 5 buffer address
; 4 number of bytes
; 3 dummy
; 2 track number (track numbers start with 0)
; 1 0=bottom side 1=top side
; 0 device (0 <= N <= 3)

; EXIT AREG=0 ERROR AREG<>0 OK

 
#line 662
 .align
#line 662
???348
#line 662
 .dbnz 0X86,"TWRIT",0X80+'E'
#line 662
 .align
#line 662
 .dw ???347
#line 662
; 348
FWR: .DW FWR+BPW
WTRACK: CALL @FLOPSET ;SETUP REGISTERS
WTR: LDL PBUFF ;SET UP BUFFER POINTER
 STL CBUFF
 LDL PCOUNT ;NUMBER OF BYTES TO WRITE
 LDL CBUFF
 ADD
 STL CBUFFE ;SAVE END OF BUFFER
 CALL @SEEKNV ;POSITION TO CORRECT TRACK
 LDC CMWRTR ;WRITE TRACK COMMAND
 LDL Z1772+CMDREG
 SB ;START THE 1772

 LDTIMER ;WAIT FOR THREE REVS
 ADC REV3
 STL FDCTIME
 
#line 679
 LDC 32*20 ;WAIT 32 uSEC
#line 679
 SHL

WTBYTE: LDL Z1772+STAREG
 LB ;GET 1772 STATUS
 LDC 0X02 ;CHECK DRQ
 AND
 CJ @WTR04 ;BRANCH IF NOT READY FOR BYTE
 LDL CBUFF ;BUFFER ADDRESS FOR BYTE
 LB ;GET BYTE FROM BUFFER
 LDL Z1772
 ADC DATREG
 SB ;SET DATA BYTE INTO 1772
 LDL CBUFF
 ADC 1 ;POINT TO NEXT BUFFER LOCATION
 STL CBUFF
 LDL CBUFFE ;CHECK IF DONE
 LDL CBUFF
 DIFF
 EQC 0
 CJ @WTBYTE
 LDL Z1772+STAREG
 LB ;CHECK STATUS
 LDC 0x1C ;RNF & CRC & LOST DATA
 AND
 CJ @WTRK8 ;BRANCH IF NO ERROR
 J @WTRERR ;OR TRY AGAIN

WTR04: LDL Z1772+STAREG
 LB ;GET FLOPPY STATUS
 LDC 1 ;BUSY BIT
 AND
 EQC 1
 CJ @WTRK8
 LDTIMER ;CURRENT TIME
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT ;1 IF ENOUGH TIME
 CJ @WTBYTE

; !!PANIC!! THE OPERATION DID NOT FINISH
; THERE ARE NO GOOD REASONS THAT A TRACK WRITE DOES NOT COMPLETE

WTRERR: LDL RETCNT ;GET RETRY COUNT
 ADC -1 ;COUNT DOWN
 STL RETCNT
 LDL RETCNT
 LDC 0
 GT
 CJ @WTRK8 ;BRANCH IF TRIED ENOUGH

 
#line 730
 LDC CMRSET ;RESET COMMAND
#line 730
 LDL Z1772+CMDREG
#line 730
 SB
#line 730
 LDC 32*20 ;WAIT 32 uSEC
#line 730
 SHL
#line 730
 ;RESET 1772
 CALL @RESTOR ;HOME THE DISK
 J @WTR

WTRK8: LDL Z1772+STAREG
 LB ;GET FLOPPY STATUS
 LDC 0X44 ;LOST DATA AND WRITE PROTECT
 AND
 AJW FSCRATCH ;FIX THE STACK
 RET

; SEEK SEEK WITH VERIFY

; ENTER CALL @SEEK/@SEEKNV
; EXIT A=0 NO ERRORS

SEEK: LDC CMSEEK+4 ;SEEK + VERIFY COMMAND
 J @SEEKSH



; SEEKNV SEEK NO VERIFY

SEEKNV: LDC CMSEEK+4 ;SEEK COMMAND
SEEKSH: LDL CDRIVE+4 ;GET CURRENT DRIVE
 ADC DRVRATE
 LB ;NOW HAVE STEP RATE FOR DRIVE
 OR ;MERGE STEP RATE & COMMAND
 LDL CTRACK+4 ;GET DESIRED TRACK
 LDL CDRIVE+4 ;GET CURRENT DRIVE
 ADC DRVTRK ;TRACK POSITION TABLE
 SB ;SAVE FOR FUTURE
 LDL CTRACK+4 ;TRACK AGAIN
 LDL Z1772+4
 ADC DATREG ;POINT TO DATA REGISTER
 SB
 LDL Z1772+CMDREG+4
 SB ;COMMAND THE SEEK
 
#line 768
 LDC 32*20 ;WAIT 32 uSEC
#line 768
 SHL

 LDTIMER ;GET CURRENT TIME
 ADC REV3 ;NORMAL MAX WAIT
 LDL Z1772+STAREG+4 ;GET 1772 STATUS
 LB
 LDC 0X20 ;CHECK IF SPIN UP SEQUENCE
 AND
 CJ @SEEK02 ;BRANCH IF NOT SPIN UP
 LDC REV5 ;ALLOW MORE TIME
SEEK02: BSUB ;"ADD"
 STL FDCTIME+4

SEEK04: LDL Z1772+STAREG+4 ;CHECK FOR BUSY
 LB
 LDC 1 ;BUSY BIT
 AND
 CJ @SEEK06 ;BRANCH IF NOT SET
 LDTIMER ;GET CURRENT TIME
 LDL FDCTIME+4 ;TIMEOUT TIME
 DIFF
 LDC 0
 GT
 CJ @SEEK04 ;BRANCH IF NOT TOO LONG
 LDC 1 ;INDICATE ERROR
SEEK07: RET

SEEK06: LDL Z1772+STAREG+4
 LB
 LDC 0X10
 AND
 CJ @SEEK07
 LDC 1
 RET

; DISK RESTORE ROUTINE

; CALL @RESTORE
; EXIT B=0 IF AT TRACK ZERO


RESTOR: AJW 4 ;CLEAN UP STACK
 STL RESRET ;SAVE THE RETURN ADDRESS
 LDC 0
 LDC DRVTRK ;SET TABLE TO REMEMBER DRIVE WAS RESTORED
 LDL CDRIVE
 BSUB ;ADD
 SB ;TABLE NOW THINKS WE ARE RESTORED

 CALL @RESSUB ;DO A RESTORE
 CJ @RSTORZ ;BRANCH IF TRACK ZERO

 
#line 820
 LDC CMRSET ;RESET COMMAND
#line 820
 LDL Z1772+CMDREG
#line 820
 SB
#line 820
 LDC 32*20 ;WAIT 32 uSEC
#line 820
 SHL
#line 820
 ;RESET THE 1772
 LDC 7 ;STEP IN THIS MANY TIMES
 STL FDCTMP

RSTOR4: LDL CDRIVE ;GET CURRENT DRIVE
 ADC DRVRATE
 LB ;NOW HAVE STEP RATE FOR DRIVE
 LDC CMSTPN ;1772 STEP IN COMMAND
 OR ;MERGE STEP RATE & COMMAND
 LDL Z1772+CMDREG
 SB ;OUTPUT THE COMMAND

 LDTIMER
 ADC REV3 ;WAIT 3 REVS
 STL FDCTIME
 
#line 835
 LDC 32*20 ;WAIT 32 uSEC
#line 835
 SHL
RSTOR6: LDL Z1772+STAREG ;GET THE STATUS
 LB
 LDC 1 ;CHECK BUSY BIT
 AND
 CJ @RSTOR8 ;BRANCH IF NOT BUSY
 LDTIMER ;CHECK IF TOO LONG
 LDL FDCTIME ;ENDING TIME
 DIFF
 LDC 0
 GT
 CJ @RSTOR6
RSTOR8: LDL FDCTMP ;NUMBER OF STEPS
 ADC -1
 STL FDCTMP
 LDL FDCTMP
 EQC 0
 CJ @RSTOR4
 
#line 853
 LDC CMRSET ;RESET COMMAND
#line 853
 LDL Z1772+CMDREG
#line 853
 SB
#line 853
 LDC 32*20 ;WAIT 32 uSEC
#line 853
 SHL
#line 853
 ;HAMMER THE 1772
 CALL @RESSUB
RSTORZ: LDL RESRET
 GCALL

RESSUB: LDL CDRIVE+4 ;GET CURRENT DRIVE
 ADC DRVRATE
 LB ;NOW HAVE STEP RATE FOR DRIVE
 LDC CMRES ;1172 RESTORE COMMAND
 OR ;MERGE STEP RATE & COMMAND
 LDL Z1772+CMDREG+4
 SB ;OUTPUT THE COMMAND

 LDTIMER
 ADC REV5 ;WAIT LONG TIME
 STL FDCTIME+4
 
#line 869
 LDC 32*20 ;WAIT 32 uSEC
#line 869
 SHL
RSSUB2: LDL Z1772+STAREG+4 ;GET THE STATUS
 LB
 LDC 1 ;CHECK BUSY BIT
 AND
 CJ @RSSUB4 ;BRANCH IF NOT BUSY
 LDTIMER ;CHECK IF TOO LONG
 LDL FDCTIME+4 ;ENDING TIME
 DIFF
 LDC 0
 GT
 CJ @RSSUB2
 LDC 1 ;INDICATE ERROR
 RET

RSSUB4: LDL Z1772+STAREG+4
 LB
 LDC 0X04 ;TRACK ZERO STATUS
 AND
 EQC 0X00
 RET

; FLOPSET INTERNAL ROUTINE TO SETUP THE DRIVER

; THIS ROUTINE MOVES PARAMETERS TO LOCAL STORAGE

; IT MAY BE DESIRABLE TO CHANGE RETRY TO A PARAMETER


FLOPSET LDL 1 ;GET RETURN FOR BASE ROUTINE
 STL 4 ;IN CASE "GCALL" BASE ROUTINE
 AJW -FSETRET ;MAKE LOTS OF ROOM
 LDC WD1772 ;MAKE 1772 REFERENCES FAST
 STL Z1772

 LDL PCOUNT
 STL CCOUNT ;SAVE NUMBER OF SECTORS
 LDL PSECTR ;GET FIRST SECTOR & SAVE AS CURRENT
 STL CSECTR
 LDL PTRACK ;GET TRACK
 STL CTRACK
 LDL PSIDE ;AND SIDE
 STL CSIDE
 LDL PDRIVE ;AND DRIVE
 STL CDRIVE
 LDL PBUFF ;BUFFER POINTER
 STL XBUFF
 LDC RETRY
 STL RETCNT ;SET RETRY COUNT
 LDC RETRY
 ADC 1 ;CALCULATE MIDDLE ERROR
 LDC 1
 SHR
 STL MIDERR

; NOW SELECT DRIVE & SIDE

 LDC FDCSEL0 ;ADDRESS OF DRIVE ZERO
 STL FDCTMP

 LDC 0
 LDL FDCTMP ;GET DRIVE 0 ADDRESS AGAIN
 SB ;DESELECT DRIVE 0

 LDC 0
 LDL FDCTMP
 ADC 4 ;DESELECT DRIVE 1
 SB

 LDC 0
 LDL FDCTMP
 ADC 8 ;DESELECT DRIVE 2
 SB

 LDC 0
 LDL FDCTMP
 ADC 12 ;DESELECT DRIVE 3
 SB

 LDC 1 ;MASK TO SELECT DRIVE
 LDL CDRIVE ;GET DRIVE NUMBER
 LDC 2
 SHL ;DRIVE NUMBER TIMES 4
 LDL FDCTMP
 BSUB ;COMPUTE SELECT ADDRESS
 SB ;AND SELECT CORRECT DRIVE

 LDL CSIDE ;GET CURRENT SIDE
 EQC 0
 EQC 0 ;MAKE SURE ITS ZERO OR ONE
 LDL FDCTMP
 ADC FDCSIDE-FDCSEL0 ;POINT TO SIDE SELECT REGISTER
 SB ;AND SELECT SIDE

 LDC DRVTRK ;POINT TO TABLE OF CURRENT TRACKS
 LDL CDRIVE ;GET CURRENT DRIVE
 BSUB ;"ADD"
 LB ;GET CURRENT TRACK
 STL FDCTMP1
 LDL FDCTMP1
 LDC 0XFF
 DIFF ;CHECK IF KNOWN
 CJ @SEL12 ;BRANCH IF IT IS NOT
 LDL FDCTMP1 ;GET CURRENT TRACK AGAIN
 LDL Z1772
 ADC TRKREG ;POINT TO 1772 TRACK REGISTER
 SB ;AND SET CURRENT TRACK
 J @SEL16

SEL12: CALL @RESTOR

SEL16: LDL FSETRET ;GET RETURN ADDRESS
 GCALL ;AND RETURN TO IT

 .align

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DRVTRK: .DB -1,-1,-1,-1 ;CURRENT TRACK ON EACH DRIVE
; ;-1 INDICATES UNKNOWN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;THIS WORD MUST BE IN RAM;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DRVRATE .DB 3,3,3,3 ;STEP RATE CODE FOR EACH DRIVE
; ;0 6ms 12ms 2ms 3ms 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;THIS WORD SHOULD BE IN RAM;;;;;;;;;;;;;;;;;
; 5 INCH DRIVES WILL NOT STEP AT THE SAME RATE AS THE 3 INCH DRIVES ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; A POSSIBLE SOLUTION MIGHT BE THE PSA AREA. HOWEVER, IF MULTI PROGRAMMING
; THE FORTH KERNEL YOU HAVE TO MAKE SURE YOU CAN FIND THE CORRECT PSA. A
; SOLUTION TO THAT MIGHT BE TO HAVE ALL PSA'S POINT TO THE FIRST ONE.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#line 3868 "T4th6.tal"


 
#line 3870
 .align
#line 3870
???349
#line 3870
 .dbnz 0X89,"POWER.OF",'F'+0X80
#line 3870
 .align
#line 3870
 .dw ???348
#line 3870
; 349
PWROFF .DW PWROFF+BPW
power_off
 ldc 0x54000000
 stl 1

 ldc 0x0f
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x0a
 ldl 1
 sb

 ldc 0x02
 ldl 1
 sb

 ldc 0x05
 ldl 1
 sb

 ldc 0x0d
 ldl 1
 sb

 ldc 0x00
 ldl 1
 sb

pwroff1 j @pwroff1

 
#line 3950
 .align
#line 3950
???350
#line 3950
 .dbnz 0X85,"DTAB",'0'+0X80
#line 3950
 .align
#line 3950
 .dw ???349
#line 3950
; 350
#line 3950
 ; DTAB0
DTAB0: .DW DOVAR ;FAKE A FORTH VARIABLE
; .RAD50 /DK FORTH DAT/ ;FILE NAME
; .DW 0 ;0=OPEN 1=NOT OPEN
; .DW 0 ;EASY PLACE TO FIND CHANNEL NUMBER
; .DW 0,0,0,0 ;AREA FOR DSTATUS&LOOKUP
; .DW 0,0,0,512.,0 ;0 .READ/.WRITE REQUEST
 ;1 CHANNEL
 ;2-3 BLOCK
 ;4-5 BUFFER
 ;6-7 WORD COUNT
 ;8-9 0 TO INDICATE WITH WAIT

;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3965
 .align
#line 3965
???351
#line 3965
 .dbnz 0X85,"DTAB",'1'+0X80
#line 3965
 .align
#line 3965
 .dw ???350
#line 3965
; 351
#line 3965
 ; DTAB1
DTAB1: .DW DOVAR ;FAKE A FORTH VARIABLE
; .RAD50 /DK FORTH1DAT/ ;FILE NAME
; .DW 0 ;0=OPEN 1=NOT OPEN
; .DW 1 ;EASY PLACE TO FIND CHANNEL NUMBER
; .DW 0,0,0,0 ;AREA FOR DSTATUS&LOOKUP
; .DW 0,0,0,512.,0 ;0 .READ/.WRITE REQUEST
;
;;-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 
#line 3975
 .align
#line 3975
???352
#line 3975
 .dbnz 0X85,"DTAB",'2'+0X80
#line 3975
 .align
#line 3975
 .dw ???351
#line 3975
; 352
#line 3975
 ; DTAB2
DTAB2: .DW DOVAR ;FAKE A FORTH VARIABLE
; .RAD50 /DK FORTH2DAT/ ;FILE NAME
; .DW 0 ;0=OPEN 1=NOT OPEN
; .DW 2 ;EASY PLACE TO FIND CHANNEL NUMBER
; .DW 0,0,0,0 ;AREA FOR DSTATUS&LOOKUP
; .DW 0,0,0,512.,0 ;0 .READ/.WRITE REQUEST

;-+-
LSTSYM: ;******** LAST SYMBOL IN PROGRAM ****


 
#line 3987
 .align
#line 3987
???353
#line 3987
 .dbnz 0X85,"DTAB",'3'+0X80
#line 3987
 .align
#line 3987
 .dw ???352
#line 3987
; 353
#line 3987
 ; DTAB3
DTAB3: .DW DOVAR ;FAKE A FORTH VARIABLE
; .RAD50 /DK FORTH3DAT/ ;FILE NAME
; .DW 0 ;0=OPEN 1=NOT OPEN
; .DW 3 ;EASY PLACE TO FIND CHANNEL NUMBER
; .DW 0,0,0,0 ;AREA FOR DSTATUS&LOOKUP
; .DW 0,0,0,512.,0 ;0 .READ/.WRITE REQUEST


FREMEM: ;START OF DICTIONARY
